<?php
	ob_start();
	require './db_info.php';
	require './ajax-pg-query-where.php';
	require './session_info.php';
	ob_end_clean();
	
	$where = getWhereStatement();
	
	// connecting to the database
	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());

	// starting new session, in order to keep the same seed for random generator
	pg_query($conn, "begin");

	// setting the size of the sample and getting the number of total records, i.e., the total number of distinct feed samples
	if (isset($_POST["sample"]) && intval($_POST["sample"]) > 0){
		$number_of_sample_samples = intval($_POST["sample"]);
	}else $number_of_sample_samples = 150;
	$number_of_distinct_samples;
	if (isset($_POST["size"]) && intval($_POST["size"]) > 0){
		$number_of_distinct_samples = intval($_POST["size"]);
	}
	if (isset($number_of_distinct_samples)){
		if ($number_of_sample_samples > $number_of_distinct_samples) $number_of_sample_samples = $number_of_distinct_samples;
	}

	// reading nutrients names ordered by groups which will form columns
	// much faster query but can be emty columns
	$selected_nutrients  = $_POST["nt"];
        $select_nutrients = "";
	if (isset($selected_nutrients)&&strlen($selected_nutrients)>0){
                $select_nutrients .= "(select distinct z_abbreviation_de as abbreviation from d_nutrient ";
		$select_nutrients .= "where (nutrient_key in ($selected_nutrients)) ";
                $select_nutrients .= "order by abbreviation)";
	}
	// much slower query
	/*"select distinct z_abbreviation_de as abbreviation ".
			    "from d_feed, ".$_SESSION["data_source"].", d_nutrient, d_origin, d_time ".
			    "where ".$_SESSION["data_source"].".id_feed_fkey = d_feed.feed_key ".
			    "and ".$_SESSION["data_source"].".id_nutrient_fkey=d_nutrient.nutrient_key ".
			    "and ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
			    "and ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key $where".
			    " order by abbreviation";*/
        //DERIVED NUTRIENT:
        $selected_derived_nutrients  = $_POST["ntd"];
        $dnrows = 0;
        if (isset($selected_derived_nutrients)&&strlen($selected_derived_nutrients)>0){
                $select_derived_nutrients = "(select abbr as abbreviation from t_formula ";       
		$select_derived_nutrients .= "where (id in ($selected_derived_nutrients)) ";
                $select_derived_nutrients .= "order by abbreviation)";
                $dnresult = pg_query($conn, $select_derived_nutrients); if (!$dnresult) die('Invalid query: ' . pg_error());
                $dnrows   = pg_numrows($dnresult);
                if ($dnrows > 0){
                    if (isset($selected_nutrients)&&strlen($selected_nutrients)>0){
                        $select_nutrients .= " UNION ALL ";
                    }    
                $select_nutrients .= $select_derived_nutrients;
        }
	}
        
	$result = pg_query($conn, $select_nutrients); if (!$result) die('Invalid query: ' . pg_error());
	$rows   = pg_numrows($result);

	if ($rows > 0){
		// for each nutrient it columns id
		$column_ids;
		// values for each column of a single row
		$column_values;
		// raw values for each column of a single row
		$column_raw_values;

		// printing nutrients names
		for ($i = 0; $i < $rows; $i++){
			$row                    = pg_fetch_array($result, $i);
			$column_ids[$row['abbreviation']] = $i;
			$column_values[$i]      = '';
			$column_raw_values[$i]  = 0;
		}


		// setting the seed for random number generator
		pg_query($conn, "select setseed(0.123)");

		// creating subquery to retrieve uniform samples of lims samples which satisfy the query condition
		$select_data_subquery = "SELECT * FROM (SELECT distinct lims_number ".
                                    	"FROM d_feed, ".$_SESSION["data_source"].", d_nutrient, d_origin, d_time ".
                                    	"WHERE ".$_SESSION["data_source"].".id_feed_fkey = d_feed.feed_key ".
                                    	"and ".$_SESSION["data_source"].".id_nutrient_fkey=d_nutrient.nutrient_key ".
                                    	"and ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
                                    	"and ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key ";
				     	if ($_SESSION["data_source"] == "fact_table") $select_data_subquery .=  "and d_m_b<> true ";
					$select_data_subquery .= $where.") as all_lims ORDER BY RANDOM() LIMIT ".$number_of_sample_samples;
		
		// reading the data
                $select_data = "SELECT abbreviation, day, avg(quantity) as avg_quantity FROM (";
		if (isset($selected_nutrients)&&strlen($selected_nutrients)>0) {
		$select_data .= "(SELECT z_abbreviation_de as abbreviation, (CASE WHEN t_day IS NULL THEN to_date(t_year||'-01-01', 'YYYY-MM-DD') ELSE t_day END) AS day, quantity ".
         		"FROM d_feed, ".$_SESSION["data_source"].", d_nutrient, d_origin, d_time ".
			"WHERE ".$_SESSION["data_source"].".id_feed_fkey = d_feed.feed_key ".
			"AND ".$_SESSION["data_source"].".id_nutrient_fkey=d_nutrient.nutrient_key ".
			"AND ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
			"AND ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key ";
                        if ($_SESSION["data_source"] == "fact_table") $select_data .= "and d_m_b <> true ";
			$select_data .= "and lims_number in (".$select_data_subquery.") ";
                        $select_data .= $where.")";      		
                }
                
                //DERIVED NUTRIENT: 
                if($dnrows > 0){
                    $dnquery =  "SELECT d_feed.name_de, id_feed_fkey, (CASE WHEN canton IS NULL THEN ''Not Available'' ELSE canton END) AS canton, max(CASE WHEN t_day IS NULL THEN to_date(t_year||''-01-01'', ''YYYY-MM-DD'') ELSE t_day END) AS t_day, lims_number, avg(quantity) as quantity ".
                                "FROM d_feed, ".$_SESSION["data_source"].", d_nutrient, d_origin, d_time ".
                                "WHERE ".$_SESSION["data_source"].".id_feed_fkey = d_feed.feed_key ".
                                "AND ".$_SESSION["data_source"].".id_nutrient_fkey = d_nutrient.nutrient_key ".
                                "AND ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
                                "AND ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key ";
                                if ($_SESSION["data_source"] == "fact_table") $dnquery .= "AND d_m_b <> true ";
                                $dnquery .= getDNWhereStatement();

                    for ($d = 0; $d < $dnrows; $d++) {
                        if ((isset($selected_nutrients)&&strlen($selected_nutrients)>0)||($d>0)) {
                            $select_data .= " UNION ";
                        }
                        $abbr = pg_fetch_array($dnresult, $d);
                        $select_data .= "(SELECT k as abbreviation, t as day, m as quantity " .
                                        "FROM nnjx('".$dnquery."', '".$abbr['abbreviation']."'))";
                    }
                }
                
                $select_data .= ") as n GROUP BY abbreviation, day ORDER BY day, abbreviation";
//                error_log($select_data);
		$fresult = pg_query($conn, $select_data); if (!$fresult) die('Invalid query: ' . pg_error());
		$frows   = pg_numrows($fresult);

		echo '{"rows":[';

		//printing the data
		if ($frows > 0){
			$row_counter = 0;
			$current_date;
			$current_date_trn;

			for ($i = 0; $i < $frows; $i++){
				$row  = pg_fetch_array($fresult, $i);

				if (isset($current_date_trn) && $current_date_trn != $row['day']){ // outputing one row
					if ($row_counter > 0) echo ',{"c":[{"v":'.$current_date.'}';
					else echo '{"c":[{"v":'.$current_date.'}';
				
					for ($j = 0; $j < $rows; $j++){
						echo ',{"v":'.floatval($column_raw_values[$j]).', "f":'.json_encode($column_values[$j]).'}';
						$column_values[$j]     = '';
                        			$column_raw_values[$j] = 0;
					}					
					echo ']}';

					$current_date_trn = $row['day'];
					if (isset($row['day'])){
						$current_date = $row['day'];
						$time = strtotime($current_date);
						$current_date = json_encode('Date('.date("Y",$time).','.date("n",$time).','.date("j",$time).')');
					}else {
						$current_date = json_encode('null');
					}
					$row_counter++;
				}

				if (!isset($current_date_trn)){
					$current_date_trn = $row['day'];
					if (isset($row['day'])){
						$current_date = $row['day'];						
						$time = strtotime($current_date);
						$current_date = json_encode('Date('.date("Y",$time).','.date("n",$time).','.date("j",$time).')');
					}else {
						$current_date = json_encode('null');
					}
				}
				
               			$_column_id = $column_ids[$row['abbreviation']];
				$column_values[$_column_id]     .= number_format(floatval($row['avg_quantity']),3);
                		$column_raw_values[$_column_id] .= $row['avg_quantity'];
			}

			// outputing the last row
			if ($row_counter > 0) echo ',{"c":[{"v":'.$current_date.'}';
			else echo '{"c":[{"v":'.$current_date.'}';
				
			for ($j = 0; $j < $rows; $j++){
				echo ',{"v":'.floatval($column_raw_values[$j]).', "f":'.json_encode($column_values[$j]).'}';
				$column_values[$j]     = '';
                        	$column_raw_values[$j] = 0;
			}					
			echo ']}';
		}

		// printing header of the table
	        echo '],"cols":[{"id":"date","label":"Date","type":"date"}';
        	for ($i = 0; $i < $rows; $i++){
			$row  = pg_fetch_array($result, $i);
			$abbr = "";
			if (isset($row['abbreviation'])) $abbr = $row['abbreviation'];
			else $abbr = 'n/a';
			
			echo ',{"id":"nutrient", "label":'.json_encode($abbr).', "type":"number"}';
		}
	        echo ']}';
	}

	// closing session
	pg_query($conn, "end");

	// closing connection
	pg_close($conn);

	exit;
?>
