<?php
	class QueryConditions{
		var $sel_classified_feeds;
		var $sel_unclassified_feeds;
		var $sel_agridea_feeds;
		var $sel_nutrients;
		var $sel_der_nutrients;
		var $sel_cantons;
		var $sel_altitude;
		var $sel_year;
		var $sel_season;
		var $sel_radius;
		var $data_type;
		var $sel_fresh;
		var $show_density;
		var $show_flags;
		var $show_regression;
		var $regr_nutrient;
		var $charts_na;
		var $charts_nb;
		var $charts_nc;
		var $stats_sel;
		var $sample_size;
		var $comp_par;
		
		// $conn_ - connection to the database
		function QueryConditions($conn_){			
			$qid = $_POST["qid"];
			if (!isset($qid) || $qid==="") $qid = $_GET["qid"];

			if (isset($qid) && !($qid==="")){// getting query parameters from a saved query
				$result_selection = pg_query($conn_, "select classified_feeds, unclassified_feeds, agridea_feeds, nutrients, derived_nutrients, cantons, altitude, selected_year, selected_season, selected_radius, data_type, fresh_matter, show_density, show_flags, show_regression, regression_nutrient, charts_na, charts_nb, charts_nc, stats_sel, sample_size, comparison from queries where id=".$qid);
				if ($result_selection){
					$row                          = pg_fetch_array($result_selection, 0);
					$this->sel_classified_feeds   = $row['classified_feeds'];
					$this->sel_unclassified_feeds = $row['unclassified_feeds'];
					$this->sel_agridea_feeds      = $row['agridea_feeds'];
					$this->sel_nutrients          = $row['nutrients'];
					$this->sel_der_nutrients      = $row['derived_nutrients'];
					$this->sel_cantons            = $row['cantons'];
					$this->sel_altitude           = $row['altitude'];
					$this->sel_year               = $row['selected_year'];
					$this->sel_season             = $row['selected_season'];
					$this->sel_radius             = $row['selected_radius'];
					$this->data_type              = $row['data_type'];
					$this->sel_fresh              = $row['fresh_matter'];
					$this->show_density           = $row['show_density'];
					$this->show_flags             = $row['show_flags'];
					$this->show_regression        = $row['show_regression'];
					$this->regr_nutrient          = $row['regression_nutrient'];
					$this->charts_na              = $row['charts_na'];
					$this->charts_nb              = $row['charts_nb'];
					$this->charts_nc              = $row['charts_nc'];
					$this->stats_sel              = $row['stats_sel'];
					$this->sample_size            = $row['sample_size'];
					$this->comp_par               = $row['comparison'];
				}
			}else {// getting query parameters from the url parametes
				$this->sel_classified_feeds   = $_POST["cf"];
				$this->sel_unclassified_feeds = $_POST["uf"];
				$this->sel_agridea_feeds      = $_POST["af"];
				$this->sel_nutrients          = $_POST["nt"];
				$this->sel_der_nutrients      = $_POST["ntd"];
				$this->sel_cantons            = $_POST["ct"];
				$this->sel_altitude           = $_POST["al"];
				$this->sel_year               = $_POST["yeh"];
				$this->sel_season             = $_POST["seh"];
				$this->sel_radius             = $_POST["rs"];
				$this->data_type              = $_POST["dt"];
				$this->sel_fresh              = $_POST["fresh"];
				$this->show_density           = $_POST['dens'];
				$this->show_flags             = $_POST['flag'];
				$this->show_regression        = $_POST['regr'];
				$this->regr_nutrient          = $_POST['rnut'];
				$this->charts_na              = $_POST['charts_na'];
				$this->charts_nb              = $_POST['charts_nb'];
				$this->charts_nc              = $_POST['charts_nc'];
				$this->stats_sel              = $_POST['stats_sel'];
			}
		}

		function getWhereStatement(){
			// creating where statement
			$search_feeds = FALSE;
			$where        = "";

			if(isset($this->sel_unclassified_feeds)&&strlen($this->sel_unclassified_feeds)>0){
				if ($search_feeds) $where .= " or id_feed_fkey in (".$this->sel_unclassified_feeds.")";
				else {
					$where .= " and (id_feed_fkey in (".$this->sel_unclassified_feeds.")";
					$search_feeds = TRUE;
				}
			}

			if(isset($this->sel_agridea_feeds)&&strlen($this->sel_agridea_feeds)>0){
				if ($search_feeds) $where .= " or id_feed_fkey in (".$this->sel_agridea_feeds.")";
				else {
					$where .= " and (id_feed_fkey in (".$this->sel_agridea_feeds.")";
					$search_feeds = TRUE;
				}
			}

			if(isset($this->sel_classified_feeds)&&strlen($this->sel_classified_feeds)>0){
				if ($search_feeds) $where .= " or id_feed_fkey in (".$this->sel_classified_feeds.")";
				else {
					$where .= " and (id_feed_fkey in (".$this->sel_classified_feeds.")";
					$search_feeds = TRUE;
				}
			}

			if ($search_feeds) $where .= ")";

			if(isset($this->sel_nutrients)&&strlen($this->sel_nutrients)>0){
				$where .= " and (id_nutrient_fkey in (".$this->sel_nutrients."))";
			}

			if(isset($this->sel_cantons)&&strlen($this->sel_cantons)>0){
				$sel_cantons_ = str_replace(",", "'dd'", $this->sel_cantons);
				$sel_cantons_ = "'".str_replace("'dd'", "','", $sel_cantons_)."'";
				if (substr_count($sel_cantons_, "'n/a'") > 0){
					$where .= " and (d_origin.canton in ($sel_cantons_) or d_origin.canton is null)";
				}else{
					$where .= " and (d_origin.canton in ($sel_cantons_))";
				}
			}

			if(isset($this->sel_altitude)&&strlen($this->sel_altitude)>0){
				$sel_altitude_ = str_replace(",", "'dd'", $this->sel_altitude);
				$sel_altitude_ = "'".str_replace("'dd'", "','", $sel_altitude_)."'";
				if (substr_count($sel_altitude_, "'n/a'") > 0){
					$where .= " and (d_origin.altitude_class in ($sel_altitude_) or d_origin.altitude_class is null)";
				}else{
					$where .= " and (d_origin.altitude_class in ($sel_altitude_))";
				}
			}

			if(isset($this->sel_year)&&strlen($this->sel_year)>0){
				$sel_year_ = str_replace(",", "'dd'", $this->sel_year);
				$sel_year_ = "'".str_replace("'dd'", "','", $sel_year_)."'";
				if (substr_count($sel_year_, "'n/a'") > 0){
					$where .= " and ((d_time.moment = 1 or d_time.moment = 2) and (d_time.t_year in ($sel_year_) or d_time.t_year is null))";
				}else{
					$where .= " and ((d_time.moment = 1 or d_time.moment = 2) and d_time.t_year in ($sel_year_))";
				}
			}

			if(isset($this->sel_season)&&strlen($this->sel_season)>0){
				$sel_season_ = str_replace(",", "'dd'", $this->sel_season);
				$sel_season_ = "'".str_replace("'dd'", "','", $sel_season_)."'";
				if (substr_count($sel_season_, "'n/a'") > 0){
					$where .= " and ((d_time.moment = 1 or d_time.moment = 2) and (d_time.season_de in ($sel_season_) or d_time.season_de is null))";
				}else{
					$where .= " and ((d_time.moment = 1 or d_time.moment = 2) and d_time.season_de in ($sel_season_))";
				}
			}		

 			if(isset($this->sel_radius)&&strlen($this->sel_radius)>0){
	 			$second = explode(',',$this->sel_radius);
	 			if(sizeof($second) == 3) {
 					if(is_numeric($second[0]) && is_numeric($second[1]) && is_numeric($second[2])) {
 						$where .= " and (d_origin.origin_key in (select * from getsamplesinradiusouterinnerboundingbox2(".$second[0].",".$second[1].",".$second[2].")))";
 					} 
 				} 
 			} 

			return $where;
		}
	}
?>
