<?php
	require './db_info.php';
	require './session_info.php';
	require './ajax-pg-query-where.php';

	//  Connection to PostgreSQL-DB
	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());
	
	// retrieving the the where statement
	$query_cond = new QueryConditions($conn);
	$where = $query_cond->getWhereStatement();
	$nutrient_par = explode("-", $_POST["nutrient"]);
	$nutrient     = $nutrient_par[0];
	$nutrient_ana = $nutrient_par[1];

	// creating queries
	$query_one = "select tmp.latitude as latitude, tmp.longitude as longitude, count(*) as count, avg(tmp.quantity) as quantity from (select avg(quantity) as quantity, lims_number, latitude, longitude ".
			"from d_feed, ".$_SESSION["data_source"].", d_nutrient, d_origin, d_time ".
			"where ".$_SESSION["data_source"].".id_feed_fkey = d_feed.feed_key ".
			"and ".$_SESSION["data_source"].".id_nutrient_fkey=d_nutrient.nutrient_key ".
			"and ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
			"and ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key ";
			if ($_SESSION["data_source"] == "fact_table") $query_one = $query_one. "and d_m_b<> true ";
			$query_one = $query_one."and latitude is not null and longitude is not null and canton is not null $where";
			if ($nutrient != "") $query_one .= " and d_nutrient.nutrient_key in ('$nutrient')";		
			if (isset($nutrient_ana)&&$nutrient_ana != "") $query_one .= " and ".$_SESSION["data_source"].".id_nutrient_analyses_fkey in ('$nutrient_ana')";		
			$query_one .= " group by lims_number, latitude, longitude ".
				") as tmp group by tmp.latitude, tmp.longitude";

	// Start XML file, create parent node
	$dom = new DOMDocument("1.0", "UTF-8");
	$node = $dom->createElement("data");
	$parnode = $dom->appendChild($node);

	$result = pg_query($conn, $query_one);
	$numrows = pg_numrows($result);

	if (!$result) {
		echo "Error: query wasn't successful (no result)";
		die();
		$numrows = 0;
	}

	header('Content-type: text/xml');
	
	$maxx = null; $maxy = null; $minx = null; $miny = null;
	$maxpixel = 160;
	$n = 0;
	$data = array();
	
	function bound($value, $opt_min, $opt_max) {
        if ($opt_min != null) $value = max($value, $opt_min);
        if ($opt_max != null) $value = min($value, $opt_max);
        return $value;
    }

    $TILE_SIZE = 1024;
    $origin = array('x' => $TILE_SIZE / 2, 'y' => $TILE_SIZE / 2);
    $pixelsPerLonDegree = $TILE_SIZE / 360;
    $pixelsPerLonRadian = $TILE_SIZE / (2*pi());
    
    function fromLatLngToPoint($lat, $lng)
    {
    	global $origin; 
    	global $pixelsPerLonDegree; 
    	global $pixelsPerLonRadian;
      	$x = $origin['x'] + $lng * $pixelsPerLonDegree;
      	$siny = bound(sin(deg2rad($lat)), -0.9999, 0.9999);
      	$y = $origin['y'] + 0.5 * log((1+$siny)/(1-$siny)) * -$pixelsPerLonRadian;
      	return array('x' => $x, 'y' => $y);
    }
    
    function fromPointToLatLng ($x, $y ) 
    {
    	global $origin; 
    	global $pixelsPerLonDegree; 
    	global $pixelsPerLonRadian;
        $lng = ($x - $origin['x']) / $pixelsPerLonDegree;
        $latRadians = ($y - $origin['y']) / -$pixelsPerLonRadian;
        $lat = rad2deg(2 * atan(exp($latRadians)) - pi() / 2);
        return array('lat' => $lat, 'lng' => $lng);
    }

	for($ri = 0; $ri < $numrows; $ri++) {
		$row = pg_fetch_array($result, $ri);
		
		$point = fromLatLngToPoint($row['latitude'], $row['longitude']);
		$point['count'] = $row['count'];
		$point['quantity'] = $row['quantity'];
		$n += $row['count'];
		array_push($data, $point);
		if ($maxx == null) {
			$miny = $point; $minx = $point; $maxy = $point; $maxx = $point;
		} else {
			if ($point['y'] < $miny['y'])
				$miny = $point;
			else if ($point['y'] > $maxy['y'])
				$maxy = $point;
			if ($point['x'] < $minx['x'])
				$minx = $point;
		   	else if ($point['x'] > $maxx['x'])
		   		$maxx = $point;
		}
		$node = $dom->createElement('test');
		$newnode = $parnode->appendChild($node);
		$newnode->setAttribute("lng", $row["longitude"]);
		$newnode->setAttribute("lat", $row["latitude"]);
		$newnode->setAttribute("count", $row["count"]);
		$newnode->setAttribute("quantity", $row["quantity"]);

	}
	
	
	pg_close($conn);
	
	
	
	$width = 0; $height = 0; $xweight = 0; $yweight = 0; $xqweight = 0; $yqweight = 0;
	if ($maxx['x'] - $minx['x'] > $maxy['y'] - $miny['y'] )
	{
		$width = $maxpixel;
		$height = floor($maxpixel/($maxx['x']-$minx['x'])*($maxy['y']-$miny['y']));
	} else {
		$width = floor($maxpixel/($maxy['y']-$miny['y'])*($maxx['x']-$minx['x']));
		$height = $maxpixel;
	}
	
	for ($i = 0; $i < count($data); $i++)
    {
		$data[$i]['x'] = ($data[$i]['x'] - $minx['x']) / ($maxx['x']-$minx['x']) * ($width);
		$data[$i]['y'] = ($data[$i]['y'] - $miny['y']) / ($maxy['y']-$miny['y']) * ($height);
		
		$xweight += ($data[$i]['x'] * $data[$i]['count']);
		$yweight += ($data[$i]['y'] * $data[$i]['count']);
		$xqweight += (pow($data[$i]['x'], 2) * $data[$i]['count']);
		$yqweight += (pow($data[$i]['y'], 2) * $data[$i]['count']);
    }
	$sx = ($xqweight - ($xweight * $xweight / $n)) / ($n-1);
	$sy = ($yqweight - ($yweight * $yweight / $n)) / ($n-1);
	$sigma = sqrt( ($sx + $sy) /2);

	$hopt =  $sigma* 1.77 * pow($n, -1/6);
	$hoptt = $hopt / $width * ($maxx['x']-$minx['x']);
	
	$p = fromPointToLatLng($minx['x']-$hoptt, $maxy['y']+$hoptt);
	$node = $dom->createElement('sw');
	$newnode = $parnode->appendChild($node);
	$newnode->setAttribute("lng", $p["lng"]);
	$newnode->setAttribute("lat", $p["lat"]);
	
	
	$p = fromPointToLatLng($maxx['x']+$hoptt, $miny['y']-$hoptt);
	$node = $dom->createElement('ne');
	$newnode = $parnode->appendChild($node);
	$newnode->setAttribute("lng", $p["lng"]);
	$newnode->setAttribute("lat", $p["lat"]);
	
	
	$width += ceil(2*$hopt);
	$height += ceil(2*$hopt);
	
	$node = $dom->createElement('grid');
	$newnode = $parnode->appendChild($node);
	$newnode->setAttribute("width", $width);
	$newnode->setAttribute("height", $height);
	
	$max = 0;
	$min = 0;
	$densitiesNom = array_fill(0, $height, array_fill(0, $width, 0));
	$densitiesDenom = array_fill(0, $height, array_fill(0, $width, 0));
	
	for ($p = 0; $p < count($data); $p++)
	{
		$point = $data[$p];
		$point['x'] += $hopt;
		$point['y'] += $hopt;
		
		for ($i = floor($point['y'] - $hopt); $i <= $height && $i <= $point['y'] + $hopt; $i++)
		{
			for ($j = floor($point['x'] - $hopt); $j <= $width && $j <= $point['x'] + $hopt; $j++)
			{
				if ($i > 0 && $j> 0)
				{
					$x = ($point['x']-$j)/$hopt;
					$y = ($point['y']-$i)/$hopt;
					$t = $x*$x + $y*$y;
					if ($t <= 1)
					{
						$value = (2 / pi() * ( 1 - $t)); // * $point['count'];
						$densitiesNom[$i-1][$j-1] += $value * $point['quantity'];
						$densitiesDenom[$i-1][$j-1] += $value;
					}
				}
			}
		}
	}
	
	$values = $dom->createElement('values');
	$newnode = $parnode->appendChild($values);
	
	for ($i = 0; $i < count($densitiesNom); $i++)
	{
		$densities = array_fill(0, $width, 0);
		for ($j = 0; $j < count($densitiesNom[$i]); $j++)
		{
			if ($densitiesNom[$i][$j] != 0)
			{
				$densities[$j] = $densitiesNom[$i][$j] / $densitiesDenom[$i][$j];
				if ($densities[$j] > $max)
					$max = $densities[$j];
				if ($densities[$j] < $min or $min == 0)
					$min = $densities[$j];
			}
		}
		$row = $dom->createElement('row');
		$newnode = $values->appendChild($row);
		$newnode->setAttribute("values", implode(";", $densities));
	}
	
	$values->setAttribute("max", $max);
	$values->setAttribute("min", $min);
	$values->setAttribute("n", $n);
	
	
	unset($data);
	

	echo $dom->saveXML();
?>
