<?php
	ob_start();
	require './db_info.php';
	require './ajax-pg-query-where.php';
	require './session_info.php';
	ob_end_clean();

	// getNumberOfDistinctSamples ***************************************************************
	// returns the number of distict feed samples which satisfy the user query
	// $_conn - connection to the database
	// $_where - query conditions	
	function getNumberOfDistinctSamples($_conn, $_where){
		$_select_samples_number = "SELECT count(distinct id_sample_fkey) ".
                                    	"FROM ".$_SESSION["data_source"].", d_origin, d_time ".
                                    	"WHERE ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
                                    	"and ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key ";
		if ($_SESSION["data_source"] == "fact_table") $_select_samples_number .=  "and d_m_b<> true ";
		$_select_samples_number .= $_where;
		$_select_samples_number_res = pg_query($_conn, $_select_samples_number); if (!$_select_samples_number_res) die('Invalid query: ' . pg_error());
		$_row  = pg_fetch_array($_select_samples_number_res, 0);
		return $_row[0];
	}
	//*******************************************************************************************

	// connecting to the database
	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());

	// retrieving the the where statement
	$query_cond = new QueryConditions($conn);
	$where = $query_cond->getWhereStatement();

	// printing the number of distinct samples
	echo "".getNumberOfDistinctSamples($conn, $where);
	//echo "1000";
	
	// closing connection
	pg_close($conn);
	
	exit;
?>
