<?php
	require './db_info.php';
	require './session_info.php';
	require './ajax-pg-query-where.php';

	//  Connection to PostgreSQL-DB
	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());	

	$query_cond = new QueryConditions($conn);
	$where = $query_cond->getWhereStatement();
	
	$udr_origin_key = $_POST["udr_origin_key"];
	$udr_latitude = $_POST["udr_latitude"];
	$udr_longitude = $_POST["udr_longitude"];
	$udr_radius = floatval($_POST["udr_radius"]);
	$ud_nutrient_key = $_POST["ud_nutrient_key"];
	$ud_ordering = $_POST["ud_ordering"];
	$ud_limit = $_POST["ud_limit"];
	$udr_radius_twice = floatval($udr_radius * 2);
	
	
	/* aggregated data view */
	
	$q_aggregated_data_replace = "CREATE OR REPLACE VIEW aggregated_data AS ";
	$q_aggregated_data_select = "SELECT nutrient_key, origin_key, avg(quantity) AS aggregated_quantity ";
	$q_aggregated_data_from = "FROM d_feed, ".$_SESSION["data_source"].", d_nutrient, d_origin, d_time ";
	$q_aggregated_data_where = "WHERE ".$_SESSION["data_source"].".id_feed_fkey = d_feed.feed_key ".
			"and ".$_SESSION["data_source"].".id_nutrient_fkey=d_nutrient.nutrient_key ".
			"and ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
			"and ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key".
			$where." AND nutrient_key=".$ud_nutrient_key." ";
	$q_aggregated_data_group_by = "GROUP BY lims_number, nutrient_key, origin_key";
	
	$q_aggregated_data = $q_aggregated_data_replace.$q_aggregated_data_select.$q_aggregated_data_from.$q_aggregated_data_where.$q_aggregated_data_group_by;
	
	
	/* region view */
	
	$q_region_replace = "CREATE OR REPLACE VIEW region AS ";
	$q_region_select = "SELECT origin_key, get_neighbours(latitude, longitude,".$udr_radius.") AS neighbour ";
	$q_region_from = "FROM d_origin";
	
	$q_region = $q_region_replace.$q_region_select.$q_region_from;
	
	
	/* region summary data view */
	
	$q_region_summary_data_replace = "CREATE OR REPLACE VIEW region_summary_data AS ";
	$q_region_summary_data_select = "SELECT region.origin_key, nutrient_key, count(aggregated_quantity), avg(aggregated_quantity), variance(aggregated_quantity), shapiro_wilk(aggregated_quantity) ";
	$q_region_summary_data_from = "FROM	region INNER JOIN aggregated_data ON region.neighbour = aggregated_data.origin_key ";
	$q_region_summary_data_where = "WHERE region.origin_key NOT IN (SELECT * FROM get_neighbours( ".$udr_latitude.", ".$udr_longitude.", ".$udr_radius_twice.")) OR region.origin_key = ".$udr_origin_key." ";
	$q_region_summary_data_group_by = "GROUP BY	region.origin_key, nutrient_key";
	
	$q_region_summary_data = $q_region_summary_data_replace.$q_region_summary_data_select.$q_region_summary_data_from.$q_region_summary_data_where.$q_region_summary_data_group_by;
	
	
	/* top k similar region view */
	
	//$q_top_k_similar_regions_replace = "CREATE OR REPLACE VIEW top_k_similar_regions AS ";
	$q_top_k_similar_regions_select = "SELECT neighbours.origin_key, neighbours.nutrient_key, get_similarity_probability(neighbours.count, neighbours.avg, neighbours.variance, selected_region.count, selected_region.avg, selected_region.variance) AS similarity_probability, postal_code, city, canton, country, latitude, longitude, altitude_class ";
	$q_top_k_similar_regions_from = "FROM region_summary_data AS selected_region INNER JOIN region_summary_data AS neighbours ON selected_region.nutrient_key = neighbours.nutrient_key INNER JOIN d_origin ON neighbours.origin_key = d_origin.origin_key ";
	// the commented below considers shapiro wilk test
	$q_top_k_similar_regions_where = "WHERE	selected_region.origin_key = ".$udr_origin_key." AND neighbours.origin_key <> ".$udr_origin_key." AND selected_region.shapiro_wilk >= 0 AND neighbours.shapiro_wilk >= 0 ";
	$q_top_k_similar_regions_order_by = "ORDER BY similarity_probability ".$ud_ordering." LIMIT ".$ud_limit;
	
	$q_top_k_similar_regions = $q_top_k_similar_regions_select.$q_top_k_similar_regions_from.$q_top_k_similar_regions_where.$q_top_k_similar_regions_order_by;
	
	
	$intermediate_result = pg_query($conn, $q_aggregated_data); if (!$intermediate_result) die('Invalid query: ' . pg_error());
	$intermediate_result = pg_query($conn, $q_region); if (!$intermediate_result) die('Invalid query: ' . pg_error());
	$intermediate_result = pg_query($conn, $q_region_summary_data); if (!$intermediate_result) die('Invalid query: ' . pg_error());
	//error_log($q_region_summary_data);
	$result = pg_query($conn, $q_top_k_similar_regions); if (!$result) die('Invalid query: ' . pg_error());
	$rows   = pg_numrows($result);
	
	if ($rows > 0){
		// outputing header
		echo '{"cols":[{"id":"postal_code", "label":'.json_encode($_terms["comp_postal_code"]).', "type":"number"},{"id":"city","label":'.json_encode($_terms["comp_city"]).',"type":"string"},{"id":"canton","label":'.json_encode($_terms["canton"]).',"type":"string"},{"id":"latitude", "label":"Latitude", "type":"number"},{"id":"longitude","label":"Longitude","type":"number"}, {"id":"similarity_probability", "label":'.json_encode($_terms["comp_simprobability"]).', "type":"number"}, {"id":"altitude", "label":'.json_encode($_terms["altitude"]).', "type":"string"}],"rows":[';
	
		// outputing data
		for ($i = 0; $i < $rows; $i++){
			$row  = pg_fetch_array($result, $i);
	
			if ($i != 0) echo ",";
			echo '{"c":[{"v":'.number_format(floatval($row[3]),0,"","").', "f":'.json_encode($row[3]).'},{"v":'.json_encode($row[4]).'},{"v":'.json_encode($row[5]).'},{"v":'.number_format(floatval($row[7]),8,".","").', "f":'.json_encode(number_format(floatval($row[7]),8)).'},{"v":'.number_format(floatval($row[8]),8,".","").', "f":'.json_encode(number_format(floatval($row[8]),8)).'},{"v":'.number_format(floatval($row[2]),6,".","").', "f":'.json_encode(number_format(floatval($row[2]),5)).'},{"v":'.json_encode($row[9]).'}]}';
		}
		echo ']}';
	}
	
	// closing connection
	pg_close($conn);
?>
	
