<?php
	ob_start();
	require './db_info.php';
	require './ajax-pg-query-where.php';
	require './session_info.php';
	ob_end_clean();

	class FeedSample{
		public $nutrient_number = 0;             // the number of nutrients
		public $nutrient_column_ids;             // for each nutrient in german its columns id in the output result
		public $nutrient_measurements;           // measurements of nutrients indexed by column id
		public $nutrient_measurements_detailed;  // measurements of nutrients indexed by column id as they are returned by the SQL
		public $nutrient_abbreviations;          // nutrient abbreviations+unities in the session language indexed by column id
		public $nutrient_ids;                    // the ids of the nutrients indexed by column id
		public $row_offset = 0;                  // the current row of the query result

		public $dnutrient_number = 0;             // the number of derived nutrients 
		public $dnutrient_column_ids;             // for each derived nutrient in german its columns id in the output result
		public $dnutrient_measurements;           // measurements of derived nutrients indexed by column id
		public $dnutrient_measurements_detailed;  // measurements of derived nutrients indexed by column id as they are returned by the SQL
		public $dnutrient_abbreviations;          // derived nutrient abbreviations+unities in the session language indexed by column id
		public $dnutrient_ids;                    // the ids of the derived nutrients indexed by column id
		
		public $sample_name = 'Not Available';		
		public $latitude = 'null';
		public $longitude = 'null';
		public $canton;
		public $postal_code = 'NA';
		public $feedname;
		public $feedkey;
		public $date;
		public $sdate;
		public $location_id = -1;
		public $c_location_id = -1;
		public $c_latitude = 'null';
		public $c_longitude = 'null';
		public $c_origin_key = -1;

		// $_conn - connection to the database
		function FeedSample($_conn, $_query_cond, $_where){
			// reading nutrients names ordered by groups which will form columns
			// much faster query but can be emty columns
			$selected_nutrients  = $_query_cond->sel_nutrients;
        		$select_nutrients    = "";

		        if (isset($selected_nutrients)&&strlen($selected_nutrients)>0){				
				$select_nutrients = "select distinct id_nutrient_fkey as id, id_nutrient_analyses_fkey as an_id, ".
					"d_nutrient.abbreviation_de as abbreviation, ".
					"d_nutrient.abbreviation_".$_SESSION["lng"]." as header_abbreviation, ".
					"d_nutrient.unit_measure_".$_SESSION["lng"]." as unit, ".
					"d_nutrient_analyses.name_de as an_name, ".
					"d_nutrient_analyses.name_".$_SESSION["lng"]." as an_header_name ".
                                    	"from ".$_SESSION["data_source"].", d_time, d_origin, d_nutrient, d_nutrient_analyses ".
                                    	"where ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
                                    	"and ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key ".
					"and ".$_SESSION["data_source"].".id_nutrient_fkey = d_nutrient.nutrient_key ".
					"and ".$_SESSION["data_source"].".id_nutrient_analyses_fkey = d_nutrient_analyses.nutrient_analyses_key ";
				     	if ($_SESSION["data_source"] == "fact_table") $select_nutrients .=  "and d_m_b<> true ";
					$select_nutrients .= $_where." order by header_abbreviation, an_header_name";
			
				$result                = pg_query($_conn, $select_nutrients); if (!$result) die('Invalid query: ' . pg_error());
				$this->nutrient_number = pg_numrows($result);

				$columns_counter = 0;
				for ($i = 0; $i < $this->nutrient_number; $i++){
					$row                                                     = pg_fetch_array($result, $i);

					// inserting column for measurements agggregated over different analyses methods
					if ($i + 1 < $this->nutrient_number && !isset($this->nutrient_column_ids[$row['id']])){
						$next_row = pg_fetch_array($result, $i + 1);
						if ($row['id'] == $next_row['id']){
							$this->nutrient_column_ids[$row['id']] = $columns_counter;
							$this->nutrient_ids[$columns_counter]  = $row['id'];
							if (isset($row['header_abbreviation'])){
								$this->nutrient_abbreviations[$columns_counter] = $row['header_abbreviation'].' '.str_replace(' ', ',', $row['unit']).' summarized';
							}else{
								$this->nutrient_abbreviations[$columns_counter] = 'n/a';
							}
							$this->nutrient_measurements[$columns_counter]                 = '';
							$this->nutrient_measurements_detailed[$columns_counter]        = 'null';
							$columns_counter++;
						}
					}
					// -------------
					
					$this->nutrient_column_ids[$row['id'].'-'.$row['an_id']] = $columns_counter;
					$this->nutrient_ids[$columns_counter]                    = $row['id'].'-'.$row['an_id'];
					if (isset($row['header_abbreviation'])){
						if (isset($this->nutrient_column_ids[$row['id']])){
							$this->nutrient_abbreviations[$columns_counter] = $row['header_abbreviation'].' '.str_replace(' ', ',', $row['unit']).' '.$row['an_header_name'];							
						}else {
							$this->nutrient_abbreviations[$columns_counter] = $row['header_abbreviation'].' '.str_replace(' ', ',', $row['unit']).'';
						}
					}else{
						$this->nutrient_abbreviations[$columns_counter] = 'n/a';
					}
					$this->nutrient_measurements[$columns_counter]                 = '';
					$this->nutrient_measurements_detailed[$columns_counter]        = 'null';
					$columns_counter++;
				}
				$this->nutrient_number = $columns_counter;
			}

			// reading derived nutrients names ordered by groups which will form columns
			$selected_derived_nutrients  = $_query_cond->sel_der_nutrients;

        		if (isset($selected_derived_nutrients)&&strlen($selected_derived_nutrients)>0){
				// andrej: it must be abbreviation in all three languages!!!!
                    //		$select_derived_nutrients  = "(select abbr_".$_SESSION['lng']." as abbreviation, id, abbr_".$_SESSION['lng']." as header_abbreviation from t_formula ";
            			$select_derived_nutrients  = "(select abbr_generic as abbreviation, id, abbr_generic as header_abbreviation from t_formula ";
            			$select_derived_nutrients .= "where (id in ($selected_derived_nutrients)) ";
            			$select_derived_nutrients .= "order by abbreviation)";
            			$dnresult                  = pg_query($_conn, $select_derived_nutrients); if (!$dnresult) die('Invalid query: ' . pg_error());
            			$this->dnutrient_number    = pg_numrows($dnresult);
		
				for ($i = 0; $i < $this->dnutrient_number; $i++){
					$row                       = pg_fetch_array($dnresult, $i);
					$this->dnutrient_ids[$i]   = $row['id'];
					$this->dnutrient_column_ids[$row['abbreviation']] = $i;
					$this->dnutrient_measurements[$i]                 = '';
					$this->dnutrient_measurements_detailed[$i]        = 'null';
					if (isset($row['header_abbreviation'])){
						$this->dnutrient_abbreviations[$i] = $row['header_abbreviation'];
					}else{
						$this->dnutrient_abbreviations[$i] = 'n/a';
					}
				}
			}
		}

		function reset_data(){
			for ($i = 0; $i < $this->nutrient_number; $i++){
				$this->nutrient_measurements[$i]           = '';
				$this->nutrient_measurements_detailed[$i]  = 'null';
			}
			for ($i = 0; $i < $this->dnutrient_number; $i++){
				$this->dnutrient_measurements[$i]           = '';
				$this->dnutrient_measurements_detailed[$i]  = 'null';
			}
		}

		function print_into_error_log(){
			$sss = "";
			for ($i = 0; $i < 1; $i++){
				$sss.= " ".$this->nutrient_abbreviations[$i].":(".$this->nutrient_measurements[$i].",".$this->nutrient_measurements_detailed[$i].") ";
			}
			error_log($sss);
		}

		function print_to_json(){
			echo '{"c":[{"v":'.$this->location_id.'},{"v":'.$this->c_origin_key.'},{"v":'.json_encode($this->sample_name).'},{"v":'.$this->date.', "f":'.$this->sdate.'},{"v":'.$this->latitude.'},{"v":'.$this->longitude.'},{"v":'.json_encode($this->canton).'},{"v":'.json_encode($this->postal_code).'},{"v":'.json_encode($this->feedname).', "p":{"style":"min-width:250px"}}';
			for ($j = 0; $j < $this->nutrient_number; $j++){
				echo ',{"v":'.$this->nutrient_measurements_detailed[$j].', "f":'.json_encode($this->nutrient_measurements[$j]).'}';
			}
                        for ($j = 0; $j < $this->dnutrient_number; $j++){
				echo ',{"v":'.$this->dnutrient_measurements_detailed[$j].', "f":'.json_encode($this->dnutrient_measurements[$j]).'}';
			}
         		echo ']}';
		}

		function print_to_excel($_objPHPExcel, $_sample_index){
			$_objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $_sample_index + 2, $this->sample_name);
			$_objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $_sample_index + 2, str_replace(',','-', substr(json_decode($this->date), 5, -1)));
			$_objPHPExcel->getActiveSheet()->getStyleByColumnAndRow(1, $_sample_index + 2)->getNumberFormat()->setFormatCode(PHPExcel_Style_NumberFormat::FORMAT_DATE_YYYYMMDDSLASH);
			$_objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2, $_sample_index + 2, $this->canton);
			$_objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3, $_sample_index + 2, $this->postal_code);
			$_objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4, $_sample_index + 2, $this->feedname);
			$_objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5, $_sample_index + 2, $this->feedkey);
			for ($j = 0; $j < $this->nutrient_number; $j++){
				$_objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6 + $j, $_sample_index + 2, $this->nutrient_measurements[$j]);
			}
                        for ($j = 0; $j < $this->dnutrient_number; $j++){
				$_objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6 + $this->nutrient_number + $j, $_sample_index + 2, $this->dnutrient_measurements[$j]);
			} 
		}
	}
	//*******************************************************************************************	

	// readSampleFromTheQueryResult *************************************************************
	function readNextSampleFromTheQueryResult($_select_data_result, $select_derived_data_result, $_feed_sample){
                if($_feed_sample->nutrient_number > 0) {
                    $_row = pg_fetch_array($_select_data_result, $_feed_sample->row_offset);
                    if (!$_row) return false;
                } 
                else if($_feed_sample->nutrient_number == 0 && $_feed_sample->dnutrient_number > 0) {
                    $_row = pg_fetch_array($select_derived_data_result, $_feed_sample->row_offset);
                    if (!$_row) return false;
                }
		
                $_feed_sample->reset_data();
                $_feed_sample->canton      = $_row['canton'];
                $_feed_sample->feedname    = $_row['feedname'];
                $_feed_sample->feedkey     = $_row['feedkey'];
                if (isset($_row['day'])){
			$_feed_sample->date = $_row['day'];
			$time = strtotime($_feed_sample->date);
			$_feed_sample->date = json_encode('Date('.date("Y",$time).','.date("n",$time).','.date("j",$time).')');
			$_feed_sample->sdate = json_encode(date("Y",$time).'/'.date("m",$time).'/'.date("j",$time));
		}else {
			$_feed_sample->date = json_encode('null');
			$_feed_sample->sdate = json_encode(date("Y",$time).'/'.date("m",$time).'/'.date("j",$time));
		}
                
                if($_feed_sample->nutrient_number > 0) {
                    $_current_sample_id = $_row['lims_number'];
                    if($_SESSION['user'] === 'admin')
                    {
                        $_feed_sample->sample_name = ($_row['lims_number']);
                    }
                    else
                    {
                        $_feed_sample->sample_name = 'xxx'.substr($_row['lims_number'], -2);             
                    }
                    
                    $_feed_sample->latitude    = floatval($_row['latitude']);
                    $_feed_sample->longitude   = floatval($_row['longitude']);
                    $_feed_sample->postal_code = $_row['postal_code'];
                    if ((!isset($_row['latitude']))||(!isset($_row['longitude']))||(!isset($_row['canton']))){
                            $_feed_sample->location_id  = -1;
                            $_feed_sample->c_origin_key = -1;
                    }else {
                            if (!isset($_feed_sample->c_location_id)){
                                    $_feed_sample->c_location_id = 0;
                                    $_feed_sample->c_latitude    = $_row['latitude'];
                                    $_feed_sample->c_longitude   = $_row['longitude'];
                                    $_feed_sample->c_origin_key  = $_row['origin_key'];
                            }else if ($_row['latitude'] != $_feed_sample->c_latitude || $_row['longitude'] != $_feed_sample->c_longitude){
                                    $_feed_sample->c_location_id = $_feed_sample->c_location_id + 1;
                                    $_feed_sample->c_latitude    = $_row['latitude'];
                                    $_feed_sample->c_longitude   = $_row['longitude'];
                                    $_feed_sample->c_origin_key  = $_row['origin_key'];
                            }
                            $_feed_sample->location_id = $_feed_sample->c_location_id;
                    }
                
                    //set derived nutrient measure if canton, day and feed equals the nutrient row    
                    for($i = 0; $i < pg_numrows($select_derived_data_result); $i++) {
                        $result = pg_fetch_array($select_derived_data_result, $i);
                        $date = $result['day'];
                        $time = strtotime($date);
                        $date = json_encode('Date('.date("Y",$time).','.date("n",$time).','.date("j",$time).')');
			$sdate = json_encode(date("Y",$time).'/'.date("m",$time).'/'.date("j",$time));
                        if($result['canton'] == 'Not Available') $canton = '';
                        else $canton = $result['canton'];
                        $feedname = $result['feedname'];

                        if($date == $_feed_sample->date && $canton == $_feed_sample->canton && $feedname == $_feed_sample->feedname) {
                            $_column_id = $_feed_sample->dnutrient_column_ids[$result['abbreviation']];
                            $_feed_sample->dnutrient_measurements[$_column_id]          = number_format(floatval($result['quantity']),3,".","");
                            $_feed_sample->dnutrient_measurements_detailed[$_column_id] = number_format(floatval($result['quantity']),5,".","");
                        }
                    }
                
                    do{		
                            // reading nutritive value
                            $_column_id = $_feed_sample->nutrient_column_ids[$_row['id'].'-'.$_row['an_id']];	
                            if (isset($_row['avg_quantity'])){
                                    $_feed_sample->nutrient_measurements[$_column_id]          = number_format(floatval($_row['avg_quantity']),3,".","");
                                    $_feed_sample->nutrient_measurements_detailed[$_column_id] = number_format(floatval($_row['avg_quantity']),5,".","");
                            }else{
                                    $_feed_sample->nutrient_measurements[$_column_id]          = '';
                                    $_feed_sample->nutrient_measurements_detailed[$_column_id] = 'null';
                            }
			    // putting to the aggregated column if necessary
			    if (isset($_feed_sample->nutrient_column_ids[$_row['id']])){
				    $_column_id_another = $_feed_sample->nutrient_column_ids[$_row['id']];

				    if ($_feed_sample->nutrient_measurements[$_column_id] != ''||
					!(isset($_feed_sample->nutrient_measurements[$_column_id_another])&&$_feed_sample->nutrient_measurements[$_column_id_another]!= '')
				    ){				
	                                    $_feed_sample->nutrient_measurements[$_column_id_another]          = $_feed_sample->nutrient_measurements[$_column_id];
	                                    $_feed_sample->nutrient_measurements_detailed[$_column_id_another] = $_feed_sample->nutrient_measurements_detailed[$_column_id];
				    }
			    }

                            $_feed_sample->row_offset++;
                            $_row = pg_fetch_array($_select_data_result, $_feed_sample->row_offset);

                            if (!$_row){				
                                    //return $_current_sample_id;
                                    return true;
                            }else if ($_row['lims_number'] != $_current_sample_id){
                                    return true;
                                    return $_current_sample_id;
                            }
                    }while(true);
                }
                
                if($_feed_sample->nutrient_number == 0 && $_feed_sample->dnutrient_number > 0) {         
                    do {
                        $_column_id = $_feed_sample->dnutrient_column_ids[$_row['abbreviation']];
                        $_feed_sample->dnutrient_measurements[$_column_id]          = number_format(floatval($_row['quantity']),3,".","");
                        $_feed_sample->dnutrient_measurements_detailed[$_column_id] = number_format(floatval($_row['quantity']),5,".","");
                        
                        $_feed_sample->row_offset++;
                        $_row = pg_fetch_array($select_derived_data_result, $_feed_sample->row_offset);
                        
                        $date = $_row['day'];
                        $time = strtotime($date);
                        $date = json_encode('Date('.date("Y",$time).','.date("n",$time).','.date("j",$time).')');
			$sdate = json_encode(date("Y",$time).'/'.date("m",$time).'/'.date("j",$time));
                        if (!$_row){
                            return true;
                        }
                        if ($_feed_sample->feedname != $_row['feedname'] || $_feed_sample->canton != $_row['canton'] || $_feed_sample->date != $date) {
                            //error_log($_feed_sample->feedname.' '.$_row['feedname'].' '.$_feed_sample->canton.' '.$_row['canton'].' '.$_feed_sample->date.' '.$date);
                            return true;
                        }

                    }while(true);
                }
	}
	//*******************************************************************************************

	// setting the export variable
	$_export = false;
	if (isset($_POST["export"])){
		$_export = true;
	}

	// connecting to the database
	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());
	
	// retrieving the the where statement
	$query_cond = new QueryConditions($conn);
	$where = $query_cond->getWhereStatement();	

	// starting new session, in order to keep the same seed for random generator	
	pg_query($conn, "begin");

	// creating an empty feed sample by reading nutrient names and abbreviations
	$feed_sample = new FeedSample($conn, $query_cond, $where);

	// setting the size of the sample and getting the number of total records, i.e., the total number of distinct feed samples
	if (isset($_POST["sample"]) && intval($_POST["sample"]) > 0){
		$number_of_sample_samples = intval($_POST["sample"]);
	}else if (isset($query_cond->sample_size)&&!($query_cond->sample_size === "")){
		$number_of_sample_samples = $query_cond->sample_size;
	}else $number_of_sample_samples = 150;
	$number_of_distinct_samples;
	if (isset($_POST["size"]) && intval($_POST["size"]) > 0){
		$number_of_distinct_samples = intval($_POST["size"]);
	}
	if (isset($number_of_distinct_samples)){
		if ($number_of_sample_samples > $number_of_distinct_samples) $number_of_sample_samples = $number_of_distinct_samples;
	}

	// setting the seed for random number generator
	pg_query($conn, "select setseed(0.123)");	

	// creating subquery to retrieve uniform samples of lims samples which satisfy the query condition
	$select_data_subquery = "SELECT * FROM (SELECT distinct id_sample_fkey ".
                                    	"FROM ".$_SESSION["data_source"].", d_time, d_origin ".
                                    	"WHERE ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
                                    	"and ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key ";
				     	if ($_SESSION["data_source"] == "fact_table") $select_data_subquery .=  "and d_m_b<> true ";
					$select_data_subquery .= $where.") as all_lims ORDER BY RANDOM() LIMIT ".$number_of_sample_samples;

	// creating query to retrieve rows of the nutrient measurements
	$select_data_query = "SELECT lims_number, id_nutrient_fkey as id, id_nutrient_analyses_fkey as an_id, max(d_nutrient_analyses.priority) as priority, avg(quantity) as avg_quantity, max(COALESCE(t_day, to_date(t_year||'-01-01', 'YYYY-MM-DD'))) AS day, min(d_origin.postal_code) as postal_code, min(d_origin.origin_key) as origin_key, min(d_origin.latitude) as latitude, min(d_origin.longitude) as longitude, min(d_origin.canton) as canton, min(COALESCE(d_feed.name_".$_SESSION["lng"].",d_feed.name_de)) as feedname, min(d_feed.feed_key) as feedkey ".
                             "FROM d_feed, ".$_SESSION["data_source"].", d_nutrient, d_origin, d_time, d_nutrient_analyses ".
                             "WHERE ".$_SESSION["data_source"].".id_feed_fkey = d_feed.feed_key ".
                             "and ".$_SESSION["data_source"].".id_nutrient_fkey=d_nutrient.nutrient_key ".
                             "and ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
                             "and ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key ".
			     "and ".$_SESSION["data_source"].".id_nutrient_analyses_fkey = d_nutrient_analyses.nutrient_analyses_key ";
                             if ($_SESSION["data_source"] == "fact_table") $select_data_query .=  "and d_m_b<> true ";
			     $select_data_query .= "and id_sample_fkey in (".$select_data_subquery.") ";
                             $select_data_query .= $where." group by lims_number, id_nutrient_fkey, id_nutrient_analyses_fkey order by latitude, longitude, lims_number, priority";


	// retrieving the data
	$select_data_result = pg_query($conn, $select_data_query); if (!$select_data_result) die('Invalid query: ' . pg_error());
	
    

	// creating query to retrieve rows of the derived nutrient measurements
	$select_derived_data_result;
	if($feed_sample->dnutrient_number > 0){
		$select_derived_data = "";
		// this is how the new query must work: feedname in different languages, and  data to be used must come from the set of the lims_number
		$dnquery =  "SELECT d_feed.name_".$_SESSION['lng']." as name_de, id_feed_fkey, (CASE WHEN canton IS NULL THEN ''''Not Available'''' ELSE canton END) AS canton, max(CASE WHEN t_day IS NULL THEN to_date(t_year||''''-01-01'''', ''''YYYY-MM-DD'''') ELSE t_day END) AS t_day, lims_number, avg(quantity) as quantity ".
                                "FROM d_feed, ".$_SESSION["data_source"].", d_nutrient, d_origin, d_time ".
                                "WHERE ".$_SESSION["data_source"].".id_feed_fkey = d_feed.feed_key ".
                                "and ".$_SESSION["data_source"].".id_nutrient_fkey = d_nutrient.nutrient_key ".
                                "and ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
                                "and ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key ";
                                if ($_SESSION["data_source"] == "fact_table") $dnquery .= "and (d_m_b=false or z_abbreviation_de='TS') ";
			     	$dnquery .= "and id_sample_fkey in (".$select_data_subquery.") " .
                                "and quantity is not null and t_year is not null group by id_feed_fkey, d_feed.name_".$_SESSION['lng'].", canton, lims_number order by id_feed_fkey, canton, t_day";		
                $select_derived_data = "SELECT * FROM (";
		for ($d = 0; $d < $feed_sample->dnutrient_number; $d++) {
			if ($d>0) {
				$select_derived_data .= " UNION ";
                        }			
                        $select_derived_data .= "(SELECT k as abbreviation, t as day, m as quantity, canton, feedname FROM nnjx('".$dnquery."', '".$feed_sample->dnutrient_abbreviations[$d]."'))";
		}
                $select_derived_data .= ") AS data ORDER BY feedname, canton, day";
		//error_log($select_derived_data);

        $handle=fopen("query.txt", "w");
        fwrite($handle, "derived_data=" .$select_derived_data);
        fclose($handle);
		// setting the seed for random number generator
		$select_derived_data_result = pg_query($conn, $select_derived_data); if (!$select_derived_data_result) die('Invalid query: ' . pg_error());
	}

	if ($_export){
		/** Include path **/
		ini_set('include_path', ini_get('include_path').':'.realpath('.').'/PHPExcel-1.7.8/Classes');

		/** PHPExcel */
		include 'PHPExcel.php';

		/** PHPExcel_Writer_Excel2007 */
		include 'PHPExcel/Writer/Excel2007.php';

		// Create new PHPExcel object
		$objPHPExcel = new PHPExcel();
		header('Content-Type: application/vnd.ms-excel');
		header('Content-Disposition: attachment;filename="feed_data.xlsx"');
		header('Cache-Control: max-age=0');

		flush();

		// Other preparations
		$objPHPExcel->setActiveSheetIndex(0);
	}else {
		echo '{"rows":[';
	}

        for ($i = 0; $i < $number_of_sample_samples; $i++){
		if (readNextSampleFromTheQueryResult($select_data_result, $select_derived_data_result, $feed_sample)){
			if ($_export){
				$feed_sample->print_to_excel($objPHPExcel, $i);
			}else {
				if ($i > 0) echo ",";
				$feed_sample->print_to_json();
			}		
		}else $i = $number_of_sample_samples;
	}

	// printing header of the table. First, categorical data
	if ($_export){
		$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, 1, "LIMS-Nr.");
		$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, 1, "Date");
		$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2, 1, "Canton");
		$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(3, 1, "PLZ");
		$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(4, 1, $_terms['feed']);
		$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(5, 1, $_terms['feed']." id");
	}else {
	        echo '],"cols":[{"id":"location", "Label":"Location", "type":"number"},{"id":"originkey", "Label":"OriginKey", "type":"number"},{"id":"lims","label":"LIMS-Nr.","type":"string"},{"id":"date","label":"Date","type":"date"},{"id":"latitude", "label":"latitude", "type":"number"},{"id":"longitude", "label":"longitude", "type":"number"},{"id":"canton","label":"Canton","type":"string"},{"id":"plz","label":"PLZ","type":"string"},{"id":"feedname","label":"'.$_terms['feed'].'","type":"string"}';
	}
	// next, names of the normal nutrients
	for ($i = 0; $i < $feed_sample->nutrient_number; $i++){				
		if ($_export){	
			$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6 + $i, 1, $feed_sample->nutrient_abbreviations[$i]);
		}else {
			echo ',{"id":"nutrient'.$feed_sample->nutrient_ids[$i].'", "label":'.json_encode($feed_sample->nutrient_abbreviations[$i]).', "hlabel":'.json_encode(str_replace(' ', '<span class="hidd">o</span>', $feed_sample->nutrient_abbreviations[$i])).', "type":"number"}';
		}
	}
	// afterwards, names of the derived nutrients
	for ($i=0; $i < $feed_sample->dnutrient_number; $i++) {
		if ($_export){	
			$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(6 + $feed_sample->nutrient_number + $i, 1, $feed_sample->dnutrient_abbreviations[$i]);
		}else {
			echo ',{"id":"nutrientD'.$feed_sample->dnutrient_ids[$i].'", "label":'.json_encode($feed_sample->dnutrient_abbreviations[$i]).', "type":"number"}';
		}                    
	}
	// closing the header
	if ($_export){
	}else {
        	echo ']}';
	}

	// closing session
	pg_query($conn, "end");

	// closing connection
	pg_close($conn);

	// pushing the excel file
	if ($_export){
		$objWriter = new PHPExcel_Writer_Excel2007($objPHPExcel);
		ob_get_contents();
		$objWriter->save('php://output');
		ob_get_flush();
		$objPHPExcel->disconnectWorksheets();
		unset($objPHPExcel);
	}
	exit;
?>
