<?php
	ob_start();
	require './session_info.php';
	require './db_info.php';
	require './ajax-pg-query-where.php';
	ob_end_clean();

	// setting the export variable
	$_export = false;
	if (isset($_POST["export"])){
		$_export = true;
	}

	// connecting to the database
	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());

	// retrieving the the where statement
	$query_cond = new QueryConditions($conn);
	$selected_nutrients = $query_cond->sel_nutrients;
	$selected_feeds     = $query_cond->sel_classified_feeds;
	$fresh              = $query_cond->sel_fresh;

	// reading nutrients names ordered by groups which will form columns    
    
    // FRANCESCO
    if(isset($fresh)&&$fresh === "true"){
		$select_nutrients = "select distinct d_nutrient.nutrient_key as id, abbreviation_".$_SESSION['lng']." as abbreviation, ".
				    "group_id, specie_id, z_order, z_group_order, null as abbr_generic ".
				    "from d_nutrient where specie_id is not null and group_id is not null and d_nutrient.nutrient_key in (".$selected_nutrients.") ".
				    "except ". 
				    "select distinct d_nutrient.nutrient_key as id, abbreviation_".$_SESSION['lng']." as abbreviation, ".
				    "group_id, specie_id, z_order, z_group_order, null ". 
				    "from d_nutrient left join t_formula on t_formula.nutrient_fkey = d_nutrient.nutrient_key ". 
				    "where specie_id is not null and group_id is not null and (rtrim(abbr_generic) not like '%TS]') ".
				    "UNION ".
				    "select distinct d_nutrient.nutrient_key as id, abbreviation_".$_SESSION['lng']." as abbreviation, ".
				    "group_id, specie_id, z_order, z_group_order, abbr_generic ".
				    "from d_nutrient left join t_formula on t_formula.nutrient_fkey=d_nutrient.nutrient_key and d_nutrient.nutrient_key in (".$selected_nutrients.") ". 
				    "where specie_id is not null and group_id is not null and (rtrim(abbr_generic) not like '%TS]') ";
	}else {
		$select_nutrients = "select distinct d_nutrient.nutrient_key as id, abbreviation_".$_SESSION['lng']." as abbreviation, ".
				    "group_id, specie_id, z_order, z_group_order, null as abbr_generic ".
				    "from d_nutrient where specie_id is not null and group_id is not null and d_nutrient.nutrient_key in (".$selected_nutrients.") ".
				    "except ". 
				    "select distinct d_nutrient.nutrient_key as id, abbreviation_".$_SESSION['lng']." as abbreviation, ".
				    "group_id, specie_id, z_order, z_group_order, null ". 
				    "from d_nutrient left join t_formula on t_formula.nutrient_fkey = d_nutrient.nutrient_key ". 
				    "where specie_id is not null and group_id is not null and (rtrim(abbr_generic) not like '%FS]') ".
				    "UNION ".
				    "select distinct d_nutrient.nutrient_key as id, abbreviation_".$_SESSION['lng']." as abbreviation, ".
				    "group_id, specie_id, z_order, z_group_order, abbr_generic ".
				    "from d_nutrient left join t_formula on t_formula.nutrient_fkey=d_nutrient.nutrient_key and d_nutrient.nutrient_key in (".$selected_nutrients.") ". 
				    "where specie_id is not null and group_id is not null and (rtrim(abbr_generic) not like '%FS]') ";
	}

    //ANDREJ OLD QUERY
	/*$select_nutrients = "select distinct d_nutrient.nutrient_key as id, abbreviation_".$_SESSION['lng']." as abbreviation, ".
				    "group_id, specie_id, z_order, z_group_order ".
			            "from d_nutrient where ".
				    "specie_id is not null and group_id is not null "; 
        
	if(isset($selected_nutrients)&&strlen($selected_nutrients)>0){
		$select_nutrients .= "and d_nutrient.nutrient_key in (".$selected_nutrients.") ";
	}*/
	$select_nutrients .= "order by z_group_order, z_order;";
	
    
       /* $handle=fopen("query.txt", "w");
        fwrite($handle, "select_nutrients=" .$select_nutrients);
        fclose($handle);
        */
	$result = pg_query($conn, $select_nutrients); if (!$result) die('Invalid query: ' . pg_error());
	$rows   = pg_numrows($result);


	if ($rows > 0){
		if ($_export){
			/** Include path **/
			ini_set('include_path', ini_get('include_path').':'.realpath('.').'/PHPExcel-1.7.7/Classes');

			/** PHPExcel */
			include 'PHPExcel.php';

			/** PHPExcel_Writer_Excel2007 */
			include 'PHPExcel/Writer/Excel2007.php';

			// Create new PHPExcel object
			$objPHPExcel = new PHPExcel();
			header('Content-Type: application/vnd.ms-excel');
			header('Content-Disposition: attachment;filename="feed_data.xlsx"');
			header('Cache-Control: max-age=0');

			flush();

			// Other preparations
			$objPHPExcel->setActiveSheetIndex(0);
		}else {
			echo '{"rows":[';
		}

		// for each nutrient it columns id
		$column_ids;
		// for each nurient its unit type
		$column_units;
		// column style modifications
		$column_styles;
		// values for each column of a single row
		$column_values;
		// raw values for each column of a single row
		$column_raw_values;
		// for each column the id of the row in a summary table
		$column_rids;

		// printing nutrients names
		$current_style  = 0;
		$current_group  = 0;
        	$select_derived = "";
		for ($i = 0; $i < $rows; $i++){
			$row  = pg_fetch_array($result, $i);
			$column_ids[$row['id']] = $i;
			$column_values[$i] = '';
			$column_rids[$i] = '';
			$column_raw_values[$i] = 0;
			if ($i > 0 && $current_group != $row['group_id']){
				if ($current_style == 0) $current_style = 1;
				else $current_style = 0;
			}
			$current_group = $row['group_id'];
			if ($current_style == 0){
				$column_styles[$i] = ', "p":{"id":"d", "style":"background-color:rgba(80, 40, 40,0.0)"}';
			}else {
				$column_styles[$i] = ', "p":{"id":"d", "style":"background-color:rgba(180, 40, 40,0.2)"}';
			}
            
            		if($row['abbr_generic']!=NULL){
				$select_derived.= " UNION " .
		                "SELECT -1, " . $row['id'] .", ltrim(to_char(m,'99999D999'))::varchar as quantity, id_feed, round(m::numeric,4) as quantity, feed_key, name_".$_SESSION['lng']." as fname, null, null, " . 
                		$row['group_id'] . " as z_group_id FROM nnjx('SELECT name_de, id_feed_fkey, canton, min(t_day) as t_day, lims_number, avg(quantity) as quantity
				from (SELECT d_feed.name_de, fkey_feed_old_key as id_feed_fkey, ''''Not Available''''::varchar AS canton, (to_date(''''2001-01-01'''',''''YYYYMMDD'''')) AS t_day, raw_value as quantity, 2001 as t_year, ''''aa''''::varchar as lims_number  
				FROM summary_data, d_nutrient, d_feed WHERE d_feed.old_key = summary_data.fkey_feed_old_key and q_formula=''''native'''' and nutrient_fkey = d_nutrient.nutrient_key and d_feed.old_key in (".$selected_feeds.")) AS d_feed 
				WHERE quantity is not null and t_year is not null group by id_feed_fkey, d_feed.name_de, canton, lims_number order by id_feed_fkey, canton, t_day ', ";
		        		if(isset($fresh)&&$fresh === "true"){
						$select_derived.="'SUMMARY_DATA#FSnut_id=" . $row['id'] . "'), d_feed where id_feed=old_key ";
				}else	$select_derived.="'SUMMARY_DATA#TSnut_id=" . $row['id'] . "'), d_feed where id_feed=old_key ";
            		}
		}


		// reading the data
		$select_data = "select rid, nid,  clean_value, fid, raw_value, feedkey, fname, fcomment,  uname from(" .
                "select summary_data.id as rid, d_nutrient.nutrient_key as nid, summary_data.clean_value as clean_value, summary_data.fkey_feed_old_key as fid, ".
                "summary_data.raw_value as raw_value, d_feed.feed_key as feedkey, ".
                "d_feed.name_".$_SESSION['lng']." as fname, ".
                "d_feed.comments_".$_SESSION['lng']." as fcomment, ".
                "summary_data.u_name_".$_SESSION['lng']." as uname, d_nutrient.group_id ".
				"from summary_data, d_nutrient, d_feed where q_formula='native' and ".
				"d_nutrient.nutrient_key = summary_data.nutrient_fkey and ".
				"d_feed.old_key = summary_data.fkey_feed_old_key and ".
				"d_nutrient.specie_id is not null and ".
				"d_nutrient.group_id is not null and ".
				"d_feed.source = 'agroscope classified' ";
		if(isset($selected_nutrients)&&strlen($selected_nutrients)>0){
			$select_data .= "and d_nutrient.nutrient_key in (".$selected_nutrients.") ";
		}
		if(isset($selected_feeds)&&strlen($selected_feeds)>0){
			$select_data .= "and d_feed.old_key in (".$selected_feeds.") ";		
		}

        	if(isset($fresh)&&$fresh === "true"){
			$select_data .= "and (summary_data.u_group_id = 2 or summary_data.u_group_id = 0) ";
		}else $select_data .= "and (summary_data.u_group_id = 1 or summary_data.u_group_id = 0) ";
        
      		$select_data =$select_data . $select_derived . " order by feedkey, group_id, nid ) aa;";	 

        /*$handle=fopen("query.txt", "w");
        fwrite($handle, "select_data=" .$select_data);
        fclose($handle);*/

		$fresult = pg_query($conn, $select_data); if (!$fresult) die('Invalid query: ' . pg_error());
		$frows   = pg_numrows($fresult);


         
		//printing the data
		if ($frows > 0){
            		//echo '{"rows":[';

			$current_feed;
			$row_counter = 0;
			$current_feed_name;
			$current_feed_comment;
			$current_feed_key;
			$rid;	

			for ($i = 0; $i < $frows; $i++){
				$row  = pg_fetch_array($fresult, $i);

				if (isset($current_feed) && $current_feed != $row['fid']){ // outputing one row
					if ($row_counter > 0){
						if ($_export){
							$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $row_counter + 2, $current_feed_name);
							$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $row_counter + 2, $current_feed_key);
						}else {	
							if (isset($current_feed_comment) && (!($current_feed_comment === ""))){
								echo ',{"c":[{"v":'.json_encode($current_feed_name."<img style=\"cursor:pointer\" rid=\"".$current_feed."\" src=\"./layout_resources/images/button_info.gif\" />").', "p":{"style":"background-color:rgba(140, 170, 100,0.2);min-width:250px", "id":"asasd"},"id":"asasd"}';
							}else {				
								echo ',{"c":[{"v":'.json_encode($current_feed_name).', "p":{"style":"background-color:rgba(140, 170, 100,0.2);min-width:250px"}}';
							}
						}
					}else{
						if ($_export){
							$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $row_counter + 2, $current_feed_name);
							$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $row_counter + 2, $current_feed_key);
						}else {
							if (isset($current_feed_comment) && (!($current_feed_comment === ""))){
								echo '{"c":[{"v":'.json_encode($current_feed_name."<img style=\"cursor:pointer\" rid=\"".$current_feed."\" src=\"./layout_resources/images/button_info.gif\" />").', "p":{"style":"background-color:rgba(140, 170, 100,0.2);min-width:250px"}}';
							}else {
								echo '{"c":[{"v":'.json_encode($current_feed_name).', "p":{"style":"background-color:rgba(140, 170, 100,0.2);min-width:250px"}}';
							}
						}
					}
				
					for ($j = 0; $j < $rows; $j++){
						if ($_export){
							if ($column_raw_values[$j] != -1)
							$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2 + $j, $row_counter + 2, $column_raw_values[$j]);
						}else {
							if (isset($column_rids[$j]) && !($column_rids[$j]==='')){
								echo ',{"v":'.floatval($column_raw_values[$j]).', "f":'.json_encode("<span  style=\"cursor:pointer\" rid=\"".$column_rids[$j]."\">".$column_values[$j]."</span>").$column_styles[$j].'}';
							}else {
								echo ',{"v":'.floatval($column_raw_values[$j]).', "f":'.json_encode($column_values[$j]).$column_styles[$j].'}';	
							}					
						}
						$column_values[$j] = '';
						$column_rids[$j] = '';
                        			$column_raw_values[$j] = 0;
					}
					if ($_export){
					}else {
						echo ']}';
					}					

					$current_feed         = $row['fid'];
					$current_feed_key     = $row['feedkey'];
					$current_feed_name    = $row['fname'];
					$current_feed_comment = $row['fcomment'];
					$row_counter++;
				}

				if (!isset($current_feed)){
					$current_feed         = $row['fid'];
					$current_feed_key     = $row['feedkey'];
					$current_feed_name    = $row['fname'];
					$current_feed_comment = $row['fcomment'];
				}
				
               			$_column_id = $column_ids[$row['nid']];
				if (!isset($row['raw_value']))
					$column_values[$_column_id] .= 'NA';
				else $column_values[$_column_id] .= $row['raw_value'];
				$column_rids[$_column_id] .= $row['rid'];
				if (!isset($row['raw_value']))
                			$column_raw_values[$_column_id] = -1;
                		else $column_raw_values[$_column_id] = $row['raw_value'];				
                		if (!isset($column_units[$_column_id])){
                    			if (isset($row['uname'])){
                        			$column_units[$_column_id] = $row['uname'];
                    			}
                		}
			}

			// outputing the last row
			if ($row_counter > 0){
				if ($_export){
					$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $row_counter + 2, $current_feed_name);
					$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $row_counter + 2, $current_feed_key);
				}else {
					if (isset($current_feed_comment) && (!($current_feed_comment === ""))){
						echo ',{"c":[{"v":'.json_encode($current_feed_name."<img style=\"cursor:pointer\" rid=\"".$current_feed."\" src=\"./layout_resources/images/button_info.gif\" />").', "p":{"style":"background-color:rgba(140, 170, 100,0.2);min-width:250px"}}';
					}else {
						echo ',{"c":[{"v":'.json_encode($current_feed_name).', "p":{"style":"background-color:rgba(140, 170, 100,0.2);min-width:250px"}}';
					}
				}
			}else{
				if ($_export){
					$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, $row_counter + 2, $current_feed_name);
					$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, $row_counter + 2, $current_feed_key);
				}else {
					if (isset($current_feed_comment) && (!($current_feed_comment === ""))){
						echo '{"c":[{"v":'.json_encode($current_feed_name."<img style=\"cursor:pointer\" rid=\"".$current_feed."\" src=\"./layout_resources/images/button_info.gif\" />").', "p":{"style":"background-color:rgba(140, 170, 100,0.2);min-width:250px"}}';
					}else {
						echo '{"c":[{"v":'.json_encode($current_feed_name).', "p":{"style":"background-color:rgba(140, 170, 100,0.2);min-width:250px"}}';
					}
				}
			}
				
			for ($j = 0; $j < $rows; $j++){
				if ($_export){
					if ($column_raw_values[$j] != -1)
					$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(2 + $j, $row_counter + 2, $column_raw_values[$j]);
				}else {
					if (isset($column_rids[$j]) && !($column_rids[$j] ==='')){
						echo ',{"v":'.floatval($column_raw_values[$j]).', "f":'.json_encode("<span style=\"cursor:pointer\" rid=\"".$column_rids[$j]."\">".$column_values[$j]."</span>").$column_styles[$j].'}';
					}else {
						echo ',{"v":'.floatval($column_raw_values[$j]).', "f":'.json_encode($column_values[$j]).$column_styles[$j].'}';			
					}
				}
				$column_values[$j] = '';
				$column_rids[$j] = '';
                		$column_raw_values[$j] = 0;
			}
			if ($_export){					
			}else {
				echo ']}';
			}
		}
        
        	// printing header of the table
		if ($_export){
			$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(0, 1, "feed");
			$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow(1, 1, "feed_key");
		}else {
		        echo '],"cols":[{"id":"feed","label":"","type":"string"}';
		}
        	for ($i = 0; $i < $rows; $i++){
			$row  = pg_fetch_array($result, $i);
			$abbr = "";
			if (isset($row['abbreviation'])) $abbr = $row['abbreviation'];

			if ($_export){
				$objPHPExcel->getActiveSheet()->setCellValueByColumnAndRow($i + 2, 1, $abbr.' '.$column_units[$i]);
			}else {
				echo ',{"id":"'.$row['id'].'", "label":'.json_encode($abbr.' '.str_replace(' ', ',', $column_units[$i])).', "type":"number"'.$column_styles[$i].'}';
			}
		}
		if ($_export){	        
		}else {
			echo ']}';
		}
	}

	// closing connection
	pg_close($conn);

	if ($_export){
		$objWriter = new PHPExcel_Writer_Excel2007($objPHPExcel);
		$objWriter->save('php://output');
	}
?>
