<?php
	class Nutrient{
		var $nid     = "";
		var $nparent = "";
		var $nname   = "";

		function Nutrient($nid_, $nparent_, $nname_, $selected_){
			$this->nid      = $nid_;
			$this->nparent  = $nparent_;
			$this->nname    = $nname_;
			$this->selected = $selected_;
		}
	}

	function printNutrients($parents, $parent_, &$string_){
		if (isset($parents[$parent_])){
			foreach ($parents[$parent_] as $i => $value) {
				if (isset($parents[$i])){
					if ($parents[$parent_][$i]->selected) $string_.="<li class=\"jstree-checked\" id=".$parents[$parent_][$i]->nid."  title='". $parents[$parent_][$i]->nname. "'><a href='#'>".$parents[$parent_][$i]->nname."</a><ul>";
					else $string_.="<li id=".$parents[$parent_][$i]->nid."  title='". $parents[$parent_][$i]->nname. "'><a href='#'>".$parents[$parent_][$i]->nname."</a><ul>";
					printNutrients($parents, $i, $string_);
					$string_.="</ul></li>";
				}else { 
					if ($parents[$parent_][$i]->selected) $string_.="<li class=\"jstree-checked\" id=".$parents[$parent_][$i]->nid."  title='". $parents[$parent_][$i]->nname. "'><a href='#'>".$parents[$parent_][$i]->nname."</a></li>";
					else $string_.="<li id=".$parents[$parent_][$i]->nid."  title='". $parents[$parent_][$i]->nname. "'><a href='#'>".$parents[$parent_][$i]->nname."</a></li>";
				}
			}
		}
	}

	// $output_string_ - a reference to the string to which the output is written
	// $conn           - connection to the database
	// returns the number of selected nutrients
	function getNutrientsInJSON(&$output_string_, $conn, $query_conditions_){         
		// the number of selected nutrients
		$selected_count = 0;

		// a two dimensional array where the primary key is the parent_id
		$parents = array();

		// a one dimensional array of the selected nutrients from the saved query
		$selection = array();

		// getting the query parameters
		if (isset($query_conditions_->sel_nutrients)&& !($query_conditions_->sel_nutrients === "")){
			$sel = explode(",", $query_conditions_->sel_nutrients);
			for($i =0; $i < count($sel); $i++) {
				$selection[$sel[$i]] = $i;
			}		
		}		

		// selecting all nutrients
		$select_nutrients = "select z_id as id, z_name_".$_SESSION['lng']."  as name, z_group_id as group_id, z_specie_id as specie_id, z_order from vs_classified_nutrients order by z_order";
		$result = pg_query($conn, $select_nutrients); 
		if (!$result) die('Invalid query: ' . pg_error());

		$rows   = pg_numrows($result);
		//echo $rows.",";
		$output_string_.= '{"c":'.$rows.',';
		for ($i = 0; $i < $rows; $i++){
			$row    = pg_fetch_array($result, $i);
			$id     = $row['id'];
			$name   = $row['name'];
			$name   = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');
			$group  = $row['group_id'];
			$specie = $row['specie_id'];
			$sel    = false;
			if (isset($selection[$id])){
				$sel = true;		
				$selected_count++;
			}

			if (!isset($parents['-g-'.$group.'-g-s'.$specie])){
				$parents['-g-'.$group.'-g-s'.$specie] = array();
			}
			$parents['-g-'.$group.'-g-s'.$specie][''.$id.''] = new Nutrient($id, '-g-'.$group.'-g-s'.$specie, $name, $sel);
		}
		
		// selecting specie names and forming the root level of the tree
		$select_species = "select distinct z_specie_id, z_specie_name_".$_SESSION['lng']." as name from vs_classified_nutrients_root order by z_specie_id";
		$result = pg_query($conn, $select_species);
		if (!$result) die('Invalid query: ' . pg_error());
		$rows   = pg_numrows($result);
		for ($i = 0; $i < $rows; $i++){
			$row  = pg_fetch_array($result, $i);
			$id   = $row['z_specie_id'];
			$name = $row['name'];		
			$name = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');

			if (!isset($parents[''])){
				$parents[''] = array();
			}
			$parents['']['-g-s'.$id] = new Nutrient('-g-s'.$id, '', $name, false);
		}

		// selecting disting group names for each specie
		$select_groups = "select distinct z_group_id as id, z_specie_id as specie_id, name_".$_SESSION['lng']." as name from vs_classified_nutrients_tree order by name_".$_SESSION['lng'].";";
		$result = pg_query($conn, $select_groups);
		if (!$result) die('Invalid query: ' . pg_error());

		$rows   = pg_numrows($result);
		for ($i = 0; $i < $rows; $i++){
			$row = pg_fetch_array($result, $i);
			$id  = $row['id'];
			$specie = $row['specie_id'];
			$name = $row['name'];		
			$name = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');

			if (!isset($parents['-g-s'.$specie])){
				$parents['-g-s'.$specie] = array();
			}
			$parents['-g-s'.$specie]['-g-'.$id.'-g-s'.$specie] = new Nutrient('-g-'.$id.'-g-s'.$specie, '-g-s'.$specie, $name, false);
		}
		$output_string_.='"v":';
		$html_val = "";
		printNutrients($parents, '', $html_val);
		$output_string_.=json_encode($html_val);
		$output_string_.=',"s":'.$selected_count.'}';

		unset($parents);
		unset($selection);
		return $selected_count;
	}
/*	for testing individually:
	ob_start();
	require './db_info.php';
    	require './session_info.php';
	ob_end_clean();

	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());

	$output_string = "";
	getNutrientsInJSON($output_string, $conn);
	echo '(';
	echo $output_string;
	echo ')';

	pg_close($conn);

	exit; 
*/
?>

