<?php
	class Nutrient{
		var $nid     = "";
		var $nparent = "";
		var $nname   = "";

		function Nutrient($nid_, $nparent_, $nname_, $selected_){
			$this->nid      = $nid_;
			$this->nparent  = $nparent_;
			$this->nname    = $nname_;
			$this->selected = $selected_;
		}
	}

	function printNutrients($parents, $parent_, &$string_){
		if (isset($parents[$parent_])){
			foreach ($parents[$parent_] as $i => $value) {
				if (isset($parents[$i])){
					if ($parents[$parent_][$i]->selected) $string_.="<li class=\"jstree-checked\" id=".$parents[$parent_][$i]->nid."  title='". $parents[$parent_][$i]->nname. "'><a href='#'>".$parents[$parent_][$i]->nname."</a><ul>";
					else $string_.="<li id=".$parents[$parent_][$i]->nid."  title='". $parents[$parent_][$i]->nname. "'><a href='#'>".$parents[$parent_][$i]->nname."</a><ul>";
					printNutrients($parents, $i, $string_);
					$string_.="</ul></li>";
				}else { 
					if ($parents[$parent_][$i]->selected) $string_.="<li class=\"jstree-checked\" id=".$parents[$parent_][$i]->nid."  title='". $parents[$parent_][$i]->nname. "'><a href='#'>".$parents[$parent_][$i]->nname."</a></li>";
					else $string_.="<li id=".$parents[$parent_][$i]->nid."  title='". $parents[$parent_][$i]->nname. "'><a href='#'>".$parents[$parent_][$i]->nname."</a></li>";
				}
			}
		}
	}

	// $output_string_ - a reference to the string to which the output is written
	// $conn           - connection to the database
	// returns the number of selected nutrients
	function getDerivedNutrientsInJSON(&$output_string_, $conn, $query_conditions_){         
		// the number of selected nutrients
		$selected_count = 0;

		// a two dimensional array where the primary key is the parent_id
		$parents = array();

		// a one dimensional array of the selected nutrients from the saved query
		$selection = array();

		// getting the query parameters
		if (isset($query_conditions_->sel_nutrients)&& !($query_conditions_->sel_nutrients === "")){
			$sel = explode(",", $query_conditions_->sel_nutrients);
			for($i =0; $i < count($sel); $i++) {
				$selection[$sel[$i]] = $i;
			}		
		}		

		// selecting all nutrients
		$select_nutrients = "select id_formula as id, abbr_de as name from t_formula, t_formula_feed, d_feed where  id=id_formula and id_feed=feed_key and d_feed.old_key in (".$selected_feeds.") ;
		$result = pg_query($conn, $select_nutrients); 
		if (!$result) die('Invalid query: ' . pg_error());

		$rows   = pg_numrows($result);
		//echo $rows.",";
		$output_string_.= '{"c":'.$rows.',';
		for ($i = 0; $i < $rows; $i++){
			$row    = pg_fetch_array($result, $i);
			$id     = $row['id'];
			$name   = $row['name'];
			$name   = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');
			$group  = 0;
			$specie = 0; //No animal
			$sel    = false;
			if (isset($selection[$id])){
				$sel = true;		
				$selected_count++;
			}

			if (isset($name)) {
        	            $name = htmlspecialchars($name, ENT_COMPAT, 'UTF-8'); 
			}else {
        	            $name = "n/a";
			}	

				if ($sel) $html_val.= "<li id='$id' class=\"jstree-checked\" title='$name'><a href='#'>$name</a></li>";
				else $html_val.= "<li id='$id' title='$name'><a href='#'>$name</a></li>";
			
        }
		
	
		$output_string_.='"v":';
		$output_string_.=json_encode($html_val);
		$output_string_.=',"s":'.$selected_count.'}';

		unset($selection);
		return $selected_count;
	}
/*	for testing individually:
	ob_start();
	require './db_info.php';
    	require './session_info.php';
	ob_end_clean();

	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());

	$output_string = "";
	getNutrientsInJSON($output_string, $conn);
	echo '(';
	echo $output_string;
	echo ')';

	pg_close($conn);

	exit; 
*/
?>

