<?php
	class Feed{
		var $nid      = "";
		var $nparent  = "";
		var $nname    = "";
		var $old_key  = "";
		var $selected = false;

		function Feed($nid_, $nparent_, $nname_, $old_key_, $selected_, $in_catalog_){
			$this->nid        = $nid_;
			$this->nparent    = $nparent_;
			$this->nname      = $nname_;
			$this->old_key    = $old_key_;
			$this->selected   = $selected_;
			$this->in_catalog = $in_catalog_;
		}
	}

	function printFeeds($parents, $parent_, &$string_){
		if (isset($parents[$parent_])){
			foreach ($parents[$parent_] as $i => $value) {
				if (isset($parents[$i])){
					if ($parents[$parent_][$i]->selected) $string_.="<li class=\"jstree-checked\" id=".$parents[$parent_][$i]->nid." title='".$parents[$parent_][$i]->nname. "'><a href='#'>".$parents[$parent_][$i]->nname."</a><ul>";
					else $string_.="<li id=".$parents[$parent_][$i]->nid." title='".$parents[$parent_][$i]->nname. "'><a href='#'>".$parents[$parent_][$i]->nname."</a><ul>";
					printFeeds($parents, $i, $string_);
					$string_.="</ul></li>";
				}else { 
					if ($parents[$parent_][$i]->selected) $string_.="<li class=\"jstree-checked\" id=".$parents[$parent_][$i]->nid." title='".$parents[$parent_][$i]->nname. "'><a href='#'>".$parents[$parent_][$i]->nname."</a>";
					else $string_.="<li id=".$parents[$parent_][$i]->nid." title='".$parents[$parent_][$i]->nname. "'><a href='#'>".$parents[$parent_][$i]->nname."</a>";
					
					if ($parents[$parent_][$i]->in_catalog)
					$string_.="<a href='http://www.feed-alp.admin.ch/fmkatalog/katalog/de/html/unit_" . $parents[$parent_][$i]->old_key . ".html' TARGET='_blank'> <img src='./layout_resources/images/button_info.gif' /> </a> ";
					$string_.="</li>";
				}
			}
		}
	}

	// $output_string_ - a reference to the string to which the output is written
	// $conn           - connection to the database
	// returns the number of selected feeds
	function getFeedsInJSON(&$output_string_, $conn, $query_conditions_){
		// the number of selected feeds
		$selected_count = 0;

		// a two dimensional array where the primary key is the parent_id
		$parents = array();

		// a one dimensional array of the selected feeds from the saved query
		$selection = array();

		// getting the seleted feed from a saved query
		if (isset($query_conditions_->sel_classified_feeds)&& !($query_conditions_->sel_classified_feeds === "")){
			$sel = explode(",", $query_conditions_->sel_classified_feeds);
			for($i =0; $i < count($sel); $i++) {
				$selection[$sel[$i]] = $i;
			}		
		}

		// determing the views
		$view_feeds      = "vc_classified_feeds";
		$view_feeds_tree = "vc_classified_feeds_tree";
		if ($_SESSION["data_source"] == "fact_table"){ 
			$view_feeds      = "vr_classified_feeds";
			$view_feeds_tree = "vr_classified_feeds_tree";
		}

		// first, selecting all feeds	
		$select_feeds = "select name_".$_SESSION['lng']." as name, feed_key, feed_group_id, old_feed_key as old_key, source, in_catalog from ".$view_feeds." order by name_".$_SESSION['lng'];
		$result = pg_query($conn, $select_feeds);
		if (!$result) die('Invalid query: ' . pg_error());

		$rows = pg_numrows($result);
		$output_string_.= '{"c":'.$rows.',';

		for ($i = 0; $i < $rows; $i++){
			$row        = pg_fetch_array($result, $i);
			$group_id   = $row['feed_group_id'];
			$feed_key   = $row['feed_key'];
			$name       = $row['name'];
			$old_key    = $row['old_key'];
			$source     = $row['source'];
			$sel        = false;
			if (isset($selection[$feed_key])) $sel = true;
			$in_catalog = false;
			if (strtolower($row['in_catalog'][0]) === 't')		
			$in_catalog = true;
	
			$name = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');
		
			if (!isset($parents['-g-'.$group_id])){
				$parents['-g-'.$group_id] = array();
			}
			if (!isset($parents['-g-'.$group_id][''.$old_key])){
				if ($sel) $selected_count++;
				if ($source == 'agroscope classified'){				
					$parents['-g-'.$group_id][''.$old_key] = new Feed(''.$feed_key, '-g-'.$group_id, $name, ''. $old_key, $sel, $in_catalog);
				}else{
					$parents['-g-'.$group_id][''.$old_key] = new Feed(''.$feed_key, '-g-'.$group_id, '', ''. $old_key, $sel, $in_catalog);
				}
			}else{
				$parents['-g-'.$group_id][''.$old_key]->nid    = $parents['-g-'.$group_id][''.$old_key]->nid.','.$feed_key;
			
				if ($source == 'agroscope classified'){					
					$parents['-g-'.$group_id][''.$old_key]->nname  = $name;

					$t_nid      = $parents['-g-'.$group_id][''.$old_key]->nid;
					$t_nparent  = $parents['-g-'.$group_id][''.$old_key]->nparent;
					$t_nname    = $parents['-g-'.$group_id][''.$old_key]->nname;
					$t_old_key  = $parents['-g-'.$group_id][''.$old_key]->old_key;
					$t_selected = $parents['-g-'.$group_id][''.$old_key]->selected;

					unset($parents['-g-'.$group_id][''.$old_key]);
					$parents['-g-'.$group_id][''.$old_key] = new Feed($t_nid, $t_nparent, $t_nname, $t_old_key, $t_selected, $in_catalog);
				}

				if ($sel&&(!$parents['-g-'.$group_id][''.$old_key]->selected)){
					$parents['-g-'.$group_id][''.$old_key]->selected = true;
					$selected_count++;
				}
			}
		}

		// second, selecting all feed groups
		$select_groups = "select feed_group_id, parent_feed_group_id, feed_group_".$_SESSION['lng']." as name from ".$view_feeds_tree." order by feed_group_id";
		$result = pg_query($conn, $select_groups);
		if (!$result) die('Invalid query: ' . pg_error());

		$rows   = pg_numrows($result);
		for ($i = 0; $i < $rows; $i++){
			$row       = pg_fetch_array($result, $i);
			$id        = $row['feed_group_id'];
			$parent_id = $row['parent_feed_group_id'];
			$name      = $row['name'];
			$name = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');

			if (!$parent_id){
				if (!isset($parents[''])){
					$parents[''] = array();
				}
				$parents['']['-g-'.$id] = new Feed('-g-'.$id, '', $name, '', false, false);
			}else{
				if (!isset($parents['-g-'.$parent_id])){
					$parents['-g-'.$parent_id] = array();
				}
				$parents['-g-'.$parent_id]['-g-'.$id] = new Feed('-g-'.$id, '-g-'.$parent_id, $name, '', false, false);
			}
		}

		$output_string_.='"v1":';
		$html_val = "";
		printFeeds($parents, '-g-1', $html_val);
		$output_string_.=json_encode($html_val).",";
		$output_string_.='"v2":';
		$html_val = "";
		printFeeds($parents, '-g-24', $html_val);
		$output_string_.=json_encode($html_val);
		$output_string_.=',"s":'.$selected_count.'}';

		unset($parents);
		unset($selection);

		return $selected_count;
	}
/*	for testing individually:
	ob_start();
	require './db_info.php';
    	require './session_info.php';
	ob_end_clean();	

	// connecting to the database
	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());

	$output_string = "";
	getFeedsInJSON($output_string, $conn);
	echo '(';
	echo $output_string;
	echo ')';

	pg_close($conn);
	exit;
*/
?>
