<?php
	// $output_string_ - a reference to the string to which the output is written
	// $conn           - connection to the database
	// returns the number of selected nutrients
	function getDerivedNutrientsInJSON(&$output_string_, $conn, $query_conditions_){
		// the number of selected nutrients
		$selected_count = 0;

		// a one dimensional array of the selected nutrients from the saved query
		$selection = array();

		// getting the seleted nutrients and feeds from the saved query, or from the search parameters
		if (isset($query_conditions_->sel_der_nutrients)&& !($query_conditions_->sel_der_nutrients === "")){
			$sel = explode(",", $query_conditions_->sel_der_nutrients);
			for($i =0; $i < count($sel); $i++) {
				$selection[$sel[$i]] = $i;
			}		
		}
		if (isset($_SESSION['user'])&&isset($_SESSION['userlevel'])&&$_SESSION['userlevel'] >= 2){ 
			$selected_classified_feeds   = $query_conditions_->sel_classified_feeds;
		}
		if (isset($_SESSION['user'])&&isset($_SESSION['userlevel'])&&$_SESSION['userlevel'] > 2){
			$selected_unclassified_feeds = $query_conditions_->sel_unclassified_feeds;
		}
		$selected_agridea_feeds      = $query_conditions_->sel_agridea_feeds;

		// selecting and preparing the result for jstree, i.e., as xml nodes
		$select_nutrients = "select distinct abbr_generic as name, t_formula.formula as description, t_formula.id as id
        	                        from t_formula, t_formula_feed
        	                        where t_formula.id=t_formula_feed.id_formula";

		$search_parameters = FALSE;

		if(isset($selected_unclassified_feeds)&&strlen($selected_unclassified_feeds)>0){
			if ($search_parameters) $select_nutrients .= " or t_formula_feed.id_feed in ($selected_unclassified_feeds)";
			else {
				$select_nutrients .= " and (t_formula_feed.id_feed in ($selected_unclassified_feeds)";
				$search_parameters = TRUE;
			}
		}

		if(isset($selected_agridea_feeds)&&strlen($selected_agridea_feeds)>0){
			if ($search_parameters) $select_nutrients .= " or t_formula_feed.id_feed in ($selected_agridea_feeds)";
			else {
				$select_nutrients .= " and (t_formula_feed.id_feed in ($selected_agridea_feeds)";
				$search_parameters = TRUE;
			}	
		}

		if(isset($selected_classified_feeds)&&strlen($selected_classified_feeds)>0){
			if ($search_parameters) $select_nutrients .= " or t_formula_feed.id_feed in ($selected_classified_feeds)";
			else {
				$select_nutrients .= " and (t_formula_feed.id_feed in ($selected_classified_feeds)";
				$search_parameters = TRUE;
			}		
		}

		if ($search_parameters) $select_nutrients .= ")";
	//	$select_nutrients .= " group by d_nutrient.z_abbreviation_de ";
		$select_nutrients.= " order by name";


		$result = pg_query($conn, $select_nutrients);
		if (!$result) die('Invalid query: ' . pg_error());	        

		$rows   = pg_numrows($result);        
		$output_string_.= '{"c":'.$rows.',';
		$html_val = "";
		for ($i = 0; $i < $rows; $i++){
			$row            = pg_fetch_array($result, $i);
			$id             = $row['id'];
			$description    = $row['description'];
			$name           = $row['name'];
			$sel            = false;
			if (isset($selection[$id])){
				$sel = true;
				$selected_count++;
			}

			if (isset($name)) {
        	            $name = htmlspecialchars($name, ENT_COMPAT, 'UTF-8'); 
			}else {
        	            $name = "n/a";
			}	

			if(isset($description)){
				$description = htmlspecialchars($description, ENT_COMPAT, 'UTF-8');
				if ($sel) $html_val.= "<li id='$id' class=\"jstree-checked\" title='$name'><a href='#'>$name</a></li>";
				else $html_val.= "<li id='$id' title='$name'><a href='#'>$name</a></li>";
			}else {
				if ($sel) $html_val.= "<li id='$id' class=\"jstree-checked\" title='$name'><a href='#'>$name</a></li>";
				else $html_val.= "<li id='$id' title='$name'><a href='#'>$name</a></li>";
			}
		}

		unset($selection);
		$output_string_.='"v":';
		$output_string_.=json_encode($html_val);
		$output_string_.=',"s":'.$selected_count.'}';
		
		return $selected_count;
	}
?>
