<?php
	// $output_string_ - a reference to the string to which the output is written
	// $conn           - connection to the database
	// returns the number of selected properties
	function getTdPropertiesInJSON(&$output_string_, $conn, $query_conditions_){
		// the counters for selection
		$sel_cantons_count = 0;
		$sel_alt_count     = 0;
		$sel_year_count    = 0;
		$sel_seas_count    = 0;		
	
		// a one dimensional array of the selected items from the saved query
		$selection_cantons  = array();
		$selection_altitude = array();
		$selection_year     = array();
		$selection_season   = array();

		// getting the seleted nutrientsm, feeds and other stuff from the query conditions
		if (isset($query_conditions_->sel_cantons)&&!($query_conditions_->sel_cantons === "")){
			$sel = explode(",", $query_conditions_->sel_cantons);
			for($i =0; $i < count($sel); $i++) {
				$selection_cantons[$sel[$i]] = $i;
			}
		}
		if (isset($query_conditions_->sel_altitude)&&!($query_conditions_->sel_altitude === "")){
			$sel = explode(",", $query_conditions_->sel_altitude);
			for($i =0; $i < count($sel); $i++) {
				$selection_altitude[$sel[$i]] = $i;
			}
		}
		if (isset($query_conditions_->sel_year)&&!($query_conditions_->sel_year === "")){
			$sel = explode(",", $query_conditions_->sel_year);
			for($i =0; $i < count($sel); $i++) {
				$selection_year[$sel[$i]] = $i;
			}
		}
		if (isset($query_conditions_->sel_season)&&!($query_conditions_->sel_season === "")){
			$sel = explode(",", $query_conditions_->sel_season);
			for($i =0; $i < count($sel); $i++) {
				$selection_season[$sel[$i]] = $i;
			}
		}
		if (isset($_SESSION['user'])&&isset($_SESSION['userlevel'])&&$_SESSION['userlevel'] >= 2){ 
			$selected_classified_feeds   = $query_conditions_->sel_classified_feeds;
		}
		if (isset($_SESSION['user'])&&isset($_SESSION['userlevel'])&&$_SESSION['userlevel'] > 2){
			$selected_unclassified_feeds = $query_conditions_->sel_unclassified_feeds;
		}
		$selected_agridea_feeds      = $query_conditions_->sel_agridea_feeds;
		$selected_nutrients          = $query_conditions_->sel_nutrients;
		
		// forming where conditions ****************************
		$where        = "";
		$search_feeds = FALSE;

		if(isset($selected_unclassified_feeds)&&strlen($selected_unclassified_feeds)>0){
			if ($search_feeds) $where .= " or feed_key in ($selected_unclassified_feeds)";
			else {
				$where .= "(feed_key in ($selected_unclassified_feeds)";
				$search_feeds = TRUE;
			}
		}

		if(isset($selected_agridea_feeds)&&strlen($selected_agridea_feeds)>0){
			if ($search_feeds) $where .= " or feed_key in ($selected_agridea_feeds)";
			else {
				$where .= "(feed_key in ($selected_agridea_feeds)";
				$search_feeds = TRUE;
			}
		}

		if(isset($selected_classified_feeds)&&strlen($selected_classified_feeds)>0){
			if ($search_feeds) $where .= " or feed_key in ($selected_classified_feeds)";
			else {
				$where .= "(feed_key in ($selected_classified_feeds)";
				$search_feeds = TRUE;
			}
		}

		if ($search_feeds) $where .= ")";

		if(isset($selected_nutrients)&&strlen($selected_nutrients)>0){
			$where .= " and (nutrient_key in ($selected_nutrients))";
		}
		// *****************************************************	

		// getting cantons *************************************
		$query = "select distinct d_origin.canton as key, d_origin.canton as name ".			
				"from d_origin where d_origin.origin_key in (select distinct origin_key from ";
				if ($_SESSION["data_source"] === "fact_table") $query .= "vr_cube where ".$where.") order by d_origin.canton;";
				else $query .= "vc_cube where ".$where.") order by d_origin.canton;";
		$result = pg_query($conn, $query); if (!$result) die('Invalid query: ' . pg_error());
		$rows   = pg_numrows($result);
		$output_string_.= '"ct":{"c":'.$rows.',';
		$html_val       = "";
		$was_sel_na     = false;
		for ($i = 0; $i < $rows; $i++){
			$row         = pg_fetch_array($result, $i);
			$name        = $row['name'];
			$key         = $row['key'];		
			$sel         = false;
        
			if (isset($key)){
				if (isset($selection_cantons[$key])){
					$sel = true;
					$sel_cantons_count++;
				}
				$key = htmlspecialchars($key, ENT_COMPAT, 'UTF-8');
				if (isset($selection_cantons[$key])&&(!$sel)){
					$sel = true;
					$sel_cantons_count++;
				}
			}else{
				$key = "n/a";
				if (isset($selection_cantons[$key])){
					$sel = true;
					if (!$was_sel_na){
						$was_sel_na = true;
						$sel_cantons_count++;
					}
				}
			}

			if (isset($name)) $name = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');
			else $name = $key;		
		
			if ($sel) $html_val.= "<li id='$key' class=\"jstree-checked\" title='$name'><a href='#'>$name</a></li>";
			else $html_val.= "<li id='$key' title='$name'><a href='#'>$name</a></li>";
		}
		$output_string_.='"v":';
		$output_string_.=json_encode($html_val);
		$output_string_.=',"s":'.$sel_cantons_count.'},';
		// *****************************************************

		// getting altitude ************************************
		$query = "select distinct d_origin.altitude_class as name ".
				"from d_origin where d_origin.origin_key in (select distinct origin_key from ";
				if ($_SESSION["data_source"] === "fact_table") $query .= "vr_cube where ".$where.") order by d_origin.altitude_class;";
				else $query .= "vc_cube where ".$where.") order by d_origin.altitude_class;";
		$result = pg_query($conn, $query); if (!$result) die('Invalid query: ' . pg_error());
		$rows   = pg_numrows($result);
		$output_string_.= '"al":{"c":'.$rows.',';
		$html_val       = "";
		$was_sel_na     = false;
		for ($i = 0; $i < $rows; $i++){
			$row         = pg_fetch_array($result, $i);
			$name        = $row['name'];		
			$sel         = false;

			if (isset($name)){
				if (isset($selection_altitude[$name])){
					$sel = true;
					$sel_alt_count++;
				}
				$name = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');
				if (isset($selection_altitude[$name])&&(!$sel)){
					$sel = true;
					$sel_alt_count++;
				}
			}else{	
				$name = "n/a";
				if (isset($selection_altitude[$name])){
					$sel = true;
					if (!$was_sel_na){
						$was_sel_na = true;
						$sel_alt_count++;
					}
				}
			}
		
			if ($sel) $html_val.= "<li id='$name' class=\"jstree-checked\"><a href='#'>$name</a></li>";
			else $html_val.= "<li id='$name'><a href='#'>$name</a></li>";
		}
		$output_string_.='"v":';
		$output_string_.=json_encode($html_val);
		$output_string_.=',"s":'.$sel_alt_count.'},';
		// *****************************************************

		// getting year ****************************************
		$query = "select distinct d_time.t_year as name from d_time where (d_time.moment = 1 or d_time.moment = 2) and d_time.time_key in (select distinct time_key from ";
				if ($_SESSION["data_source"] === "fact_table") $query .= "vr_cube where ".$where.") order by d_time.t_year;";
				else $query .= "vc_cube where ".$where.") order by d_time.t_year;";
		$result = pg_query($conn, $query); if (!$result) die('Invalid query: ' . pg_error());
		$rows   = pg_numrows($result);
		$output_string_.= '"yeh":{"c":'.$rows.',';
		$html_val       = "";
		$was_sel_na     = false;
		for ($i = 0; $i < $rows; $i++){
			$row         = pg_fetch_array($result, $i);
			$name        = $row['name'];		
			$sel         = false;

			if (isset($name)){
				if (isset($selection_year[$name])){
					$sel = true;
					$sel_year_count++;
				}
				$name = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');
				if (isset($selection_year[$name])&&(!$sel)){
					$sel = true;	
					$sel_year_count++;
				}
			}else{
				$name = "n/a";
				if (isset($selection_year[$name])){
					$sel = true;
					if (!$was_sel_na){
						$was_sel_na = true;
						$sel_year_count++;
					}
				}
			}
		
			if ($sel) $html_val.= "<li id='$name' class=\"jstree-checked\"><a href='#'>$name</a></li>";
			else $html_val.= "<li id='$name'><a href='#'>$name</a></li>";
		}
		$output_string_.='"v":';
		$output_string_.=json_encode($html_val);
		$output_string_.=',"s":'.$sel_year_count.'},';
		// *****************************************************

		// getting season **************************************
		$query = "select distinct d_time.season_de as key, d_time.season_".$_SESSION['lng'].
				 	    " as name from d_time where (d_time.moment = 2 or d_time.moment = 1) and d_time.time_key in (select distinct time_key from ";
				 	    if ($_SESSION["data_source"] === "fact_table") $query .= "vr_cube where ".$where.") order by d_time.season_de;";
				 	    else $query .= "vc_cube where ".$where.") order by d_time.season_de;";
		$result = pg_query($conn, $query); if (!$result) die('Invalid query: ' . pg_error());
		$rows   = pg_numrows($result);
		$output_string_.= '"seh":{"c":'.$rows.',';
		$html_val       = "";
		$was_sel_na     = false;
		for ($i = 0; $i < $rows; $i++){
			$row         = pg_fetch_array($result, $i);
			$name        = $row['name'];
			$key         = $row['key'];
			$sel         = false;
        
			if (isset($key)){
				if (isset($selection_season[$key])){
					$sel = true;	
					$sel_seas_count++;
				}
				$key = htmlspecialchars($key, ENT_COMPAT, 'UTF-8');
				if (isset($selection_season[$key])&&(!$sel)){
					$sel = true;	
					$sel_seas_count++;
				}
			}else{
				$key = "n/a";
				if (isset($selection_season[$key])){
					$sel = true;
					if (!$was_sel_na){
						$was_sel_na = true;
						$sel_seas_count++;
					}	
				}
			}

			if (isset($name)) $name = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');
			else $name = $key;		
		
			if ($sel) $html_val.= "<li id='$key' class=\"jstree-checked\"><a href='#'>$name</a></li>";
			else $html_val.= "<li id='$key'><a href='#'>$name</a></li>";
		}
		$output_string_.='"v":';
		$output_string_.=json_encode($html_val);
		$output_string_.=',"s":'.$sel_seas_count.'}';
		// *****************************************************	

		// clearing arrays
		unset($selection_cantons);
		unset($selection_altitude);
		unset($selection_year);
		unset($selection_season);

		return ($sel_cantons_count + $sel_alt_count + $sel_year_count + $sel_seas_count);
	}
?>
