<?php
	// $output_string_ - a reference to the string to which the output is written
	// $conn           - connection to the database
	// returns the number of selected feeds
	function getUnclasFeedsInJSON(&$output_string_, $conn, $query_conditions_){
		// the number of selected feeds
		$selected_count = 0;

		// a one dimensional array of the selected feeds from the saved query
		$selection = array();

		// getting the seleted feeds from query conditions
		if (isset($query_conditions_->sel_unclassified_feeds)&& !($query_conditions_->sel_unclassified_feeds === "")){
			$sel = explode(",", $query_conditions_->sel_unclassified_feeds);
			for($i =0; $i < count($sel); $i++) {
				$selection[$sel[$i]] = $i;
			}		
		}

		// determing the views
		$view_feeds      = "vc_unclassified_feeds";
		if ($_SESSION["data_source"] == "fact_table"){ 
			$view_feeds      = "vr_unclassified_feeds";
		}

		// selecting and preparing the result for jstree as html tags
		$select_feeds = "select distinct feed_key, name_".$_SESSION['lng']." as name, alternative_name_".$_SESSION['lng']." as alternative_name from ".$view_feeds." order by name";
		$result = pg_query($conn, $select_feeds);

		if (!$result) die('Invalid query: ' . pg_error());

		$rows   = pg_numrows($result);
		$output_string_.= '{"c":'.$rows.',';
		$html_val = "";
		for ($i = 0; $i < $rows; $i++){
			$row              = pg_fetch_array($result, $i);
			$id               = $row['feed_key'];
			$alternative_name = $row['alternative_name'];
			$name             = $row['name'];
			$sel              = false;
			if (isset($selection[$id])){
				$sel = true;
				$selected_count++;
			}

			if (isset($name)) $name = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');
			else $name = "n/a";

			if(isset($alternative_name)){
				$alternative_name = htmlspecialchars($alternative_name, ENT_COMPAT, 'UTF-8');
				if ($sel) $html_val.= "<li id='$id' class=\"jstree-checked\" title='$name'><a href='#'>$name   <i>-- $alternative_name</i></a></li>";
				else $html_val.= "<li id='$id' title='$name'><a href='#'>$name   <i>-- $alternative_name</i></a></li>";
			}else {
				if ($sel) $html_val.= "<li id='$id' class=\"jstree-checked\" title='$name'><a href='#'>$name</a></li>";
				else $html_val.= "<li id='$id' title='$name'><a href='#'>$name</a></li>";
			}
		}

		unset($selection);

		$output_string_.='"v":';
		$output_string_.=json_encode($html_val);
		$output_string_.=',"s":'.$selected_count.'}';
		
		return $selected_count;
	}
/*	for testing individually:
	ob_start();
	require './db_info.php';
    	require './session_info.php';
	ob_end_clean();

	// connecting to the database
	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());
	
	$output_string = "";
	getUnclasFeedsInJSON($output_string, $conn);
	echo '(';
	echo $output_string;
	echo ')';

	pg_close($conn);
	exit;
*/
?>
