<?php
	ob_start();
	require './db_info.php';
	require './ajax-pg-query-where.php';
	require './session_info.php';
	ob_end_clean();
	
	$where = getWhereStatement();
        $nutrients  = $_POST["nt"];
        $derived_nutrients  = $_POST["ntd"];

	//  Connection to PostgreSQL-DB
	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());

	// setting the size of the sample and getting the number of total records, i.e., the total number of distinct feed samples
	if (isset($_POST["sample"]) && intval($_POST["sample"]) > 0){
		$number_of_sample_samples = intval($_POST["sample"]);
	}else $number_of_sample_samples = 150;
	$number_of_distinct_samples;
	if (isset($_POST["size"]) && intval($_POST["size"]) > 0){
		$number_of_distinct_samples = intval($_POST["size"]);
	}
	if (isset($number_of_distinct_samples)){
		if ($number_of_sample_samples > $number_of_distinct_samples) $number_of_sample_samples = $number_of_distinct_samples;
	}
	
	// starting new session, in order to keep the same seed for random generator
	pg_query($conn, "begin");
        
	// creating queries for nutrients
        $subquery = "";
        if (isset($nutrients)&&strlen($nutrients)>0){
            $subquery = "(SELECT z_abbreviation_de as abbreviation, quantity ".
                                "from d_feed, ".$_SESSION["data_source"].", d_nutrient, d_origin, d_time ".
                                "where ".$_SESSION["data_source"].".id_feed_fkey = d_feed.feed_key ".
                                "and ".$_SESSION["data_source"].".id_nutrient_fkey=d_nutrient.nutrient_key ".
                                "and ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
                                "and ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key ";
                                if ($_SESSION["data_source"] == "fact_table") $nutrients_select .= "and d_m_b<> true ";
            $subquery .= $where.")";
        }
        
        //creating queries for derived nutrients
        
        if (isset($derived_nutrients)&&strlen($derived_nutrients)>0){
                $select_abbr =  "select abbr from t_formula ".       
                                "where (id in ($derived_nutrients)) ".
                                "order by abbr";
                $abbrresult = pg_query($conn, $select_abbr); if (!$abbrresult) die('Invalid query: ' . pg_error());
                $abbrrows   = pg_numrows($abbrresult);
                
                $dnquery =  "SELECT d_feed.name_de, id_feed_fkey, (CASE WHEN canton IS NULL THEN ''Not Available'' ELSE canton END) AS canton, max(CASE WHEN t_day IS NULL THEN to_date(t_year||''-01-01'', ''YYYY-MM-DD'') ELSE t_day END) AS t_day, lims_number, avg(quantity) as quantity ".
                                "FROM d_feed, ".$_SESSION["data_source"].", d_nutrient, d_origin, d_time ".
                                "WHERE ".$_SESSION["data_source"].".id_feed_fkey = d_feed.feed_key ".
                                "AND ".$_SESSION["data_source"].".id_nutrient_fkey = d_nutrient.nutrient_key ".
                                "AND ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
                                "AND ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key ";
                                if ($_SESSION["data_source"] == "fact_table") $dnquery .= "AND d_m_b <> true ";
                                $dnquery .= getDNWhereStatement();

                    for ($d = 0; $d < $abbrrows; $d++) {
                        if ((isset($nutrients)&&strlen($nutrients)>0)||($d>0)) {
                            $subquery .= " UNION ";
                        }
                        $abbr = pg_fetch_array($abbrresult, $d);
                        $subquery .= "(SELECT k as abbreviation, m as quantity " .
                                        "FROM nnjx('".$dnquery."', '".$abbr['abbr']."'))";
                    }
        }
        
	// setting the seed for random number generator
	pg_query($conn, "select setseed(0.123)");

	// creating subquery to retrieve uniform samples of lims samples which satisfy the query condition
	$select_data_subquery = "SELECT * FROM (SELECT distinct lims_number ".
                                    	"FROM d_feed, ".$_SESSION["data_source"].", d_nutrient, d_origin, d_time ".
                                    	"WHERE ".$_SESSION["data_source"].".id_feed_fkey = d_feed.feed_key ".
                                    	"and ".$_SESSION["data_source"].".id_nutrient_fkey=d_nutrient.nutrient_key ".
                                    	"and ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
                                    	"and ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key ";
				     	if ($_SESSION["data_source"] == "fact_table") $select_data_subquery .=  "and d_m_b<> true ";
					$select_data_subquery .= $where.") as all_lims ORDER BY RANDOM() LIMIT ".$number_of_sample_samples;

	// creating the query
        $select_data_query = "SELECT z_abbreviation_de, count(quantity), min(quantity), max(quantity), avg(quantity), stddev_samp(quantity)";
        $select_data_query .= " from d_feed, ".$_SESSION["data_source"].", d_nutrient, d_origin, d_time ".
			"where ".$_SESSION["data_source"].".id_feed_fkey = d_feed.feed_key ".
			"and ".$_SESSION["data_source"].".id_nutrient_fkey=d_nutrient.nutrient_key ".
			"and ".$_SESSION["data_source"].".id_origin_fkey = d_origin.origin_key ".
			"and ".$_SESSION["data_source"].".id_time_fkey = d_time.time_key ";
			if ($_SESSION["data_source"] == "fact_table") $select_data_query .= "and d_m_b<> true ";
	$select_data_query .= "and lims_number in (".$select_data_subquery.") ";
	$select_data_query .= $where." GROUP BY z_abbreviation_de ORDER BY z_abbreviation_de";
        
	$result = pg_query($conn, $select_data_query); if (!$result) die('Invalid query: ' . pg_error());
	$rows   = pg_numrows($result);

	if ($rows > 0){
		// outputing header
		echo '{"cols":[{"id":"nutrient", "label":"Nutrient", "type":"string"},{"id":"count","label":"Count","type":"number"},{"id":"min","label":"Min","type":"number"},{"id":"max", "label":"Max", "type":"number"},{"id":"avg", "label":"Avg", "type":"number"},{"id":"stdev","label":"2&sigma;","type":"number"}, {"id":"m.stdev", "label":"avg(&mu;< -&sigma;)", "type":"number"},{"id":"a.stdev", "label":"avg(&mu;&plusmn;&sigma;)", "type":"number"},{"id":"p.stdev", "label":"avg(&mu;> +&sigma;)", "type":"number"}],"rows":[';

		// outputing data
		for ($i = 0; $i < $rows; $i++){
			$row  = pg_fetch_array($result, $i);

			if (isset($row[0])) $abbr = $row[0];
			else $abbr = 'n/a';

			if ($i != 0) echo ",";
			echo '{"c":[{"v":'.json_encode($abbr).'},{"v":'.number_format(floatval($row[1]),3,".","").', "f":'.json_encode(number_format(floatval($row[1]),0)).'},{"v":'.number_format(floatval($row[2]),3,".","").', "f":'.json_encode(number_format(floatval($row[2]),3)).'},{"v":'.number_format(floatval($row[3]),3,".","").', "f":'.json_encode(number_format(floatval($row[3]),3)).'},{"v":'.number_format(floatval($row[4]),3,".","").', "f":'.json_encode(number_format(floatval($row[4]),3)).'},{"v":'.number_format(floatval($row[5]),3,".","").', "f":'.json_encode(number_format(floatval($row[5]),3)).'}, {"v":null, "f":null}, {"v":null, "f":null}, {"v":null, "f":null}]}';
		}
		echo ']}';
	}

	// closing session
	pg_query($conn, "end");

	// closing connection
	pg_close($conn);

	exit;
?>
