<?php
	require './db_info.php';
	require './ajax-pg-query-where.php';
	
	$where = getWhereStatement();
	
	// creating queries    
	$sql_select = "SELECT z_abbreviation_de, count(quantity), min(quantity), max(quantity), avg(quantity), stddev_samp(quantity)";
	$sql_orderBy = " GROUP BY z_abbreviation_de ORDER BY z_abbreviation_de";
	$c = $sql_select." from d_feed, fact_table, d_nutrient, d_origin, d_time ".
			"where fact_table.id_feed_fkey = d_feed.feed_key ".
			"and fact_table.id_nutrient_fkey=d_nutrient.nutrient_key ".
			"and fact_table.id_origin_fkey = d_origin.origin_key ".
			"and fact_table.id_time_fkey = d_time.time_key and d_m_b<>true ".$where.$sql_orderBy;

	//  Connection to PostgreSQL-DB
	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());

	$result = pg_query($conn, $c);
	if(!$result){
		echo "Error: query wasn't successful (no result)";
	}else{
		$numrows = pg_numrows($result);

		$string = null;
		for($i = 0; $i < $numrows; $i++){
			$row = pg_fetch_array($result, $i);
			$string .= '-sep-'.$row[0];
			//add next value: converted to float, set to 3 decimal places.
			$string .= '-s-'.number_format(floatval($row[2]),3);
			$string .= '-s-'.number_format(floatval($row[3]),3);
			$string .= '-s-'.number_format(floatval($row[4]),3);
			$string .= '-s-'.number_format(floatval($row[5]),3);
			$string .= '-s-'.$row[1];

		}
		echo $string;
	}

	pg_close($conn);
?>
