<?php
	class Nutrient{
		var $nid     = "";
		var $nparent = "";
		var $nname   = "";

		function Nutrient($nid_, $nparent_, $nname_){
			$this->nid     = $nid_;
			$this->nparent = $nparent_;
			$this->nname   = $nname_;
		}
	}

	function printNutrients($parents, $parent_){
		if (isset($parents[$parent_])){
			foreach ($parents[$parent_] as $i => $value) {
				if (isset($parents[$i])){
					echo "<li id=".$parents[$parent_][$i]->nid."  title='". $parents[$parent_][$i]->nname. "'><a href='#'>".$parents[$parent_][$i]->nname."</a><ul>";
					echo printNutrients($parents, $i);
					echo "</ul></li>";
				}else { 
					echo "<li id=".$parents[$parent_][$i]->nid."  title='". $parents[$parent_][$i]->nname. "'><a href='#'>".$parents[$parent_][$i]->nname."</a></li>";
				}
			}
		}
	}

	require './db_info.php';
	require './session_info.php';	
         
	// connecting to the database
	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());

	// a two dimensional array where the primary key is the parent_id
	$parents = array();

	// selecting all nutrients
	$select_nutrients = "select distinct z_id as id, z_name_".$_SESSION['lng']." as name, z_group_id as group_id, z_specie_id as specie_id, z_order from d_nutrient where z_id is not null and z_specie_id is not null and z_group_id is not null order by z_order;";
	$result = pg_query($conn, $select_nutrients); if (!$result) die('Invalid query: ' . pg_error());	
	$rows   = pg_numrows($result);
	echo $rows.",";
	for ($i = 0; $i < $rows; $i++){
		$row    = pg_fetch_array($result, $i);
		$id     = $row['id'];
		$name   = $row['name'];
		$name   = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');
		$group  = $row['group_id'];
		$specie = $row['specie_id'];

		if (!isset($parents['-g-'.$group.'-g-s'.$specie])){
			$parents['-g-'.$group.'-g-s'.$specie] = array();
		}
		$parents['-g-'.$group.'-g-s'.$specie][''.$id.''] = new Nutrient($id, '-g-'.$group.'-g-s'.$specie, $name);
	}

	// selecting specie names and forming the root level of the tree
	$select_species = "select distinct z_specie_id, z_specie_name_".$_SESSION['lng']." as name from d_nutrient where z_id is not null and z_specie_id is not null and z_group_id is not null order by z_specie_id";
	$result = pg_query($conn, $select_species); if (!$result) die('Invalid query: ' . pg_error());
	$rows   = pg_numrows($result);
	for ($i = 0; $i < $rows; $i++){
		$row  = pg_fetch_array($result, $i);
		$id   = $row['z_specie_id'];
		$name = $row['name'];		
		$name = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');

		if (!isset($parents[''])){
			$parents[''] = array();
		}
		$parents['']['-g-s'.$id] = new Nutrient('-g-s'.$id, '', $name);
	}

	// selecting disting group names for each specie
	$select_groups = "select distinct z_group_id as id, z_specie_id as specie_id, group_".$_SESSION['lng']." as name from d_nutrient where z_id is not null and z_specie_id is not null and z_group_id is not null order by group_".$_SESSION['lng'].";";
	$result = pg_query($conn, $select_groups); if (!$result) die('Invalid query: ' . pg_error());
	$rows   = pg_numrows($result);
	for ($i = 0; $i < $rows; $i++){
		$row = pg_fetch_array($result, $i);
		$id  = $row['id'];
		$specie = $row['specie_id'];
		$name = $row['name'];		
		$name = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');

		if (!isset($parents['-g-s'.$specie])){
			$parents['-g-s'.$specie] = array();
		}
		$parents['-g-s'.$specie]['-g-'.$id.'-g-s'.$specie] = new Nutrient('-g-'.$id.'-g-s'.$specie, '-g-s'.$specie, $name);
	}

	printNutrients($parents, '');
    
	unset($parents);
	pg_close($conn);
?>
