<?php
	ob_start();
	require './db_info.php';
    	require './session_info.php';
	ob_end_clean();

	// getting input parameters
	$selected_classified_feeds   = $_POST["cf"];
	$selected_unclassified_feeds = $_POST["uf"];
	$selected_agridea_feeds      = $_POST["af"];
	$selected_nutrients          = $_POST["nt"];
	
	// connecting to the database
	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());

	// selecting and preparing the result for jstree, i.e., as xml nodes
	$select_year = "select distinct d_time.t_year as name from d_time where d_time.moment = 1 and d_time.time_key in (select distinct time_key from ";
			if ($_SESSION["data_source"] === "fact_table") $select_year .= "vr_cube where ";
			else $select_year .= "vc_cube where ";

	$search_feeds = FALSE;

	if(isset($selected_unclassified_feeds)&&strlen($selected_unclassified_feeds)>0){
		if ($search_feeds) $select_year .= " or feed_key in ($selected_unclassified_feeds)";
		else {
			$select_year .= "(feed_key in ($selected_unclassified_feeds)";
			$search_feeds = TRUE;
		}
	}

	if(isset($selected_agridea_feeds)&&strlen($selected_agridea_feeds)>0){
		if ($search_feeds) $select_year .= " or feed_key in ($selected_agridea_feeds)";
		else {
			$select_year .= "(feed_key in ($selected_agridea_feeds)";
			$search_feeds = TRUE;
		}
	}

	if(isset($selected_classified_feeds)&&strlen($selected_classified_feeds)>0){
		if ($search_feeds) $select_year .= " or feed_key in ($selected_classified_feeds)";
		else {
			$select_year .= "(feed_key in ($selected_classified_feeds)";
			$search_feeds = TRUE;
		}
	}

	if ($search_feeds) $select_year .= ")";


	if(isset($selected_nutrients)&&strlen($selected_nutrients)>0){
		$select_year .= " and (nutrient_key in ($selected_nutrients))";
	}	
        
	// the above enclose part do not work **************
        if(isset($selected_derived_nutrients)&&strlen($selected_derived_nutrients)>0){
            $selected_derived_nutrients = explode(",", $selected_derived_nutrients);
            for($i=0; $i<count($selected_derived_nutrients); $i++){
                $formula = pg_query($conn, "select formula from t_formula where id=".$selected_derived_nutrients[$i]);
                $formula = pg_fetch_row($formula);
                $dnutrients = pg_query($conn, "SELECT getallinvolvedabbreviationsnnj('".$formula[0]."')");
                $dnutrients = pg_fetch_row($dnutrients);
                if((isset($selected_nutrients)&&strlen($selected_nutrients)>0)||$i>0) {
                    $select_year .= " or ";
                }
                $select_year .= " (d_nutrient.abbreviation_de=ANY('$dnutrients[0]'::text[]))";
            }
	}
	// *************************************************	
	
	$select_year .= ") order by d_time.t_year;";

	$result = pg_query($conn, $select_year);
	if (!$result){
                die('Invalid query: ' . pg_error());
        }

	$rows   = pg_numrows($result);
	echo "$rows,";
	for ($i = 0; $i < $rows; $i++){
		$row         = pg_fetch_array($result, $i);
		$name        = $row['name'];

		if (isset($name)) $name = htmlspecialchars($name, ENT_COMPAT, 'UTF-8');
		else $name = "n/a";

		echo "<li id='$name'><a href='#'>$name</a></li>";
	}
	pg_close($conn);
?>
