<?php
	ob_start();
	require './db_scripts/session_info.php';
	require './db_scripts/db_info.php';
	ob_end_clean();

	// connecting to the database
	$conn = pg_connect("host=$host port=$port dbname=$database user=$username password = $password") or die  ('Error connecting to Postgres');
	if (!$conn) die('Not connected : ' . pg_error());
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<meta http-equiv="cache-control" content="no-cache">
		<meta http-equiv="pragma" content="no-cache">
		<script type="text/javascript" src="http://cdn.jquerytools.org/1.2.7/full/jquery.tools.min.js"></script>
		<link rel="stylesheet" type="text/css"  href="layout_resources/css/main-12.css">
		<link rel="stylesheet" type="text/css"  href="layout_resources/css/tabs-11.css">
		<link rel="stylesheet" type="text/css"  href="layout_resources/css/login-11.css">
		<link rel="stylesheet" type="text/css"  href="layout_resources/css/messages-11.css">
		<link rel="stylesheet" type="text/css"  href="layout_resources/css/feed_table.css">
	</head>

	<body>
		<div id="active_body"> 
			<div id="header">
				<a href="index.php" style="text-decoration: none; border:0px"><img style="border:0px" src="layout_resources/images/header.jpg"></a>
			</div>			

			<div class="title_block" style="border-width: 0px 0px 0px 0px;">
				<?php
					if ($_SESSION["lng"] == "de"){
						echo "Die verwendeten Namen/Bezeichnungen der Futtermittel, die regional oder national unterschiedlich sein können, ".
							"beziehen sich auf die Situation in der Schweiz. Wenn mehr als ein Name erwähnt wird, gilt der Erste als der ".
							"Gebräuchlichste oder Eindeutigste, und in den Klammern {} sind synonym verwendete Begriffe angegeben.";
						echo "<ul>".
  							"<li><a href=\"layout_resources/lng/Glossar_Wiesenbestaende_Charakterisierung.pdf\" target=\"_blank\">Wiesenbestand: Charakterisierung (Tabelle pdf)</a></li>".
							"<li><a href=\"layout_resources/lng/Glossar_Wiesenbestaende_Merkmale.pdf\" target=\"_blank\">Wiesenbestand: Entwicklungsstadien (Tabelle pdf)</a></li>".
							"</ul>";
					}else if ($_SESSION["lng"] == "en"){
						echo "Die verwendeten Namen/Bezeichnungen der Futtermittel, die regional oder national unterschiedlich sein können, ".
							"beziehen sich auf die Situation in der Schweiz. Wenn mehr als ein Name erwähnt wird, gilt der Erste als der ".
							"Gebräuchlichste oder Eindeutigste, und in den Klammern {} sind synonym verwendete Begriffe angegeben.";
						echo "<ul>".
  							"<li><a href=\"layout_resources/lng/Glossar_Wiesenbestaende_Charakterisierung.pdf\" target=\"_blank\">Wiesenbestand: Charakterisierung (Tabelle pdf)</a></li>".
							"<li><a href=\"layout_resources/lng/Glossar_Wiesenbestaende_Merkmale.pdf\" target=\"_blank\">Wiesenbestand: Entwicklungsstadien (Tabelle pdf)</a></li>".
							"</ul>";
					}else if ($_SESSION["lng"] == "fr"){
						echo "La dénomination et spécification des aliments pour animaux, qui peuvent varier selon la région ou le pays ".
							"se basent sur les normes suisses. Si plus d' un terme est indiqué, le premier est considéré ".
							"comme le plus courant ou le plus évident. Entre parenthèses {} sont mentionnés les termes synomymes.";
						echo "<ul>".
							"<li><a href=\"layout_resources/lng/Glossaire_Caracteristiques_des_types_de_prairie.pdf\" target=\"_blank\">Caract&eacute;ristiques des types de prairie (tableau pdf)</a></li>".
							"<li><a href=\"layout_resources/lng/Glossaire_Estimation_du_stade_de_developpement.pdf\" target=\"_blank\">Estimation du stade de d&eacute;veloppement des prairies (tableau pdf)</a></li>".
							"</ul>";
					}
				?>
			</div>

			<div class="title_block" style="border-width: 0px 0px 0px 0px;">
				<h2 align="center"><a name="feeds"></a><?php echo $_terms["feed"];?></h2>
				<table class="feed_table">
					<tr><th><b><?php echo $_terms["name"];?></b></th><th><b><?php echo $_terms["group"];?></b></th></tr>
					<?php 
						$select_feed = "select distinct name_".$_SESSION['lng']. " as name, feed_group_".$_SESSION['lng']." as feed_group ".
						"from d_feed where feed_group_".$_SESSION['lng']." is not null and name_".$_SESSION['lng']." is not null order by name";

						$result = pg_query($conn, $select_feed); 
						if (!$result) die('Invalid query: ' . pg_error());
						$rows   = pg_numrows($result);

						for($i=0; $i<$rows; $i++){
							$row  = pg_fetch_array($result, $i);
							echo "<tr> <td> $row[0] </td> <td> $row[1] </td> </tr> ";
						}
					?>
				</table>
			</div>

			<div class="title_block" style="border-width: 0px 0px 0px 0px;">
				<h2 align="center"><a name="nutrients"></a><?php echo $_terms["nutrients"];?></h2>
				<table class="feed_table">
					<tr><th><b><?php echo $_terms["abbreviation"];?></b></th><th><b><?php echo $_terms["description"];?></b></th></tr>
					<?php
						$select_nutrient = "select distinct z_abbreviation_".$_SESSION['lng']. " as abbreviation, z_name_".$_SESSION['lng']." as name " .
					    	"from d_nutrient where z_abbreviation_".$_SESSION['lng']." is not null and z_name_".$_SESSION['lng']." is not null order by name";

						$result = pg_query($conn, $select_nutrient); 
						if (!$result) die('Invalid query: ' . pg_error());
						$rows   = pg_numrows($result);

						 for($i=0; $i<$rows; $i++){
							$row  = pg_fetch_array($result, $i);
							echo "<tr> <td> $row[0] </td> <td> $row[1] </td> </tr> ";
						} 
					?>
				</table>
			</div>

			<div id="footer">
		                <div style="display:inline;float:left">
                		    <label>© Universität Zürich, Agroscope, 2011-2013</label>
		                </div>
				<a href="#" style="text-decoration:none;color:#777777;font-size:1.2em" class="navigation_menu"></a>
		       </div>
		</div>

		<div id="navigation_overlay" style="width:110px;height:45px;background-color:#fff;border:1px solid #aaa;">
			<div class="close" style="display:none"></div>
			<ul style="padding:0px 0px 0px 15px;margin:3px">
				<li><a href="#feeds"><?php echo $_terms["feed"];?></a></li>
				<li><a href="#nutrients"><?php echo $_terms["nutrients"];?></a></li>
			</ul>
		</div>

		<script>
			$(document).ready(function(){
				$("#navigation_overlay").overlay({closeOnClick: false, closeOnEsc: false, load: true, left:0, top:'50%'});
			});
		</script>
	</body>
</html>
<?php
	pg_close($conn);
	exit;
?>
