function setControls(map){
	var controlDiv = document.createElement("div");
	controlDiv.style.border = "1px solid rgb(113,123,135)";
	controlDiv.style.boxShadow = "rgba(0,0,0,0.398438) 0px 2px 4px";
	controlDiv.style.backgroundColor = "rgb(255,255,255)";
	controlDiv.style.margin = "5px";
	
	for (var i = 0; i < 4; i++){		
		var div = document.createElement("div");		
		div.id = "_maps_div_"+i;
		div.style.fontFamily = "Arial, sans-serif";
		div.style.fontSize = "11px";
		div.style.padding = "3px 5px";
		div.style.textAlign = "left";		
		if (i > 0) div.style.borderTop = "1px solid rgb(113,123,135)";
		else div.style.cursor = "pointer";
		controlDiv.appendChild(div);		
		
		var span = document.createElement("span");
		span.style.boxSizing = "border-box";
		span.style.position = "relative";
		span.style.lineHeight = "0";
		span.style.fontSize = "0px";
		span.style.marginRight = "5px";
		if (i == 0) span.style.display = "none";
		else span.style.display = "inline-block";
		span.style.border = "1px solid rgb(198,198,198)";
		span.style.width = "13px";
		span.style.height = "13px";
		span.style.verticalAlign = "middle";
		span.style.backgroundColor = "rgb(255,255,255)";
		div.appendChild(span);
		
		if (i != 0){
			var innerDiv = document.createElement("div");
			innerDiv.style.position = "absolute";
			innerDiv.style.left = "1px";
			innerDiv.style.top = "-2px";
			innerDiv.style.width = "13px";
			innerDiv.style.height = "11px";
			innerDiv.style.overflow = "hidden";
			innerDiv.id = "map_vis" + i;
			innerDiv.style.cursor = "pointer";
			span.appendChild(innerDiv);

			if (i == 1) google.maps.event.addDomListener(innerDiv, 'click', toggleDensity);
			if (i == 2) google.maps.event.addDomListener(innerDiv, 'click', toggleRegression);
			if (i == 3) google.maps.event.addDomListener(innerDiv, 'click', toggleMarkers);
		
			var img = document.createElement("img");
			img.src = "http://maps.gstatic.com/mapfiles/mv/imgs8.png";
			img.style.position = "absolute";
			img.style.left = "-52px";
			img.style.top = "-44px";
			img.style.width = "68px";
			img.style.height = "67px";
			img.id = "map_vis_img" + i;
			if (i == 1 || i == 2) {
				img.style.visibility = "hidden";
			}else img.style.visibility = "visible";
			innerDiv.appendChild(img);
		}
		
		var label = document.createElement("label");
		label.style.verticalAlign = "middle";
		if (i == 0){
			label.innerHTML = mes_show_visualisation_option;
			label.style.cursor = "pointer";
		}else if (i == 1){
			label.innerHTML = mes_show_density_option;
		}else if (i == 2){
			label.innerHTML = mes_show_regression_option;
		}else if (i == 3){
			label.innerHTML = mes_show_flags_option;
		}
		div.appendChild(label);

		if (i == 2){
			var select_n = document.createElement("select");
			select_n.id = "_maps_div_2_nutrients";
			div.appendChild(select_n);
			$(select_n).html($("#dd_charts_nutrient_a").html().substring($("#dd_charts_nutrient_a").html().indexOf("</option>") + 9));
			$(select_n).find("option").each(function (index){
				var col_i = parseInt($(this).attr("value"));
				$(this).attr("value", query_result.getColumnId(col_i).substring(8));				
			});

			google.maps.event.addDomListener(select_n, 'change', function(){
				var img = document.getElementById("_maps_div_2").getElementsByTagName("span")[0].getElementsByTagName("div")[0].getElementsByTagName("img")[0];
				if (img.style.visibility == "visible") {
					glob_regr_nutrient = $("#_maps_div_2_nutrients").val();
					g_regressionMap.show(glob_regr_nutrient);			
				}
			});
		}
		
		
		google.maps.event.addDomListener(div, 'mouseover', function() {
			this.getElementsByTagName("span")[0].style.borderColor = "rgb(102,102,102)";
			this.style.backgroundColor = "rgb(235,235,235)";
		});
		google.maps.event.addDomListener(div, 'mouseout', function() {
			this.getElementsByTagName("span")[0].style.borderColor = "rgb(198,198,198)";
			this.style.backgroundColor = "rgb(255,255,255)";
		});
	}
	
	map.controls[google.maps.ControlPosition.TOP_CENTER].push(controlDiv);
	$(controlDiv).children("[id!='_maps_div_0']").hide();

	$(controlDiv).children("[id='_maps_div_0']").bind('click', function() {
		if ($(controlDiv).children("[id!='_maps_div_0']:visible").length == 0){
			$(controlDiv).children("[id!='_maps_div_0']").show();
		}else{
			$(controlDiv).children("[id!='_maps_div_0']").hide();
		}
	});

	// color legend
	var color_legend = document.createElement('div');
	color_legend.id = "_maps_div_color_legend";
	color_legend.style.borderStyle = "none";
	color_legend.style.borderWidth = "0px";
	color_legend.style.display = "none";
	
	var top_label = document.createElement('label');
	top_label.id = "_maps_div_top_label";
	top_label.style.display = "block";
	top_label.innerHTML = "";
	top_label.style.verticalAlign = "middle";
	color_legend.appendChild(top_label);	
	
	var canvas = document.createElement("canvas");
	canvas.id = "_maps_div_canvas";
	canvas.style.display = "block";
	//canvas.style.width = "100%";
	//canvas.style.height = "100%";
	canvas.width  = "20";
	canvas.height = "120";
	color_legend.appendChild(canvas);	

	if ($.browser.msie){
	  	if (parseInt($.browser.version, 10) < 9){
			canvas = G_vmlCanvasManager.initElement(canvas);			
		}
	}
	var ctx=canvas.getContext('2d');


	// Create Linear Gradients
    	var lingrad = ctx.createLinearGradient(0,0,0,120);
    	lingrad.addColorStop(0, '#FF0000');
	lingrad.addColorStop(0.25, '#ffff00');
	lingrad.addColorStop(0.5, '#00FF00');
	lingrad.addColorStop(0.75, '#00FFFF');
	lingrad.addColorStop(1, '#0000FF');

    	// assign gradients to fill and stroke styles
	ctx.fillStyle = lingrad;
	//ctx.fillStyle = 'rgb(200, 0, 255)';
	ctx.fillRect(0,0,20,120);

	var bottom_label = document.createElement('label');
	bottom_label.id = "_maps_div_bottom_label";
	bottom_label.style.display = "block";
	bottom_label.innerHTML = "";
	bottom_label.style.verticalAlign = "middle";
	color_legend.appendChild(bottom_label);
	map.controls[google.maps.ControlPosition.LEFT_BOTTOM].push(color_legend);
}

function toggleDensity(e) 
{
	var img = document.getElementById("_maps_div_1").getElementsByTagName("span")[0].getElementsByTagName("div")[0].getElementsByTagName("img")[0];
	if (img.style.visibility == "hidden") {		
		g_densityMap.show();
		img.style.visibility = "visible";		

		// hidding regression
		g_regressionMap.hide();
		document.getElementById("_maps_div_2").getElementsByTagName("span")[0].getElementsByTagName("div")[0].getElementsByTagName("img")[0].style.visibility = "hidden";

		if(!g_densityMap.isCalculated()){
        		g_densityMap.calculateImage();
		}

		$("#_maps_div_color_legend").show();
		glob_show_density = "true";
	} else {
		g_densityMap.hide();
		img.style.visibility = "hidden";
		$("#_maps_div_color_legend").hide();
		glob_show_density = "false";
	}
}

function toggleRegression(e){
	var img = document.getElementById("_maps_div_2").getElementsByTagName("span")[0].getElementsByTagName("div")[0].getElementsByTagName("img")[0];
	if (img.style.visibility == "hidden") {
		glob_regr_nutrient = $("#_maps_div_2_nutrients").val();
		g_regressionMap.show(glob_regr_nutrient);
		img.style.visibility = "visible";

		// hidding density
		g_densityMap.hide();
		document.getElementById("_maps_div_1").getElementsByTagName("span")[0].getElementsByTagName("div")[0].getElementsByTagName("img")[0].style.visibility = "hidden";
		$("#_maps_div_color_legend").show();
		glob_show_regression = "true";
	}else {
		g_regressionMap.hide();
		img.style.visibility = "hidden";
		$("#_maps_div_color_legend").hide();
		glob_show_regression = "false";
	}
}

function toggleMarkers(e) 
{
	var img = document.getElementById("_maps_div_3").getElementsByTagName("span")[0].getElementsByTagName("div")[0].getElementsByTagName("img")[0];
	if (img.style.visibility == "hidden") {
		showAllMarkers();
		img.style.visibility = "visible";
		glob_show_flags = "true";
	} else {
		hideAllMarkers();
		img.style.visibility = "hidden";
		glob_show_flags = "false";
	}
}

function isDensityOnMapSelected(){
	if ($("#map_vis_img1").length == 0) return false;

	if ($("#map_vis_img1").css("visibility") == "hidden") return false;
	else return true;
}

function isFlagsOnMapSelected(){
	if ($("#map_vis_img3").length == 0) return false;

	if ($("#map_vis_img3").css("visibility") == "hidden") return false;
	else return true;
}

function isRegressionOnMapSelected(){
	if ($("#map_vis_img2").length == 0) return false;

	if ($("#map_vis_img2").css("visibility") == "hidden") return false;
	else return true;
}

function restoreMapVisualisationOptions(){
	if (glob_show_flags.length > 0 && ($("#map_vis_img3").length != 0)){						
		if ((glob_show_flags === "true" && !isFlagsOnMapSelected())||
			(glob_show_flags === "false" && isFlagsOnMapSelected())) toggleMarkers(); 
	}
	if (glob_show_density.length > 0 && ($("#map_vis_img1").length != 0)){
		if ((glob_show_density === "true" && !isDensityOnMapSelected())||
			(glob_show_density === "false" && isDensityOnMapSelected())) toggleDensity();
	}
	if (glob_regr_nutrient.length > 0 && $("#_maps_div_2_nutrients").length != 0 && $("#_maps_div_2_nutrients").val() != glob_regr_nutrient){
		$("#_maps_div_2_nutrients").val(glob_regr_nutrient);
	}
	if (glob_show_regression.length > 0 && ($("#map_vis_img2").length != 0)){	
		if ((glob_show_regression === "true" && !isRegressionOnMapSelected())||
			(glob_show_regression === "false" && isRegressionOnMapSelected())) toggleRegression();
	}
}
