// a sort of class/object to deal with search options.
// where div_id is a div_id that is treated as a jstree,
// and url where to get the data from
function SearchOption(div_id_par, url_par){
    this.div_id         = div_id_par;
    this.count          = 0;
    this.count_selected = 0;
    this.loading        = false;
    this.url            = url_par;
    this.selected       = "";
    this.selected_names = "";    
}

// resets a search option
function reset_search_option(search_option){
    $(search_option.div_id).jstree("destroy");
    $(search_option.div_id).html("");
    search_option.count          = 0;
    search_option.count_selected = 0;
    search_option.loading        = false;
    search_option.selected       = "";
    search_option.selected_names = "";
    $(search_option.div_id).bind("loaded.jstree", function (event, data) {
	//$(td_classified_feeds2.div_id).find('.jstree-closed,.jstree-checked > .jstree-icon').click();
	//$(td_classified_feeds2.div_id).find('.jstree-closed,.jstree-undetermined > .jstree-icon').click();
	get_selected_options(search_option);
    }); 
}

// search options
var selected_data_type        = "t";
var selected_fresh_matter     = "false";
var selected_data_source      = "2";
var td_unclassified_feeds     = new SearchOption("#td_select_unclassified_feeds", "web_templates/td_unclassified_feeds.php");
var td_agridea_feeds          = new SearchOption("#td_select_agridea_feeds", "web_templates/td_agridea_feeds.php");
var td_classified_feeds1      = new SearchOption("#td_select_classified_feeds1", "");
var td_classified_feeds2      = new SearchOption("#td_select_classified_feeds2", "");
var td_nutrients_options      = new SearchOption("#td_select_nutrients", "db_scripts/get_td_nutrients.php");
var td_der_nutrients_options  = new SearchOption("#td_select_nutrients_derived", "db_scripts/get_td_nutrients_derived.php");
var td_geo_canton             = new SearchOption("#td_geo_canton", "db_scripts/get_td_cantons.php");
var td_geo_altitude           = new SearchOption("#td_geo_altitude", "db_scripts/get_td_altitude.php");
var td_time_year              = new SearchOption("#td_time_year", "");
var td_time_season            = new SearchOption("#td_time_season", "");
var sd_nutrients_options      = new SearchOption("#sd_select_nutrients", "web_templates/sd_nutrients.php");
var sd_der_nutrients_options  = new SearchOption("#sd_select_nutrients_derived", "db_scripts/get_sd_nutrients_derived.php");
var sd_feeds_options1         = new SearchOption("#sd_select_classified_feeds1", "web_templates/sd_classified_feeds1.php");
var sd_feeds_options2         = new SearchOption("#sd_select_classified_feeds2", "web_templates/sd_classified_feeds2.php");
var selected_radius           = new String("");
var glob_show_flags           = "";
var glob_show_density         = "";
var glob_show_regression      = "";
var glob_regr_nutrient        = "";
var glob_charts_na            = "";
var glob_charts_nb            = "";
var glob_charts_nc            = "";
var glob_stats_sel            = "";
var glob_comp_pars            = "";

//for temporal debug
var get_sd_script = "get_sd_data.php";

// creates empty http object
function getHttpObject(){
	var xhr = false;

	if (window.ActiveXObject){
		try{
			xhr = new ActiveXObject("Msxml2.XMLHTTP");
		}catch(e){
			try{
				xhr = new ActiveXObject("Microsoft.XMLHTTP");
			}catch(e) {
				xhr = false;
			}
		}
	}else if (window.XMLHttpRequest){
		xhr = new XMLHttpRequest();
	}

	if (!xhr){
		alert("Your browser does not support AJAX.");
		return null;
	}else return xhr;
}


String.prototype.truncate = function(length) {
  if (this.length > length) {
    return this.slice(0, length - 3) + "...";
  } else {
    return this;
  }
};

// returns query paramaters as a single string
function getQueryParameters(query_id){
	if (query_id == -1){
		var parameters = "dt=" + selected_data_type + "&dts=" + selected_data_source + 
					 "&uf=" + td_unclassified_feeds.selected + "&af=" + td_agridea_feeds.selected + "&ct=" + td_geo_canton.selected + "&al=" + td_geo_altitude.selected +
					 "&yeh=" + td_time_year.selected + "&seh=" + td_time_season.selected +					 
					 "&fresh=" + selected_fresh_matter + "&rs=" + selected_radius.value + "&ntd=" + td_der_nutrients_options.selected;

		if (sd_nutrients_options.count_selected > 0) parameters += "&nt=" + sd_nutrients_options.selected;
		else parameters += "&nt=" + td_nutrients_options.selected;

		if (sd_feeds_options1.count_selected > 0 || sd_feeds_options2.count_selected > 0){
			if (sd_feeds_options1.selected.length > 0 && sd_feeds_options2.selected.length > 0){
				parameters += "&cf=" + sd_feeds_options1.selected + "," + sd_feeds_options2.selected;
			}else if (sd_feeds_options1.selected.length > 0){
				parameters += "&cf=" + sd_feeds_options1.selected;
			}else if (sd_feeds_options2.selected.length > 0){
				parameters += "&cf=" + sd_feeds_options2.selected;
			}
		}else {
			if (td_classified_feeds1.selected.length > 0 && td_classified_feeds2.selected.length > 0){
				parameters += "&cf=" + td_classified_feeds1.selected + "," + td_classified_feeds2.selected;
			}else if (td_classified_feeds1.selected.length > 0){
				parameters += "&cf=" + td_classified_feeds1.selected;
			}else if (td_classified_feeds2.selected.length> 0){
				parameters += "&cf=" + td_classified_feeds2.selected;
			}
		}

		if (isDensityOnMapSelected()) parameters += "&dens=true";
		else parameters += "&dens=false";

		if (isFlagsOnMapSelected()) parameters += "&flag=true";
		else if ($("#map_vis_img3").length > 0) parameters += "&flag=false";

		if (isRegressionOnMapSelected()) parameters += "&regr=true";
		else parameters += "&regr=false";

		if ($("#_maps_div_2_nutrients").length > 0) parameters += "&rnut=" + $("#_maps_div_2_nutrients").val();

		if (getSelectedNutrientIdFromChartsA().length > 0) parameters += "&charts_na=" + getSelectedNutrientIdFromChartsA();
		if (getSelectedNutrientIdFromChartsB().length > 0) parameters += "&charts_nb=" + getSelectedNutrientIdFromChartsB();
		if (getSelectedNutrientIdFromChartsC().length > 0) parameters += "&charts_nc=" + getSelectedNutrientIdFromChartsC();

		if ($("#dd_stat_type_select").length > 0) parameters += "&stats_sel=" + $("#dd_stat_type_select").val();

		if ($("#number_of_records_in_result").length > 0 && $("#number_of_records_in_result").val() != 150) parameters += "&sample_size=" + $("#number_of_records_in_result").val();

		parameters    += "&comp_pars=" + one_to_many_comparison_getQueryParams();

		return parameters;
	}else {
		return "qid=" + query_id;
	}
}

// creates http object for the given url. all query parametes are passed using post method
function createHttpObject(url,top_query_id){
	var httpObject = getHttpObject();
	if (httpObject != null){
		var parameters = getQueryParameters(top_query_id);
		httpObject.open("POST", url, true);
		httpObject.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		httpObject.send(parameters);
	}
	return httpObject;
}

function createHttpObjectFromParameters(url, params){
	var httpObject = getHttpObject();
	if (httpObject != null){
		httpObject.open("POST", url, true);
		httpObject.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		httpObject.send(params);
	}
	return httpObject;
}


function send_feedback(){
	var feedback_message = $("#feedback_message").val();
	var feedback_name    = $("input[name=\"feedback_name\"]").val();
	var feedback_reply   = $("input[name=\"feedback_reply\"]").val();

	var httpObject = getHttpObject();
	if (httpObject != null){						
		httpObject.open("POST", "db_scripts/mail_feedback.php", false);
		httpObject.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		httpObject.send("fb_name=" + feedback_name + "&fb_reply=" + feedback_reply + "&fb_mess=" + feedback_message);
		if (httpObject.readyState == 4){
			showSuccessMessage(message_feedback_recieved);
		}
	}
}

function execute_td_query(query_id){
	if (areLoading()) return; // necessary to avoid inconsistency in displaying results
	document.data_type.data_type[0].checked = true;
	if (updateDataType(query_id)){
		output_results(query_id);
	}
}

function execute_sd_query(query_id){
	if (areLoading()) return; // necessary to avoid inconsistency in displaying results
	document.data_type.data_type[1].checked = true;
	if (updateDataType(query_id)){
		output_results(query_id);
	}
}

function save_query(){
	var save_query_description_de = $("input[name=\"save_query_description_de\"]").val() + $("input[name=\"save_query_description_user\"]").val();
	var save_query_description_en = $("input[name=\"save_query_description_en\"]").val();
	var save_query_description_fr = $("input[name=\"save_query_description_fr\"]").val();
	var availability              = $("input[name=save_query_availability]:checked").val();	

	var httpObject = getHttpObject();
	if (httpObject != null){						
		httpObject.open("POST", "db_scripts/save_query.php", false);
		httpObject.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		httpObject.send("dde=" + save_query_description_de + "&den=" + save_query_description_en + "&dfr=" + save_query_description_fr + "&qav=" + availability +  "&" + getQueryParameters(-1));
		if (httpObject.readyState == 4){
			showSuccessMessage(message_query_saved);
			refresh_user_queries();
		}
	}
}

function delete_query(query_id){
	var httpObject = getHttpObject();
	if (httpObject != null){						
		httpObject.open("POST", "db_scripts/delete_query.php", false);
		httpObject.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		httpObject.send("qid=" + query_id);
		if (httpObject.readyState == 4){
			refresh_user_queries();
		}
	}
}

function refresh_user_queries(){
	var api = $("#saved_queries_tabs").data("tabs");
	api.getCurrentPane().load(api.getCurrentTab().attr("href"));
	//var api1 = $("#sponsor_queries_tabs").data("tabs");
	//api1.getCurrentPane().load(api1.getCurrentTab().attr("href"));
	//alert('ss');
}

function showSuccessMessage(mess){
	hideInfoMessage();
	$('#info_message').css('background-color', '#61b832');
	$('#info_message').css('border-color', '#55a12c');
	$('#info_message').html(mess);
	$('#info_message').animate({top:"0"}, 500, function(){$('#info_message').delay(6000).animate({top: -$('#info_message').outerHeight()}, 1000)});
}

function showErrorMessage(mess){
	hideInfoMessage();
	$('#info_message').css('background-color', '#de4343');
	$('#info_message').css('border-color', '#c43d3d');
	$('#info_message').html(mess);
	$('#info_message').animate({top:"0"}, 500, function(){$('#info_message').delay(6000).animate({top: -$('#info_message').outerHeight()}, 1000)});
}

function showWarningMessage(mess){
	hideInfoMessage();
	$('#info_message').css('background-color', '#eaaf51');
	$('#info_message').css('border-color', '#d99a36');
	$('#info_message').html(mess);
	$('#info_message').animate({top:"0"}, 500, function(){$('#info_message').delay(6000).animate({top: -$('#info_message').outerHeight()}, 1000)});
}

function showMessage(mess){
	hideInfoMessage();
	$('#info_message').css('background-color', '#4ea5cd');
	$('#info_message').css('border-color', '#3b8eb5');
	$('#info_message').html(mess);
	$('#info_message').animate({top:"0"}, 500, function(){$('#info_message').delay(6000).animate({top: -$('#info_message').outerHeight()}, 1000)});
}

function hideInfoMessage(){
	var height = $("#info_message").outerHeight();
	$("#info_message").css('top', -height);
}
