// the number of feed samples in the query result
var number_of_feed_samples;
var copy_of_query_parameters;
var id_of_top_query;
// the big array of samples
var query_result = null;
var sorted_rows  = null;
// the array of markers
var distinct_locations = null;
var spread_samples     = null;
var spread_lines       = null;
// the clusters of markers
var marker_cluster          = null;
var selected_zindex         = null;
// for drawing the table
var table_view_query_result = null;
var table_view              = null;
var table_view_options      = null;
// for drawing scatter chart
var view_for_scatter_chart  = null;
var scatter_chart           = null;
var scatter_chart_options   = null;
var chart_was_displayed     = false;
// for drawing line chart
var query_result_time_aggregated = null;
var view_for_line_chart          = null;
var line_chart_options           = null;
// for drawing nutrient statistics
var query_result_nutrient_aggregated  = null;
var table_nutrient_aggregated         = null;
var table_nutrient_options            = null;
var nutrient_aggregated_was_displayed = false;
var selected_nutrient_in_stats        = -1;
// the map and selected sample
var g_map             = null;
var selected_sample   = -1;
var selected_location = -1;
// variable to control the loading
var time_aggregated_loading     = false;
var nutrient_aggregated_loading = false;
var samples_loading             = false;
// unvariying
var normal_marker_icon   = new google.maps.MarkerImage("layout_resources/images/light-red-dot.png", null, null, null, new google.maps.Size(28, 20));
var selected_marker_icon = new google.maps.MarkerImage("layout_resources/images/red-dot.png", null, null, null, new google.maps.Size(40, 30));
var spread_icon          = new google.maps.MarkerImage("layout_resources/images/red.png", null, null, null, new google.maps.Size(35, 30));

function clear_results(){
	if ($("#detailed_data").css("display") == "block"){// if searching throw temporal data		
		releaseVariables();

        	// deleting previous data
	        $("#dd_data").html("Loading...");
        	$("#dd_map").html("Loading...");
	        //$("#dd_stat").html("Loading...");
        	$("#dd_map").css("background", "#ffffff");
	}

	$("#sponsors").css("display","block");
	$("#summary_data").css("display","none");
	$("#detailed_data").css("display","none");
	$("#export_options").css("display","none");
	$("#export_options").attr("topquery", "-1");
	$("#set_sample_size").css("display","none");
	$("#save_query_button").css("display","none");
}

function releaseVariables(){
	id_of_top_query = -1;

	if (query_result != null){
		var prevRows = query_result.getNumberOfRows();
            	if(prevRows != 0) query_result.removeRows(0,prevRows);
            	var prevColumns = query_result.getNumberOfColumns();
            	if (prevColumns != 0) query_result.removeColumns(0, prevColumns);
		query_result = null;
	}

	if (sorted_rows != null){
		sorted_rows.length = 0;
		sorted_rows        = null;
	}

	if (distinct_locations != null){
		for (i in distinct_locations) distinct_locations[i].setMap(null);
		distinct_locations = null;
		marker_cluster  = null;
		selected_zindex = null;
	}

	if (spread_samples != null){
		for (i in spread_samples) spread_samples[i].setMap(null);
		spread_samples = null;
	}

	if (spread_lines != null){
		for (i in spread_lines) spread_lines[i].setMap(null);
		spread_lines = null;
	}

	view_for_scatter_chart  = null;	
	scatter_chart_options   = null;
	if (scatter_chart != null){
		if (chart_was_displayed) scatter_chart.clearChart();
		scatter_chart = null;
	}

	var table_view_query_result = null;
	var table_view_options      = null;
	if (table_view != null){
		table_view.clearChart();
		table_view = null;
	}

	table_nutrient_options     = null;
	selected_nutrient_in_stats = -1;	
	if (table_nutrient_aggregated != null){
		if (nutrient_aggregated_was_displayed) table_nutrient_aggregated.clearChart();
		table_nutrient_aggregated = null;
	}

	if (query_result_time_aggregated != null){
		var prevRows = query_result_time_aggregated.getNumberOfRows();
            	if(prevRows != 0) query_result_time_aggregated.removeRows(0,prevRows);
            	var prevColumns = query_result_time_aggregated.getNumberOfColumns();
            	if (prevColumns != 0) query_result_time_aggregated.removeColumns(0, prevColumns);
		query_result_time_aggregated = null;
	}
	view_for_line_chart = null;
	line_chart_options  = null;

	if (query_result_nutrient_aggregated != null){
		var prevRows = query_result_nutrient_aggregated.getNumberOfRows();
            	if(prevRows != 0) query_result_nutrient_aggregated.removeRows(0,prevRows);
            	var prevColumns = query_result_nutrient_aggregated.getNumberOfColumns();
            	if (prevColumns != 0) query_result_nutrient_aggregated.removeColumns(0, prevColumns);
		query_result_nutrient_aggregated = null;
	}

	selected_sample                   = -1;
	selected_location                 = -1;
	g_map                             = null;
	time_aggregated_loading           = false;
	nutrient_aggregated_loading       = false;
	samples_loading                   = false;
	chart_was_displayed               = false;
	nutrient_aggregated_was_displayed = false;

	$("#dd_charts_nutrtients").css("display","block");
	$("#dd_google_chart").css("display","block");
	$("#dd_region_comparison").css("display", "none");
	$("#dd_many_region_comparison").hide(0, one_to_many_comparison_hide);
	$("#dd_region_comparison").hide(0, one_to_one_comparison_hide);
}

function output_results(top_query_id, _number_of_feed_samples, _sample_size){
	if (top_query_id == -1 && td_nutrients_options.count_selected + sd_nutrients_options.count_selected + td_der_nutrients_options.count_selected == 0){
		showErrorMessage("Please, select at least one feed and one nutrient");
		return;
	}

	$("#sponsors").css("display","block");
	$("#summary_data").css("display","none");
	$("#detailed_data").css("display","none");

	$("#export_options").css("display","block");
	$("#export_options").attr("topquery", top_query_id);

	if (selected_data_type == "t"){// if searching throw temporal data
		releaseVariables();
		id_of_top_query = top_query_id;

        	$("#sponsors").css("display","none");		
		$("#detailed_data").css("display","block");
	        $("#dd_data").html("Loading...");
        	$("#dd_map").html("Loading...");
        	$("#dd_map").css("background", "#ffffff");
		$("#save_query_button").css("display","inline");
        	
		resize_initialize();
	        
		//some hack to make chart scale
		time_aggregated_loading     = true;
		nutrient_aggregated_loading = true;
		samples_loading             = true;

		$("#dd_google_chart").css("display", "block");
		$("#dd_stats_nutrients").css("display", "none");
		$("#dd_region_comparison").css("display", "none");
		$("#dd_many_region_comparison").hide(0, one_to_many_comparison_hide);
		$("#dd_region_comparison").hide(0, one_to_one_comparison_hide);
	        $("#dd_google_chart").html("Loading...");
	        $("#dd_stats_nutrients").html("");
		$("#dd_region_comparison").html("");
		$("#dd_many_region_comparison").html("");

		if (typeof(_sample_size) === 'undefined' || _sample_size < 0) _sample_size = 150;
		
		if(typeof(_number_of_feed_samples)==='undefined' || _number_of_feed_samples < 0 || typeof(number_of_feed_samples) === 'undefined' || number_of_feed_samples < 0){
			copy_of_query_parameters = getQueryParameters(top_query_id);
			google.load("visualization", "1", {packages:["table", "corechart"], callback: function(){load_samples(copy_of_query_parameters + "&sample=" + _sample_size, true);}});		
		}else {
			google.load("visualization", "1", {packages:["table", "corechart"], callback: function(){load_samples(copy_of_query_parameters + "&sample=" + _sample_size + "&size=" + number_of_feed_samples, false);}});			
		}
		//google.load("visualization", "1", {packages:["corechart"], callback: function(){load_time_aggregated(copy_of_query_parameters + "&sample=" + _sample_size + "&size=" + number_of_feed_samples);}});
		
		load_data_for_region_comparison(top_query_id);
		one_to_many_comparison_init(top_query_id);
	}else {// if searching throw aggregated data
		copy_of_query_parameters = getQueryParameters(top_query_id);
		id_of_top_query = top_query_id;
		$("#sponsors").css("display","none");
		$("#summary_data").css("display","block");
		$("#set_sample_size").css("display","none");
		$("#summary_data").html("Loading");
		$("#save_query_button").css("display","inline");
		
		google.load("visualization", "1", {packages:["table"], callback: function(){load_aggregated_data(top_query_id);}});
	}
}

function changeNumberOfRecordsInResult(){
	output_results(id_of_top_query, number_of_feed_samples, $("#number_of_records_in_result").val());
}

function promptSampleSize(){
	var nr_rows = table_view_query_result.getNumberOfRows();
	if (nr_rows == 0){
		$("#set_sample_size").css("display","none");
	}else {
		$("#set_sample_size").css("display","block");
		$("#number_of_records_in_result").val(nr_rows);
		$("#sample_size").text(nr_rows);
		$("#data_size").text(number_of_feed_samples);
	}
}

function load_aggregated_data(top_query_id){
	var httpObject = createHttpObject("db_scripts/get_sd_data.php",top_query_id);
	if (httpObject != null){
		httpObject.onreadystatechange = function(){
			if(httpObject.readyState == 4){
				var summary_data = new google.visualization.DataTable(httpObject.responseText);
				var summary_table = new google.visualization.Table(document.getElementById('summary_data'));				
				google.visualization.events.addListener(summary_table, 'ready', function(){
					$("#summary_data").click(function(event){
						var target = $(event.target);
						if (target.is("span[rid]") || target.is("img[rid]")){
							if (!target.data("tooltip")){
								var _ajax_request_parameters = "rid=" + target.attr("rid");
								if (target.is("img[rid]")) _ajax_request_parameters += "&isfeed=true";
								target.tooltip({tip: '#tooltip', opacity: 0.9, position: 'center center', delay: 150,  events: {def:"click, blur mouseleave"},
								onBeforeHide: function(){
									this.getTip().html("");
									this.getTrigger().unbind('mouseenter mouseleave mouseover mouseout click blur');
									this.getTrigger().removeData("tooltip");
									//this.getTrigger().css('color', 'black');
									this.getTrigger().css('cursor','pointer');
								},
								onBeforeShow: function(){
									//this.getTrigger().css('color', 'red');
									this.getTrigger().css('cursor','default');
									$.ajax({url:"db_scripts/get_sd_data_measure_details.php", 
										success: function(data){$("#tooltip").html(data);},
										type: "POST",
										data: _ajax_request_parameters
									});
								}
								});
								target.trigger("click");
							}
						}						
					});
					$("#summary_data").mouseout(function(event){	
						var target = $(event.target);
						if (target.is("span[rid]") || target.is("img[rid]")){							
							if (target.data("tooltip")) target.removeData("tooltip");
							target.unbind('mouseenter mouseleave mouseover mouseout click');							
						}
					});
				});
				summary_table.draw(summary_data, {width:'100%', height:'695px', allowHtml: true, showRowNumber: true, page: 'enable', pageSize: 50, startPage: 0});
				$("#summary_data").find("table").bind('copy', function (e) {e.preventDefault();});

				if (id_of_top_query != -1){
					initializeSearchOptions(id_of_top_query);
				}
			}
		}
	}
}

// loads individual samples and creates markers, table and scatter chart
function load_samples(copy_of_query_parameters, get_number_of_samples){
	var httpObject = createHttpObjectFromParameters("db_scripts/ajax-samples.php",copy_of_query_parameters);
	if (httpObject != null){
		httpObject.onreadystatechange = function(){
			if(httpObject.readyState == 4){
				// reading the data from the http_response
				query_result = new google.visualization.DataTable(httpObject.responseText);
				var formatter_short     = new google.visualization.DateFormat({formatType: 'short'});
				formatter_short.format(query_result, 3);


				// preparing the table
				table_view_query_result = new google.visualization.DataView(query_result);				
				table_view_query_result.hideColumns([0,1,4,5]);				
//				table_view_query_result.setColumns([2,3,6,7,8]);
				table_view              = new google.visualization.Table(document.getElementById('dd_data'));
				table_view_options      = {width:'100%', height:'100%', allowHtml: true, showRowNumber: true, page: 'enable', pageSize: 50, sort: 'event', sortColumn: -1, sortAscending: true, startPage: 0};
				table_view.draw(table_view_query_result, table_view_options);
				google.visualization.events.addListener(table_view, 'select',
                        		function(){
                        			var selection = table_view.getSelection();
						if (selection.length == 0) clearSelection();
                        			else{
							var sample_id = table_view_query_result.getTableRowIndex(selection[0].row);
							selectLocation(query_result.getValue(sample_id,0), sample_id, true);
							selectSampleOnChart(sample_id);
							selected_sample = sample_id;
						}
	                        	}
				);
				google.visualization.events.addListener(table_view, 'sort', 
					function(properties){
						clearSelection();
						var sorted_column = properties['column'];
			 			var sorted_asc    = properties['ascending'];
						var sorting       = query_result.getSortedRows([{'column': table_view_query_result.getTableColumnIndex(sorted_column), 'desc': !sorted_asc}]);
						for (var i = 0; i < sorting.length; i++) {
							sorted_rows[sorting[i]] = i;
						}						
						table_view_query_result.setRows(sorting);
						table_view_options['sortColumn']    = sorted_column;
						table_view_options['sortAscending'] = sorted_asc;
						table_view_options['startPage']     = 0;
						table_view.draw(table_view_query_result, table_view_options);
						adjustTableLayout();
					}
				);
				google.visualization.events.addListener(table_view, 'ready', function(){adjustTableLayout();});
				google.visualization.events.addListener(table_view, 'page', function(){adjustTableLayout();});				

				// preparing datatable for the statistics of the nutrients
				query_result_nutrient_aggregated = new google.visualization.DataTable();
				query_result_nutrient_aggregated.addColumn('string', message_nutrients, 'nutrient');
				query_result_nutrient_aggregated.addColumn('number', message_count, 'count');
				query_result_nutrient_aggregated.addColumn('number', 'Min', 'min');
				query_result_nutrient_aggregated.addColumn('number', 'Max', 'max');
				query_result_nutrient_aggregated.addColumn('number', 'Avg', 'avg');
				query_result_nutrient_aggregated.addColumn('number', '&sigma;', 'stdev');
				/*query_result_nutrient_aggregated.addColumn('number', 'avg(&mu;< -&sigma;)', 'm.stdev');
				query_result_nutrient_aggregated.addColumn('number', 'avg(&mu;&plusmn;&sigma;)', 'a.stdev');
				query_result_nutrient_aggregated.addColumn('number', 'avg(&mu;> +&sigma;)', 'p.stdev');*/

				// preparing select tags for the nutrients
				var select_tags    = "<option value='-1'></option>";
				var first_nutrient = null;
				for (var i = 0; i < query_result.getNumberOfColumns() ; i++) {
					if (query_result.getColumnId(i).substring(0,8) == "nutrient"){
						if (first_nutrient == null) first_nutrient = i;
						select_tags += "<option value='" + i + "'>" + query_result.getColumnLabel(i) + "</option>";
						query_result_nutrient_aggregated.addRow([query_result.getColumnLabel(i), 0, null, null, 0, 0]);
					}
				}
				$("#dd_charts_nutrtients select").each(function(){
					$(this).html(select_tags);
    				});
				if (first_nutrient != null) $("#dd_charts_nutrtients select").eq(0).val(first_nutrient);

				

				// creating scatter chart
				view_for_scatter_chart = new google.visualization.DataView(query_result);
				scatter_chart_options  = {hAxis: {format: 'MM/yyyy'}, pointSize: 4, legend:{position:'top'}, chartArea:{width:"80%",height:"80%"}};
				scatter_chart          = new google.visualization.ScatterChart(document.getElementById('dd_google_chart'));
				google.visualization.events.addListener(scatter_chart, 'select',
                        		function(){
						var selection = scatter_chart.getSelection();
						if (selection.length == 0) clearSelection();
                        			else{
							var sample_id   = selection[0].row;			
							selectLocation(query_result.getValue(sample_id,0), sample_id, true);
							selectSampleInTable(sample_id);
							selected_sample = sample_id;
						}

                                	}
                        	);
				google.visualization.events.addListener(scatter_chart, 'ready',
                        		function(){
						chart_was_displayed = true;
					}
				);

				// creating the map
				if (g_map == null){
                    			g_map = new google.maps.Map(document.getElementById("dd_map"), {mapTypeId: google.maps.MapTypeId.TERRAIN});
					google.maps.event.addListenerOnce(g_map, 'tilesloaded', function(){						
	    					setControls(g_map);
						restoreMapVisualisationOptions();					
					});					
				}

				//Initialize Density Map
                		g_densityMap     = new DensityOverlay(g_map, copy_of_query_parameters);
				g_regressionMap	 = new RegressionOverlay(g_map, copy_of_query_parameters);

				// creating the markers and counting the statistics about the nutrients
				var g_bounds            = new google.maps.LatLngBounds();
				distinct_locations      = [];
				sorted_rows             = [query_result.getNumberOfRows()];
				var current_location_id = -1;
				var current_location    = null;
				for (var i = 0; i < query_result.getNumberOfRows(); i++) {
					sorted_rows[i] = i;

					// locations
					var location_id = query_result.getValue(i,0);
					if (location_id != -1){
						if (location_id != current_location_id){
							var latLng          = new google.maps.LatLng(query_result.getValue(i,4), query_result.getValue(i,5));							
							current_location    = new google.maps.Marker({'position': latLng, 'id': location_id, 'sample_ids': [i], shadow: "layout_resources/images/msmarker.shadow.png", icon: normal_marker_icon});
							distinct_locations.push(current_location);
							current_location_id = location_id;
							g_bounds.extend(latLng);
							google.maps.event.addListener(current_location, 'click', 
								function() {
									if (selected_location == this.id) clearSelection();										
									else{
										selectLocation(this.id, -1, false);
										if (this.sample_ids.length == 1){
											selectSampleInTable(this.sample_ids[0]);
											selectSampleOnChart(this.sample_ids[0]);
											selected_sample = this.sample_ids[0];
											one_to_many_comparison_attach_target(selected_sample);
											//one_to_one_comparison_attach_target(selected_sample);
										}else {
											selectSampleInTable(-1);
											selectSampleOnChart(-1);
											selected_sample = -1;
										}
									}
								}
							);
						}else {
							current_location.sample_ids.push(i);
						}						
					}

					// nutrients
					for (var j = first_nutrient; j < query_result.getNumberOfColumns(); j++){
						var _val = query_result.getValue(i, j);						
						if (_val != null){
							var _j   = j - first_nutrient;

							var _count = query_result_nutrient_aggregated.getValue(_j, 1) + 1;
							query_result_nutrient_aggregated.setCell(_j, 1, _count);
							
							var _min = query_result_nutrient_aggregated.getValue(_j, 2);
							var _max = query_result_nutrient_aggregated.getValue(_j, 3);
							if (_min == null || _max == null){
								query_result_nutrient_aggregated.setCell(_j, 2, _val);
								query_result_nutrient_aggregated.setCell(_j, 3, _val);
							}else if (_val < _min){
								query_result_nutrient_aggregated.setCell(_j, 2, _val);
							}else if (_val > _max){
								query_result_nutrient_aggregated.setCell(_j, 3, _val);
							}

							var _sum = query_result_nutrient_aggregated.getValue(_j, 4) + _val;
							query_result_nutrient_aggregated.setCell(_j, 4, _sum);

							var _sums = query_result_nutrient_aggregated.getValue(_j, 5) + _val*_val;
							query_result_nutrient_aggregated.setCell(_j, 5, _sums);
						}
					}
				}				
				g_map.fitBounds(g_bounds);
				marker_cluster = new MarkerClusterer(g_map, distinct_locations, {maxZoom: 8});
				if (distinct_locations.length == 0) g_map.setZoom(0);

				// finalizing statistics about the nutrients
				for (var j = 0; j < query_result.getNumberOfColumns() - first_nutrient; j++){
					var _count = query_result_nutrient_aggregated.getValue(j, 1);
					var _sum   = query_result_nutrient_aggregated.getValue(j, 4);
					var _sums  = query_result_nutrient_aggregated.getValue(j, 5);
					var _min = query_result_nutrient_aggregated.getValue(j, 2);
					var _max = query_result_nutrient_aggregated.getValue(j, 3);
					
					if (_count > 0){
						var _avg = _sum/_count;
						var _dev = Math.sqrt(_sums/_count - _avg*_avg);
						query_result_nutrient_aggregated.setCell(j, 2, _min, _min.toFixed(3));
						query_result_nutrient_aggregated.setCell(j, 3, _max, _max.toFixed(3));
						query_result_nutrient_aggregated.setCell(j, 4, _avg, _avg.toFixed(3));
						query_result_nutrient_aggregated.setCell(j, 5, _dev, _dev.toFixed(3));
					
					}else {
						query_result_nutrient_aggregated.setCell(j, 2, null, null);
						query_result_nutrient_aggregated.setCell(j, 3, null, null);
						query_result_nutrient_aggregated.setCell(j, 4, null, null);
						query_result_nutrient_aggregated.setCell(j, 5, null, null);
					}
				}


				samples_loading = false;
				redrawCharts();

				// disabling copy
				$("#dd_data").find("table").bind('copy', function (e) {e.preventDefault();});

				// dispaying statistics about the nutrients
				load_nutrient_aggregated();

				// loading search options if a save query				
				if (id_of_top_query != -1 && get_number_of_samples){
					initializeSearchOptions(id_of_top_query);
				}

				// if the number of the samples in the query result is uknown
				if (get_number_of_samples){			
					var httpObject2 = createHttpObjectFromParameters("db_scripts/ajax-pg-result-size.php",copy_of_query_parameters);
					if (httpObject2 != null){
						httpObject2.onreadystatechange = function(){
							if(httpObject2.readyState == 4){
								number_of_feed_samples = parseInt(httpObject2.responseText);
								// activating for the user an option to change the size of the sample
								promptSampleSize();
							}
						}
					}
				}else {
					// activating for the user an option to change the size of the sample
					promptSampleSize();
				}
			}
		}
	}
}

// loads aggregated nutrients values over the time and creates lines chart
function load_time_aggregated(copy_of_query_parameters){
	var httpObject = createHttpObjectFromParameters("db_scripts/ajax-linediagram.php",copy_of_query_parameters);
	if (httpObject != null){
		httpObject.onreadystatechange = function(){
			if(httpObject.readyState == 4){
				// reading the data from the http_response
				query_result_time_aggregated = new google.visualization.DataTable(httpObject.responseText);

				// creating line chart
				view_for_line_chart      = new google.visualization.DataView(query_result_time_aggregated);
				line_chart_options       = {title: 'temporal mean value distribution', hAxis: {title: 'Timeline'}, vAxis: {title: 'Quantity'},pointSize: 1,curveType: 'none',lineWidth: 2};
				time_aggregated_loading  = false;
				redrawCharts();
			}
		}
	}
}

// loads aggregated nutrients values over the time and creates lines chart
function load_nutrient_aggregated(copy_of_query_parameters){
	// creating table
	table_nutrient_aggregated  = new google.visualization.Table(document.getElementById('dd_stats_nutrients'));
	table_nutrient_options     = {width:'100%', height:'100%', allowHtml: true, showRowNumber: true};
	google.visualization.events.addListener(table_nutrient_aggregated, 'ready', function(){nutrient_aggregated_was_displayed = true;});
	
	nutrient_aggregated_loading  = false;
	redrawCharts();	
}

function unmarkMarkersAccordinToNutrient(){
	if (selected_nutrient_in_stats  != -1){
		var row_id = -1;
		for (var i = 0; i < query_result_nutrient_aggregated.getNumberOfRows(); i++){
			if (query_result.getColumnLabel(selected_nutrient_in_stats) == query_result_nutrient_aggregated.getValue(i, 0)) row_id = i;
		}

		if (row_id != -1){
			query_result_nutrient_aggregated.setProperty(row_id, 6, "style","background:transparent");			
			query_result_nutrient_aggregated.setProperty(row_id, 7, "style","background:transparent");
			query_result_nutrient_aggregated.setProperty(row_id, 8, "style","background:transparent");
		}

		selected_nutrient_in_stats = -1;
	}
}

// spreads samples of a given location
function unSelectLocation(){
	if (selected_location != -1){
		distinct_locations[selected_location].setIcon(normal_marker_icon);
		distinct_locations[selected_location].setAnimation(null);
		distinct_locations[selected_location].setZIndex(selected_zindex);	
		if (distinct_locations[selected_location].sample_ids.length > 1){
			for (i in spread_samples) spread_samples[i].setMap(null);
			spread_samples = null;
			for (i in spread_lines) spread_lines[i].setMap(null);
			spread_lines = null;			
		}
		selected_location = -1;
	}

}

// unspreads samples of a given location
function selectLocation(location_id, sample_id, animate){
	unSelectLocation();

	// if not a single sample spread
	if (location_id == -1){
		selected_location = location_id;
	}else {
		selected_location = location_id;		
		selected_zindex   = distinct_locations[selected_location].getZIndex();
		distinct_locations[selected_location].setZIndex(google.maps.Marker.MAX_ZINDEX);
		distinct_locations[selected_location].setIcon(selected_marker_icon);		
		if (animate){
			g_map.panTo(distinct_locations[selected_location].getPosition());
			if (g_map.getZoom() <= marker_cluster.getMaxZoom()) g_map.setZoom(marker_cluster.getMaxZoom() + 1);
			distinct_locations[selected_location].setAnimation(google.maps.Animation.DROP);
		}	

		if (distinct_locations[location_id].sample_ids.length > 1){			
			spread_samples   = [distinct_locations[location_id].sample_ids.length];
			spread_lines     = [distinct_locations[location_id].sample_ids.length];
			var angle_offset = Math.PI*1.999999/distinct_locations[location_id].sample_ids.length;
			var radius_a       = (g_map.getBounds().getNorthEast().lat() - g_map.getBounds().getSouthWest().lat())/10;
			var radius_b       = (g_map.getBounds().getNorthEast().lng() - g_map.getBounds().getSouthWest().lng())/10;
			var a            = distinct_locations[location_id].getPosition().lat();
			var b            = distinct_locations[location_id].getPosition().lng();
			for (var i = 0; i < distinct_locations[location_id].sample_ids.length; i++){
				var latLng;
				if (i%2 == 0){
					latLng = new google.maps.LatLng(a + radius_a*Math.cos(angle_offset*Math.round(i/2)), b + radius_b*Math.sin(angle_offset*Math.round(i/2)));
				}else {
					latLng = new google.maps.LatLng(a + radius_a*Math.cos(-angle_offset*Math.round(i/2)), b + radius_b*Math.sin(-angle_offset*Math.round(i/2)));
				}
				var marker = new google.maps.Marker({'map':distinct_locations[location_id].map, 'position': latLng, 'id': distinct_locations[location_id].sample_ids[i], shadow: "layout_resources/images/msmarker.shadow.png", icon: spread_icon});
				var line   = new google.maps.Polyline({'map':distinct_locations[location_id].map,'path':[distinct_locations[location_id].getPosition(),latLng],'strokeColor':"#000", "strokeOpacity":0.6, "strokeWeight":1.5});

				marker.setZIndex(google.maps.Marker.MAX_ZINDEX);
				google.maps.event.addListener(marker, 'click', 
					function() {
						if (selected_sample == this.id){
							this.setIcon(spread_icon);
							selectSampleInTable(-1);
							selectSampleOnChart(-1);
							selected_sample = -1;
						}else {
							if (selected_sample != -1){
								var pos_sel_sample = 0;
								for (;spread_samples[pos_sel_sample].id != selected_sample; pos_sel_sample++);
								spread_samples[pos_sel_sample].setIcon(spread_icon);
							}
							selectSampleInTable(this.id);
							selectSampleOnChart(this.id);
							this.setIcon(selected_marker_icon);
							selected_sample = this.id;
							one_to_many_comparison_attach_target(selected_sample);
							//one_to_one_comparison_attach_target(selected_sample);
						}
					}
				);

				spread_samples[i] = marker;
				spread_lines[i]   = line;

				if (sample_id == marker.id){
					marker.setIcon(selected_marker_icon);
					marker.setAnimation(google.maps.Animation.DROP);
				}
			}
		}else {			
			distinct_locations[selected_location].setZIndex(google.maps.Marker.MAX_ZINDEX);
		}
	}
}

// cleans user selection from everythere
function clearSelection(){	
	unSelectLocation();
	table_view.setSelection(null);
	if ($("#dd_stat_type_select").val() == "1"){
		scatter_chart.setSelection(null);
	}
	selected_sample = -1;	
}

// selects a row in the table and do all fancy visual stuff as moving to the appropriate cell
function selectSampleInTable(sample_id){
	// unselecting previously selected row
	table_view.setSelection(null);
	// exiting if nothing to select
	if (sample_id == -1) return;
	// moving table to the right page
	table_view_options['startPage'] = Math.floor(sorted_rows[sample_id]/(table_view_options['pageSize']));
	table_view.draw(table_view_query_result, table_view_options);
	adjustTableLayout();
	// moving to the right row
	table_view.setSelection([{'row':sorted_rows[sample_id]}]);
	$("#dd_data").children().children().each(function() {		
	    if ($(this).css('overflow-x') === "auto" && $(this).css('overflow-y') === "auto"){
		var w   = $(this);
		var row = $(".google-visualization-table-tr-sel");	
		w.animate({scrollTop: w.scrollTop() + row.position().top - (w.height()/2)}, 1000 );
	    }
	});
}

// selectes a dot in a scatter chart
function selectSampleOnChart(sample_id){
	if ($("#dd_stat_type_select").val() == "1"){
		// unselecting previously selected row
		scatter_chart.setSelection(null);
		// exiting if nothing to select
		if (sample_id == -1) return;
		// selecting the right one
		scatter_chart.setSelection([{'row':sample_id}]);
	}
}

// adjust layout of the table so it scales 
function adjustTableLayout(){
	$("#dd_data").children().children().each(function() {		
	    if ($(this).css('overflow-x') === "auto" && $(this).css('overflow-y') === "auto")
	        $(this).css("height",  $("#dd_data").height() +  "px");
	   });
}

// redraws charts if the nutients are changed
function redrawCharts(){
	//if (time_aggregated_loading) return;
	if (nutrient_aggregated_loading) return;
	if (samples_loading) return;

	if ($("#dd_stat_type_select").val() == "1"){
		$("#dd_region_comparison").css("display", "none");
		$("#dd_stats_nutrients").css("display", "none");
		$("#dd_many_region_comparison").hide(0, one_to_many_comparison_hide);
		$("#dd_region_comparison").hide(0, one_to_one_comparison_hide);
		//unmarkMarkersAccordinToNutrient();
		if (view_for_scatter_chart == null) return;
		$("#dd_charts_nutrtients").css("display","block");
		$("#dd_google_chart").css("display","block");

		var selected_nutrients = [];
		selected_nutrients.push(3);
		if ($("#dd_charts_nutrient_a").val() != "-1") selected_nutrients.push(parseInt($("#dd_charts_nutrient_a").val()));
		if ($("#dd_charts_nutrient_b").val() != "-1") selected_nutrients.push(parseInt($("#dd_charts_nutrient_b").val()));
		if ($("#dd_charts_nutrient_c").val() != "-1") selected_nutrients.push(parseInt($("#dd_charts_nutrient_c").val()));

		view_for_scatter_chart.setColumns(selected_nutrients);
		scatter_chart.draw(view_for_scatter_chart, scatter_chart_options);
		if (selected_sample != -1) selectSampleOnChart(selected_sample);
	}else if ($("#dd_stat_type_select").val() == "2"){
		$("#dd_region_comparison").css("display", "none");
		$("#dd_stats_nutrients").css("display", "none");
		$("#dd_many_region_comparison").hide(0, one_to_many_comparison_hide);
		$("#dd_region_comparison").hide(0, one_to_one_comparison_hide);
		//unmarkMarkersAccordinToNutrient();
		if (view_for_line_chart == null) return;
		$("#dd_charts_nutrtients").css("display","block");
		$("#dd_google_chart").css("display","block");

		// determing index of the first nutrient in query_result
		var first_nutrient = null;
		for (var i = 0; i < query_result.getNumberOfColumns() && (first_nutrient == null); i++) {
			if (query_result.getColumnId(i).substring(0,8) == "nutrient") first_nutrient = i;
		}

		var selected_nutrients = [];
		selected_nutrients.push(0);
		if ($("#dd_charts_nutrient_a").val() != "-1") selected_nutrients.push(parseInt($("#dd_charts_nutrient_a").val()) - first_nutrient + 1);
		if ($("#dd_charts_nutrient_b").val() != "-1") selected_nutrients.push(parseInt($("#dd_charts_nutrient_b").val()) - first_nutrient + 1);
		if ($("#dd_charts_nutrient_c").val() != "-1") selected_nutrients.push(parseInt($("#dd_charts_nutrient_c").val()) - first_nutrient + 1);

		view_for_line_chart.setColumns(selected_nutrients);
		scatter_chart.draw(view_for_line_chart, line_chart_options);
	}else {
		$("#dd_charts_nutrtients").css("display","none");
		$("#dd_google_chart").css("display","none");

		if ($("#dd_stat_type_select").val() == "3"){
			$("#dd_region_comparison").css("display", "none");
			$("#dd_many_region_comparison").hide(0, one_to_many_comparison_hide);
			$("#dd_region_comparison").hide(0, one_to_one_comparison_hide);
			$("#dd_stats_nutrients").css("display", "block");
			table_nutrient_aggregated.draw(query_result_nutrient_aggregated, table_nutrient_options);
		}else if ($("#dd_stat_type_select").val() == "4"){
			$("#dd_stats_nutrients").css("display", "none");
			$("#dd_many_region_comparison").hide(0, one_to_many_comparison_hide);
			//unmarkMarkersAccordinToNutrient();
			//$("#dd_region_comparison").css("display", "block");
			$("#dd_region_comparison").show(0, one_to_one_comparison_show);
		}else if ($("#dd_stat_type_select").val() == "5"){
			$("#dd_region_comparison").css("display", "none");
			$("#dd_stats_nutrients").css("display", "none");
			$("#dd_region_comparison").hide(0, one_to_one_comparison_hide);
			$("#dd_many_region_comparison").show(0, one_to_many_comparison_show);
		}
	}
}

function getSelectedNutrientIdFromChartsA(){
	if ($("#dd_charts_nutrient_a").length == 0) return "";	
	if ($("#dd_charts_nutrient_a").val() == "-1") return "";	
	if (query_result == null) return "";

	var col_i = parseInt($("#dd_charts_nutrient_a").val());	
	return query_result.getColumnId(col_i).substring(8);
}

function getSelectedNutrientIdFromChartsB(){
	if ($("#dd_charts_nutrient_b").length == 0) return "";	
	if ($("#dd_charts_nutrient_b").val() == "-1") return "";
	if (query_result == null) return "";
	
	var col_i = parseInt($("#dd_charts_nutrient_b").val());
	return query_result.getColumnId(col_i).substring(8);
}

function getSelectedNutrientIdFromChartsC(){
	if ($("#dd_charts_nutrient_c").length == 0) return "";	
	if ($("#dd_charts_nutrient_c").val() == "-1") return "";
	if (query_result == null) return "";
	
	var col_i = parseInt($("#dd_charts_nutrient_c").val());
	return query_result.getColumnId(col_i).substring(8);
}

function showAllMarkers(){
	if (distinct_locations != null){
		if (marker_cluster != null) marker_cluster.addMarkers(distinct_locations);
	}
	if (spread_samples != null){
		for (i in spread_samples) spread_samples[i].setMap(g_map);
	}
	if (spread_lines != null){
		for (i in spread_lines) spread_lines[i].setMap(g_map);
	}
}

function hideAllMarkers(){
	if (distinct_locations != null){
		if (marker_cluster != null) marker_cluster.clearMarkers();
	}
	if (spread_samples != null){
		for (i in spread_samples) spread_samples[i].setMap(null);
	}
	if (spread_lines != null){
		for (i in spread_lines) spread_lines[i].setMap(null);
	}
}

function export_measurements(){
	//if (time_aggregated_loading)     return;
	if (nutrient_aggregated_loading) return;
	if (samples_loading)             return;

	var parameters = "";
	var url        = "";

	if ($("#detailed_data").css("display") == "block"){
		url = "db_scripts/ajax-samples.php";
		parameters = "export=yes&" + copy_of_query_parameters + "&sample=" + table_view_query_result.getNumberOfRows() + "&size=" + number_of_feed_samples;
	}else if ($("#summary_data").css("display") == "block"){
		url = "db_scripts/get_sd_data.php";
		parameters = "export=yes&" + copy_of_query_parameters;
	}

	var inputs = "";
	jQuery.each(parameters.split('&'), function(){ 
		var pair = this.split('=');
		inputs+='<input type="hidden" name="'+ pair[0] +'" value="'+ pair[1] +'" />'; 
	});	

	jQuery('<form action="'+ url +'" method="post">' + inputs + '</form>')
	.appendTo('body').submit().remove();
}

function restoreChartsVisualisationOptions(){
	if (query_result == null) return;
	if ($("#dd_charts_nutrient_a").length == 0) return;
	if ($("#dd_charts_nutrient_b").length == 0) return;
	if ($("#dd_charts_nutrient_c").length == 0) return;

	if (glob_charts_na.length > 0 && !(getSelectedNutrientIdFromChartsA() === glob_charts_na)){
		var col_id = -1;
		for (var i = 0; i < query_result.getNumberOfColumns() && col_id == -1; i++) {
			if (query_result.getColumnId(i) == "nutrient" + glob_charts_na) col_id = i;
		}
		if (col_id != -1){
			$("#dd_charts_nutrient_a").val(col_id);
		}
	}

	if (glob_charts_nb.length > 0 && !(getSelectedNutrientIdFromChartsB() === glob_charts_nb)){
		var col_id = -1;
		for (var i = 0; i < query_result.getNumberOfColumns() && col_id == -1; i++) {
			if (query_result.getColumnId(i) == "nutrient" + glob_charts_nb) col_id = i;
		}
		if (col_id != -1){
			$("#dd_charts_nutrient_b").val(col_id);
		}
	}

	if (glob_charts_nc.length > 0 && !(getSelectedNutrientIdFromChartsC() === glob_charts_nc)){
		var col_id = -1;
		for (var i = 0; i < query_result.getNumberOfColumns() && col_id == -1; i++) {
			if (query_result.getColumnId(i) == "nutrient" + glob_charts_nc) col_id = i;
		}
		if (col_id != -1){
			$("#dd_charts_nutrient_c").val(col_id);
		}
	}

	if (glob_stats_sel.length > 0 && !($("#dd_stat_type_select").val() === glob_stats_sel)){
		$("#dd_stat_type_select").val(glob_stats_sel);
	}

	redrawCharts();
}
