var glob_rad_map;
var glob_rad_geocoder;
var glob_rad_marker;
var glob_rad_circle;

function loadRadiusMap() {	
	if (!glob_rad_map){	
		glob_rad_map = new google.maps.Map(document.getElementById("radius_map"), {
        	        center: new google.maps.LatLng(46.912751,8.338623),
        	        zoom: 7,
        	        mapTypeId: 'roadmap',
        	        mapTypeControlOptions: {style: google.maps.MapTypeControlStyle.DROPDOWN_MENU}
		});

		glob_rad_geocoder = new google.maps.Geocoder();
	}
}

function searchRadLocations() {
	var address = $("#radAddressInput").val();
        glob_rad_geocoder.geocode({address: address, region:'CH'}, function(results, status) {
		if (status == google.maps.GeocoderStatus.OK) {
			var center = results[0].geometry.location;
			addRadMarker(center);
			setRadCircle(center);
			selected_radius.value  = center.lat() + "," + center.lng() + "," + $('#radRadiusSelect').val();
			$('#radius_error_message').hide();
		} else {
               		clearRadMap();
			$('#radius_error_message').show();
		}
	});
}

function clearRadMap() {
	selected_radius.value  = "";
	//$("#radAddressInput").val("");
	if (glob_rad_marker) {
		glob_rad_marker.setMap(null);
	}
	if (glob_rad_circle) {
		glob_rad_circle.setMap(null);
	}
	if (glob_rad_map){		
		glob_rad_map.setCenter(new google.maps.LatLng(46.912751,8.338623));
		glob_rad_map.setZoom(7);
	}
}

function restoreRadMap(){
	if (selected_radius.value.length == 0) return;

	var split_value = selected_radius.value.split(",");
	if (split_value.length == 3 && glob_rad_map){	
		var center = new google.maps.LatLng(parseFloat(split_value[0]), parseFloat(split_value[1]));
		$('#radRadiusSelect').val(split_value[2]);
		addRadMarker(center);		
		setRadCircle(center);
		selected_radius.value  = center.lat() + "," + center.lng() + "," + $('#radRadiusSelect').val();
	}
}

function addRadMarker(center) {
	clearRadMap();
	glob_rad_marker = new google.maps.Marker({
		map: glob_rad_map,
                position: center
	});
}
        
function setRadCircle(center) {
	glob_rad_circle = new google.maps.Circle({
		center: center,
		radius: $('#radRadiusSelect').val() * 1000,
		map: glob_rad_map
	});	
	glob_rad_map.fitBounds(glob_rad_circle.getBounds());	
}
