var one_to_one_query_id; // the id of the top_query
var one_to_one_store_next_selected_location = -1; // -1: false; non-negative-value: location-number - 1
var one_to_one_selected_locations = new Array();
var one_to_one_circle_location_1;
var one_to_one_circle_location_2;
var one_to_one_circle_location_radius_for_region_comparison; // radius in kilometers
var radius_for_region_comparison_loc_1;
var radius_for_region_comparison_loc_2;

// initialisiation
function load_data_for_region_comparison(top_query_id) {
	
	one_to_one_query_id = top_query_id;	
	one_to_one_circle_location_radius_for_region_comparison = 10;
	radius_for_region_comparison_loc_1 = 10;
	radius_for_region_comparison_loc_2 = 10;
	
	var html = new String();
	html += "<select id=\"one_to_one_circle_location_radius_for_region_comparison\" onclick=\"set_one_to_one_circle_location_radius_for_region_comparison()\">><option value=5>5km</option><option selected=\"selected\" value=10>10km</option><option value=25>25km</option></select>";
	html += "<button id=\"first_location\" type=\"button\" onclick=\"set_first_location()\">Set first location</button>";
	html += "<button id=\"second_location\" type=\"button\" onclick=\"set_second_location()\">Set second location</button>";
	html += "<button id=\"calculate_f_test\" type=\"button\" disabled=\"disabled\" onclick=\"calculate_f_test()\">Calculate F-Test</button>";
	html += "<div id=\"first_location_value\"></div>";
	html += "<div id=\"second_location_value\"></div>";
	html += "<div id=\"f_test\">Please click on a button and set the region by clicking on a sample on the map!</div>";
	    
    $("#dd_region_comparison").html(html); 
}

function calculate_f_test() {
	var html = new String();
	
	html += "<p><b> Running F-Test... </b></p>";
	html += "<p> This may take several seconds. Please wait. </p>";
	$("#f_test").html(html);  
	
	// convert location data
	var loc1 = one_to_one_selected_locations[0] + "";
	var loc2 = one_to_one_selected_locations[1] + "";
	loc1 = loc1.substr(1,loc1.length-2);
	loc2 = loc2.substr(1,loc2.length-2);
	var semicolon_pos = loc1.search(',');
	loc1 = loc1.substr(0,semicolon_pos+1) + loc1.substr(semicolon_pos+2,loc1.length-2-semicolon_pos);
	semicolon_pos = loc2.search(',');
	loc2 = loc2.substr(0,semicolon_pos+1) + loc2.substr(semicolon_pos+2,loc2.length-2-semicolon_pos);
	
	// run the query (we cannot take the default query as we have additional POST-elements!
	var httpObject = getHttpObject();
	if (httpObject != null){
		var parameters = getQueryParameters(one_to_one_query_id);
		parameters += "&loc1=" + loc1 +"," + radius_for_region_comparison_loc_1;
		parameters += "&loc2=" + loc2 +"," + radius_for_region_comparison_loc_2;
		httpObject.open("POST", "db_scripts/ajax-pg-result-f-test.php", true);
		httpObject.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		httpObject.send(parameters);

		httpObject.onreadystatechange = function(){
			if(httpObject.readyState == 4){

                
                var temp = httpObject.responseText;
                var array = 0;
                var html = new String();
		
                // --2-- create new html output	
                temp = temp.substring(5);
                if(temp != ""){
                    array = temp.split("-sep-");
					
                    html+="<table border=\"2\" frame=\"void\" rules=\"all\">";
                    html+="<tr>";
                    html+="<th>Nutrient</th>";
                    html+="<th>Minimum</th>";
                    html+="<th>Maximum</th>";
                    html+="<th>Average</th>";
                    html+="<th>  2&sigma;*</th>";
                    html+="<th>Count</th>";
                    html+="<th></th>";
                    html+="<th>F-Test</th>";
                    html+="<th>Degree of freedom</th>";
                    html+="<th>Level of significance</th>";
                    html+="</tr>";
			
                    var secondArray;
                    for(var i = 0; i < array.length; i++){
                        secondArray = array[i].split("-s-");
                        
                        //F-Test
                        var count = new Number(secondArray[5]) + new Number(secondArray[13]);
                        var sumOfX = new Number(secondArray[6]) + new Number(secondArray[14]);
                        var sumOfX2 = new Number(secondArray[7]) + new Number(secondArray[15]);
                        var sumOfXsumOfXByN = new Number(secondArray[8]) + new Number(secondArray[16]);
                        
                        var betweenTheGroupVariability =  (sumOfXsumOfXByN - (sumOfX*sumOfX/count)).toFixed(3);
                        var withinTheGroupVariability = (sumOfX2 - sumOfXsumOfXByN).toFixed(3);
                        
                        var MAQbetweenTheGroup = betweenTheGroupVariability;
                        var MAQwithinTheGroup = withinTheGroupVariability/(count-2);
                        var Ftest = (MAQbetweenTheGroup/MAQwithinTheGroup).toFixed(3);
                                       
                        var levelOfSignificance;
                        var degreeOfFreedom = "(m=1, n="+(count-2)+")";
                        
                        if(new Number(secondArray[5]) == 0 || new Number(secondArray[13]) == 0) {
                        	Ftest = "---";
                        	degreeOfFreedom = "---";
                        	levelOfSignificance = "---";
                        } else {
                        	
                    		var ft=ftail(Ftest,1,(count-2));
                    		levelOfSignificance = new Number(RoundDP(ft,5));
                    		levelOfSignificance *= 100;
                    		levelOfSignificance = levelOfSignificance.toFixed(3);
                     
                        }
                        
		
                        html+="<tr>\n";
                        html+="<th rowspan=\"2\">"
                        	+ secondArray[0]+"</th>";       
                        
                        html+="<td align='right'>"
                            + secondArray[1]+"</td><td align='right'>"
                            + secondArray[2]+"</td><td align='right'>"
                            + secondArray[3]+"</td><td align='right'>"
                            + secondArray[4]+"</td><td align='right'>"
                            + secondArray[5]+"</td>";
                        html+="<td></td>";                     

                        html+="<th rowspan=\"2\" align='right'>" + Ftest  + "</th>";
                        html+="<th rowspan=\"2\" align='right'>" + degreeOfFreedom +"</th>";
                        html+="<th rowspan=\"2\" align='right'>"+ levelOfSignificance +"%</th>";
                        
                        html+="</tr><tr>";
                        
                        html+="<td align='right'>"
                            + secondArray[9]+"</td><td align='right'>"
                            + secondArray[10]+"</td><td align='right'>"
                            + secondArray[11]+"</td><td align='right'>"
                            + secondArray[12]+"</td><td align='right'>"
                            + secondArray[13]+"</td>";
                        html+="<td></td>"; 

                        html+="</tr>";
                    }
                    html+="</table>";
			
                    // --3-- set content
                    $("#f_test").html(html);
                }
            }
		}
	}
	
	
}

function set_one_to_one_circle_location_radius_for_region_comparison() {
	one_to_one_circle_location_radius_for_region_comparison = document.getElementById('one_to_one_circle_location_radius_for_region_comparison').options[document.getElementById('one_to_one_circle_location_radius_for_region_comparison').selectedIndex].value;
}


function one_to_one_comparison_attach_target(){
	var location_id = query_result.getValue(selected_sample,0);
	var lat = distinct_locations[location_id].getPosition().lat();
	var lng = distinct_locations[location_id].getPosition().lng();
	var latlng = new google.maps.LatLng(lat, lng);

	if(one_to_one_store_next_selected_location > -1) { // every time a sample on the map is clicked, this function will be executed. But the location should only be stored, if the user also has clicked on the corresponding set-button before.
		
		one_to_one_selected_locations[one_to_one_store_next_selected_location] = latlng;

		var g_boundsss = new google.maps.LatLngBounds();
		
		if(one_to_one_store_next_selected_location == 0) {
			
			if(one_to_one_circle_location_1 != null) one_to_one_circle_location_1.setMap(null);
			one_to_one_circle_location_1 = new google.maps.Circle({
				center: latlng,
				radius: one_to_one_circle_location_radius_for_region_comparison * 1000,
				map: g_map
			});

			radius_for_region_comparison_loc_1 = one_to_one_circle_location_radius_for_region_comparison;
			$("#first_location_value").html("Location 1: " + latlng);

			g_boundsss.extend(one_to_one_circle_location_1.getBounds().getNorthEast());
			g_boundsss.extend(one_to_one_circle_location_1.getBounds().getSouthWest()); 
			if (one_to_one_circle_location_2 != null){
				g_boundsss.extend(one_to_one_circle_location_2.getBounds().getNorthEast());
				g_boundsss.extend(one_to_one_circle_location_2.getBounds().getSouthWest()); 
			}
			
		} else if(one_to_one_store_next_selected_location == 1) {
			
			if(one_to_one_circle_location_2 != null) one_to_one_circle_location_2.setMap(null);
			one_to_one_circle_location_2 = new google.maps.Circle({
				center: latlng,
				radius: one_to_one_circle_location_radius_for_region_comparison * 1000,
				map: g_map
			});
			
			radius_for_region_comparison_loc_2 = one_to_one_circle_location_radius_for_region_comparison;
			$("#second_location_value").html("Location 2: " + latlng);

			g_boundsss.extend(one_to_one_circle_location_2.getBounds().getNorthEast());
			g_boundsss.extend(one_to_one_circle_location_2.getBounds().getSouthWest()); 
			if (one_to_one_circle_location_1 != null){
				g_boundsss.extend(one_to_one_circle_location_1.getBounds().getNorthEast());
				g_boundsss.extend(one_to_one_circle_location_1.getBounds().getSouthWest()); 
			}
			
		}

		g_map.fitBounds(g_boundsss);
		one_to_one_store_next_selected_location = -1; // location set.
		

		if(one_to_one_selected_locations[0] != null &&  one_to_one_selected_locations[1] != null) { // if two locations are set, allow the F-Test calculation
			document.getElementById("calculate_f_test").removeAttribute("disabled");
		}
	}
}

function one_to_one_comparison_show(){
	var g_boundsss = new google.maps.LatLngBounds();
	var adjust = false;

	if (one_to_one_circle_location_1 != null){
		one_to_one_circle_location_1.setMap(g_map);
		g_boundsss.extend(one_to_one_circle_location_1.getBounds().getNorthEast());
		g_boundsss.extend(one_to_one_circle_location_1.getBounds().getSouthWest());
		adjust = true;
	}
	if (one_to_one_circle_location_2 != null){
		one_to_one_circle_location_2.setMap(g_map);
		g_boundsss.extend(one_to_one_circle_location_2.getBounds().getNorthEast());
		g_boundsss.extend(one_to_one_circle_location_2.getBounds().getSouthWest());
		adjust = true;
	}

	if (adjust) g_map.fitBounds(g_boundsss);
}

function one_to_one_comparison_hide(){
	if (one_to_one_circle_location_1 != null) one_to_one_circle_location_1.setMap(null);
	if (one_to_one_circle_location_2 != null) one_to_one_circle_location_2.setMap(null);
}

function set_first_location() {
	if(one_to_one_store_next_selected_location > -1) {
		$("#second_location_value").html("");
	}
	$("#first_location_value").html("Location 1: Click now on a sample!"); 
	one_to_one_store_next_selected_location = 0;
}

function set_second_location() {
	if(one_to_one_store_next_selected_location > -1) {
		$("#first_location_value").html("");
	}
	$("#second_location_value").html("Location 2: Click now on a sample!");  
	one_to_one_store_next_selected_location = 1;
}
