var selected_bar = null;
var start_x      = 0;
var start_y      = 0;
var a_offset     = 4;
var resize_windows_initialized = false;
var resize_windows_left = 0;

function update_reize_windows(){
    if (!resize_windows_initialized) return;
    updateHorizontalBar($("#dd_hbar").position().top - (resize_windows_top  - $("#detailed_data").position().top));
    updateVerticalBar($("#dd_vbar").position().left - (resize_windows_left - $("#detailed_data").position().left));
    resize_windows_left = $("#detailed_data").position().left;
    resize_windows_top  = $("#detailed_data").position().top;
}

function resize_initialize(){
	selected_bar = null;
    
    	if (resize_windows_initialized) return;
    
    	resize_windows_left = $("#detailed_data").position().left;
    	resize_windows_top  = $("#detailed_data").position().top;
	var container_w = $("#detailed_data").innerWidth();
	var container_h = $("#detailed_data").innerHeight();

	// positioning
	$("#dd_hbar").css("width", container_w - $("#dd_hbar").outerWidth(true) + $("#dd_hbar").outerWidth() + "px");
	$("#dd_data").css("width", container_w + "px");	
	$("#dd_vbar").css("left", $("#detailed_data").position().left + container_w/1.7 - 110 + "px");
	updateHorizontalBar($("#detailed_data").position().top + container_h/1.7);
	updateVerticalBar($("#dd_vbar").position().left);
	
	// setting events
	$("#dd_hbar").mousedown(function(event){selectBar(event);});
	$("#dd_vbar").mousedown(function(event){selectBar(event);});
	//$("#detailed_data").mouseup(function(event){setBar(event);});
	//$("#detailed_data").mouseleave(function(event){unselectBar();});
	//$("#detailed_data").mousemove(function(event){moveBar(event);});
    
    resize_windows_initialized = true;
}

function updateHorizontalBar(new_top){
	$("#dd_hbar").css("top", new_top + "px");

	// setting the height of other elements
	$("#dd_vbar").css("height", new_top - $("#detailed_data").position().top - $("#dd_vbar").outerWidth(true) + $("#dd_vbar").outerWidth() + "px");
	$("#dd_data").css("height", $("#detailed_data").innerHeight() - (new_top - $("#detailed_data").position().top) - $("#dd_hbar").outerHeight(true) + "px");
	$("#dd_data").css("top", new_top + $("#dd_hbar").outerHeight(true) + "px");
	var i_height = new_top - $("#detailed_data").position().top; 
	$("#dd_map").css("height", i_height + "px");
	$("#dd_stat").css("height", i_height + "px");
    
    if (table_view != null){
	$("#dd_data").children().children().each(function() {		
	    if ($(this).css('overflow-x') === "auto" && $(this).css('overflow-y') === "auto")
	        $(this).css("height",  $("#dd_data").height() +  "px");
	   });
    }
    if (g_map != null){
        google.maps.event.trigger(g_map, "resize");
    }
}

function updateVerticalBar(new_left){
	$("#dd_vbar").css("left", new_left + "px");
	$("#dd_map").css("width", new_left - $("#detailed_data").position().left + "px");
	$("#dd_stat").css("left", new_left + $("#dd_vbar").outerWidth(true) + "px");
	$("#dd_stat").css("width", ($("#detailed_data").innerWidth(true) + $("#detailed_data").position().left) - (new_left + $("#dd_vbar").outerWidth(true)) + "px");
    if (g_map != null){
        google.maps.event.trigger(g_map, "resize");
    }
}

// selects the bar
function selectBar(e){
	e.preventDefault();
	unselectBar();
	selected_bar = e.target;
	start_x = e.pageX;
	start_y = e.pageY;
	$("#dd_mbar").css("display","block");
	$("#dd_mbar").css("top", $(selected_bar).position().top + "px");
	$("#dd_mbar").css("left", $(selected_bar).position().left + "px");
	$("#dd_mbar").css("width", $(selected_bar).outerWidth(true) + "px");
	$("#dd_mbar").css("height", $(selected_bar).outerHeight(true) + "px");
    
    $(document).mask({
        color: "#ffffff",
        opacity: "0.2",
        loadSpeed: 0,
        closeSpeed: 0
    });
    
    $.mask.getMask().mouseup(function(event){setBar(event);});
	$.mask.getMask().mouseleave(function(event){e.preventDefault();unselectBar();});
	$.mask.getMask().mousemove(function(event){moveBar(event);});
}

// unselects the bar
function unselectBar(){
	if (selected_bar == null) return;
	selected_bar = null;
	$("#dd_mbar").css("display","none");
    
    $.mask.getMask().mouseup(function(event){});
	$.mask.getMask().mouseleave(function(event){});
	$.mask.getMask().mousemove(function(event){});
    $.mask.close();
}

// moves bar
function moveBar(e){
    	e.preventDefault();
	if (selected_bar == null) return;

	if ($(selected_bar).attr("id") == "dd_hbar"){
		var new_top = $("#dd_mbar").position().top + (e.pageY - start_y);
		if (new_top < $("#detailed_data").position().top + a_offset){
			new_top = $("#detailed_data").position().top + a_offset;
		}
		if (new_top > $("#detailed_data").position().top + $("#detailed_data").innerHeight(true) - $("#dd_mbar").outerHeight(true) - a_offset){
			new_top = $("#detailed_data").position().top + $("#detailed_data").innerHeight(true) - $("#dd_mbar").outerHeight(true) - a_offset;
		}
		$("#dd_mbar").css("top", new_top + "px");
	}else if ($(selected_bar).attr("id") == "dd_vbar"){
		var new_left = $("#dd_mbar").position().left + (e.pageX - start_x);
		if (new_left < $("#detailed_data").position().left + a_offset){
			new_left = $("#detailed_data").position().left + a_offset;
		}
		if (new_left > $("#detailed_data").position().left + $("#detailed_data").innerWidth(true)- $("#dd_mbar").outerWidth(true)- a_offset){
			new_left = $("#detailed_data").position().left + $("#detailed_data").innerWidth(true) - $("#dd_mbar").outerWidth(true)- a_offset;
		}
		$("#dd_mbar").css("left", new_left + "px");
	}

	start_x = e.pageX;
	start_y = e.pageY;
}

// updates the position of bar
function setBar(e){
	e.preventDefault();
	if (selected_bar == null) return;

	if ($(selected_bar).attr("id") == "dd_hbar"){
		updateHorizontalBar($("#dd_mbar").position().top);
	}else if ($(selected_bar).attr("id") == "dd_vbar"){
		updateVerticalBar($("#dd_mbar").position().left);
	}
	unselectBar();
}
