function initializeSearchOptions(query_id){
	reset_search_option(td_unclassified_feeds);
	reset_search_option(td_agridea_feeds);
	reset_search_option(td_classified_feeds1);
	reset_search_option(td_classified_feeds2);
	reset_search_option(td_time_year);
	reset_search_option(td_time_season);
	reset_search_option(td_geo_canton);
	reset_search_option(td_geo_altitude);
	reset_search_option(td_nutrients_options);
	reset_search_option(sd_nutrients_options);
//	reset_search_option(sd_der_nutrients_options);
	reset_search_option(sd_feeds_options1);
	reset_search_option(sd_feeds_options2);
	reset_search_option(td_der_nutrients_options);
	glob_show_flags      = "";
	glob_show_density    = "";
	glob_show_regression = "";
	glob_regr_nutrient   = "";
	glob_charts_na       = "";
	glob_charts_nb       = "";
	glob_charts_nc       = "";
	glob_stats_sel       = "";
	clearRadMap();

	$("#open_time_options").removeClass().addClass("disabled_search_item");
	$("#open_geo_options").removeClass().addClass("disabled_search_item");
	$("#open_bio_options").removeClass().addClass("disabled_search_item");
	$("#open_tech_options").removeClass().addClass("disabled_search_item");
	
	updateLabels();	

	if (selected_data_type == "t"){// if searching throw temporal data
		// enabling search other nutrients and feeds options
		$("#open_td_feeds_options").css("display", "inline");
		$("#open_td_nutrients_options").css("display", "inline");
		$("#open_sd_feeds_options").css("display", "none");
		$("#open_sd_nutrients_options").css("display", "none");
		
		load_td_search_options(query_id, 0);
	}else {// if searching throw aggregated data
		$("#open_td_feeds_options").css("display", "none");
		$("#open_td_nutrients_options").css("display", "none");
		$("#open_sd_feeds_options").css("display", "inline");
		$("#open_sd_nutrients_options").css("display", "inline");

		// loading search options
		load_sd_search_options(query_id);		
	}
}

function load_td_search_options(query_id, load_level){
	if (load_level < 1){
		td_agridea_feeds.loading         = true;
		td_classified_feeds1.loading     = true;
		td_classified_feeds2.loading     = true;
		td_unclassified_feeds.loading    = true;
	}
	if (load_level < 2){
		td_nutrients_options.loading     = true;
		td_der_nutrients_options.loading = true;
	}
	td_geo_canton.loading            = true;
	td_geo_altitude.loading          = true;
	td_time_year.loading             = true;
	td_time_season.loading           = true;
	updateLabels();

	var httpObject = createHttpObject("db_scripts/get_td_search_options.php?ll=" + load_level, query_id);
	if (httpObject != null){
		httpObject.onreadystatechange = function(){
          	  	if (httpObject.readyState == 4){

				var data = eval(httpObject.responseText);

				if (load_level < 1){
					reset_search_option(td_agridea_feeds);
					td_agridea_feeds.count          = data.af.c;
					td_agridea_feeds.count_selected = data.af.s;
					$(td_agridea_feeds.div_id).jstree({
        	        		        "html_data":{"data": data.af.v},
						"search" : {"case_insensitive":true},
        	        		        "plugins" : [ "html_data", "checkbox", "themes", "search"]
        	       	    		});

					reset_search_option(td_classified_feeds1);
					reset_search_option(td_classified_feeds2);
					if (data.cf.c > -1){
						td_classified_feeds1.count = data.cf.c;
						td_classified_feeds1.count_selected = data.cf.s;

						$(td_classified_feeds1.div_id).jstree({
        		      		        	"html_data":{"data": data.cf.v1},
							"search" : {"case_insensitive":true},//, "show_only_matches":true},
        		       		        	"plugins" : [ "html_data", "checkbox", "themes", "search"]
        		       	    		});
        
						$(td_classified_feeds2.div_id).jstree({
        		      		        	"html_data":{"data": data.cf.v2},
							"search" : {"case_insensitive":true},//, "show_only_matches":true},
        		       		        	"plugins" : [ "html_data", "checkbox", "themes", "search"]
        		       	    		});
					}

					reset_search_option(td_unclassified_feeds);
					if (data.uf.c > -1){
						td_unclassified_feeds.count = data.uf.c;
						td_unclassified_feeds.count_selected = data.uf.s;
						$(td_unclassified_feeds.div_id).jstree({
		                		        "html_data":{"data": data.uf.v},
							"search" : {"case_insensitive":true},
        	        			        "plugins" : [ "html_data", "checkbox", "themes", "search"]
        	       		    		});
					}
				}

				if (load_level < 2){
					reset_search_option(td_nutrients_options);
					if (data.n.c > -1){
						td_nutrients_options.count          = data.n.c;
						td_nutrients_options.count_selected = data.n.s;
						$(td_nutrients_options.div_id).jstree({
                			        	"html_data":{"data": data.n.v},
							"search" : {"case_insensitive":true},
        	        			        "plugins" : [ "html_data", "checkbox", "themes", "search"]
        	       	    			});        	
					}

					reset_search_option(td_der_nutrients_options);
					if (data.nd.c > -1){
						td_der_nutrients_options.count          = data.nd.c;
						td_der_nutrients_options.count_selected = data.nd.s;
						$(td_der_nutrients_options.div_id).jstree({
        		        		        "html_data":{"data": data.nd.v},
							"search" : {"case_insensitive":true},
        		        		        "plugins" : [ "html_data", "checkbox", "themes", "search"]
        		       	    		});       		
					}
				}

				reset_search_option(td_geo_canton);
				if (data.ct.c > -1){
					td_geo_canton.count          = data.ct.c;
					td_geo_canton.count_selected = data.ct.s;

					$(td_geo_canton.div_id).jstree({
                		        	"html_data":{"data": data.ct.v},
						"search" : {"case_insensitive":true},//, "show_only_matches":true},
                		        	"plugins" : [ "html_data", "checkbox", "themes", "search"]
                	    		});
				}

				reset_search_option(td_geo_altitude);
				if (data.al.c > -1){
					td_geo_altitude.count          = data.al.c;
					td_geo_altitude.count_selected = data.al.s;				
	
					$(td_geo_altitude.div_id).jstree({
                		        	"html_data":{"data": data.al.v},
						"search" : {"case_insensitive":true},//, "show_only_matches":true},
                		        	"plugins" : [ "html_data", "checkbox", "themes", "search"]
                	    		});
        			}

				reset_search_option(td_time_year);
				if (data.yeh.c > -1){
					td_time_year.count          = data.yeh.c;
					td_time_year.count_selected = data.yeh.s;

					$(td_time_year.div_id).jstree({
                		        	"html_data":{"data": data.yeh.v},
						"search" : {"case_insensitive":true},//, "show_only_matches":true},
                		        	"plugins" : [ "html_data", "checkbox", "themes", "search"]
                	    		});
				}
	
				reset_search_option(td_time_season);
				if (data.seh.c > -1){					
					td_time_season.count          = data.seh.c;
					td_time_season.count_selected = data.seh.s;

					$(td_time_season.div_id).jstree({
                		        	"html_data":{"data": data.seh.v},
						"search" : {"case_insensitive":true},//, "show_only_matches":true},
                		        	"plugins" : [ "html_data", "checkbox", "themes", "search"]
                	    		});
				}

				clearRadMap();
				if (data.rs.length > 0) selected_radius.value = data.rs;
				restoreRadMap();

				if (load_level < 1){
	                		td_agridea_feeds.loading         = false;
					td_classified_feeds1.loading     = false;
					td_classified_feeds2.loading     = false;
					td_unclassified_feeds.loading    = false;
				}
				if (load_level < 2){
					td_nutrients_options.loading     = false;
					td_der_nutrients_options.loading = false;
				}
				td_geo_canton.loading            = false;
				td_geo_altitude.loading          = false;
				td_time_year.loading             = false;
				td_time_season.loading           = false;

				if (td_nutrients_options.count_selected + td_der_nutrients_options.count_selected == 0){
					$("#open_time_options").removeClass().addClass("disabled_search_item");
					$("#open_geo_options").removeClass().addClass("disabled_search_item");
					$("#open_bio_options").removeClass().addClass("disabled_search_item");
					$("#open_tech_options").removeClass().addClass("disabled_search_item");
				}else {
					$("#open_time_options").removeClass().addClass("search_item");
					$("#open_geo_options").removeClass().addClass("search_item");
					$("#open_bio_options").removeClass().addClass("search_item");
					$("#open_tech_options").removeClass().addClass("search_item");
				}

				// activating visualisation on the map
				glob_show_flags      = data.flag;
				glob_show_density    = data.dens;
				glob_show_regression = data.regr;
				glob_regr_nutrient   = data.rnut;
				glob_charts_na       = data.charts_na;				
				glob_charts_nb       = data.charts_nb;
				glob_charts_nc       = data.charts_nc;
				glob_stats_sel       = data.stats_sel;

				restoreMapVisualisationOptions();
				restoreChartsVisualisationOptions();

                		updateLabels();
			}
		}
	}else {
		if (load_level < 1){
			td_agridea_feeds.loading         = false;
			td_classified_feeds1.loading     = false;
			td_classified_feeds2.loading     = false;
			td_unclassified_feeds.loading    = false;
		}
		if (load_level < 2){
			td_nutrients_options.loading     = false;
			td_der_nutrients_options.loading = false;
		}
		td_geo_canton.loading            = false;
		td_geo_altitude.loading          = false;
		td_time_year.loading             = false;
		td_time_season.loading           = false;
		updateLabels();
	}
}

function load_sd_search_options(query_id){
	sd_feeds_options1.loading    = true;
	sd_feeds_options2.loading    = true;
	sd_nutrients_options.loading = true;
	updateLabels();	

	var httpObject = createHttpObject("db_scripts/get_sd_search_options.php", query_id);
	if (httpObject != null){
		httpObject.onreadystatechange = function(){
          	  	if (httpObject.readyState == 4){
				var data = eval(httpObject.responseText);

				sd_feeds_options1.count = data.f.c;
				sd_feeds_options1.count_selected = data.f.s;
				$(sd_feeds_options1.div_id).jstree({
              		        	"html_data":{"data": data.f.v1},
					"search" : {"case_insensitive":true},//, "show_only_matches":true},
					"plugins" : [ "html_data", "checkbox", "themes", "search"]
               	    		});

				$(sd_feeds_options2.div_id).jstree({
              		        	"html_data":{"data": data.f.v2},
					"search" : {"case_insensitive":true},//, "show_only_matches":true},
               		        	"plugins" : [ "html_data", "checkbox", "themes", "search"]
               	    		});

				sd_nutrients_options.count          = data.n.c;
				sd_nutrients_options.count_selected = data.n.s;
				$(sd_nutrients_options.div_id).jstree({
                		        "html_data":{"data": data.n.v},
					"search" : {"case_insensitive":true},
                		        "plugins" : [ "html_data", "checkbox", "themes", "search"]
               	    		});
                
             /*   sd_der_nutrients_options.count          = data.nd.c;
				sd_der_nutrients_options.count_selected = data.nd.s;
				$(sd_der_nutrients_options.div_id).jstree({
      		        		        "html_data":{"data": data.nd.v},
							"search" : {"case_insensitive":true},
        		        		        "plugins" : [ "html_data", "checkbox", "themes", "search"]
        		       	    		});       		*/


                	sd_feeds_options1.loading    = false;
                	sd_feeds_options2.loading    = false;
                    sd_nutrients_options.loading = false;
       //         sd_der_nutrients_options.loading = false;

				if (data.fm.length > 0){
					if (data.fm === "true"){
						$("input[name=sd_nutrients_fresh]").filter('[value="true"]').attr('checked', 'checked');
					}else {
						$("input[name=sd_nutrients_fresh]").filter('[value="false"]').attr('checked', 'checked');
					}
				}
				updateLabels();			
			}
		}
	}else {
		sd_feeds_options1.loading    = false;
		sd_feeds_options2.loading    = false;
		sd_nutrients_options.loading = false;
		sd_der_nutrients_options.loading = false;
		updateLabels();
	}
}


// executed when the user changes the data type
function updateDataType(query_id){
	if (!areLoading()){
		// getting the selected data type. Note, that the name of the radio buttons must be 'data_type'
		// and the name of the input form must be 'data_type' as well.
		for (var i = 0; i < document.data_type.data_type.length; i++){
			if (document.data_type.data_type[i].checked == true) selected_data_type = document.data_type.data_type[i].value;
		}

		// getting the selected data stage. Note, that the name of the check box must be 'data_stage'
		// and the name of the input form must be 'data_stage' as well.
		if ($("#switch_to_raw").length>0){
			if (document.data_stage[0].checked == true) selected_data_source = "1";
			else selected_data_source = "2";
		}	
		return true;
	}else {
		for (var i = 0; i < document.data_type.data_type.length; i++){
			if (document.data_type.data_type[i].value == selected_data_type) document.data_type.data_type[i].checked = true;
			else document.data_type.data_type[i].checked = false;
		}

		if ($("#switch_to_raw").length>0){
			if (selected_data_source == "1") document.data_stage[0].checked = true;
			else document.data_stage[0].checked = false;
		}
		return false;
	}
}

// checkes all checkboxes
function checkAll(item_name){
	$(item_name).jstree("check_all");
}

// uncheckes all checkboxes
function unCheckAll(item_name){
	$(item_name).jstree("uncheck_all");
}

// get selected search options
function get_selected_options(search_option){
	search_option.selected       = "";
	search_option.count_selected = 0;

	$(search_option.div_id).find(".jstree-checked").each(function(){ 
		if (!(this.id.length >= 3 && this.id.charAt(0) == '-' && this.id.charAt(1) == 'g' && this.id.charAt(2) == '-')){
			if (search_option.selected.length == 0){
				search_option.selected += this.id;
				search_option.count_selected++;
			}else{
				search_option.selected += "," + this.id;
				search_option.count_selected++;
			}
		}
	});
}

// loads search options after at least one nutrient and at least one feed type is selected or,
// disables detailed search menu
/*function update_detailed_search_options(query_id){
	reset_search_option(td_time_year);
	reset_search_option(td_time_season);
	reset_search_option(td_geo_canton);
	reset_search_option(td_geo_altitude);
	clearRadMap();
	updateLabels();
    
	if (selected_data_type != "t" ||(td_nutrients_options.count_selected + td_der_nutrients_options.count_selected == 0 && query_id < 0)){
		$("#open_time_options").removeClass().addClass("disabled_search_item");
		$("#open_geo_options").removeClass().addClass("disabled_search_item");
		$("#open_bio_options").removeClass().addClass("disabled_search_item");
		$("#open_tech_options").removeClass().addClass("disabled_search_item");
	}else {
		$("#open_time_options").removeClass().addClass("search_item");
		$("#open_geo_options").removeClass().addClass("search_item");
		$("#open_bio_options").removeClass().addClass("search_item");
		$("#open_tech_options").removeClass().addClass("search_item");

		load_td_properties(query_id);        
	}

	updateLabels();
}*/

// returns true is search options are loading
function areLoading(){
	if (areFeedsLoading()) return true;
	if (areNutrientsLoading()) return true;
	if (areTimeLoading()) return true;
	if (areGeoLoading()) return true;
	return false;
}

// returns true if feed search parameters are loading
function areFeedsLoading(){
	if (td_unclassified_feeds.loading) return true;
	if (td_classified_feeds1.loading)  return true;
	if (td_classified_feeds2.loading)  return true;
	if (sd_feeds_options1.loading)     return true;
	if (sd_feeds_options2.loading)     return true;
	if (td_agridea_feeds.loading)      return true;
	return false;
}

// returns true if nutrients search parameters are loading
function areNutrientsLoading(){
	if (td_nutrients_options.loading) return true;
	if (sd_nutrients_options.loading) return true;
        if (td_der_nutrients_options.loading) return true;
	return false;
}

// returns true if time options are loading
function areTimeLoading(){
	if (td_time_year.loading) return true;
	if (td_time_season.loading) return true;
	return false;
}

// returns true if geo options are loading
function areGeoLoading(){
	if (td_geo_canton.loading) return true;
	if (td_geo_altitude.loading) return true;
	return false;
}

// getting search option for feed types for querying temporal data
function getTdFeedOptions(){
	var old_query = getQueryParameters(-1);

	get_selected_options(td_unclassified_feeds);
	get_selected_options(td_agridea_feeds);
	get_selected_options(td_classified_feeds1);
	get_selected_options(td_classified_feeds2);
	updateLabels();   

	if (old_query != getQueryParameters(-1)){
		load_td_search_options(-1, 1);
	}
}

// getting search options for nutrients for querying temporal data
function getTdNutrientsOptions(){
	var old_query = getQueryParameters(-1);

	get_selected_options(td_nutrients_options);
        get_selected_options(td_der_nutrients_options);
	updateLabels(); 

	if (old_query != getQueryParameters(-1)){
		load_td_search_options(-1, 2);
	}
}

// getting time options selected by the user
function getTdTimeOptions(){
	get_selected_options(td_time_year);
    	get_selected_options(td_time_season);
	updateLabels();
}

// getting geo options selected by the user
function getTdGeoOptions(){
	get_selected_options(td_geo_canton);
    	get_selected_options(td_geo_altitude);
	updateLabels();
}

// getting search option for nutrients for querying summary data
function getSdNutrientsOptions(){
	get_selected_options(sd_nutrients_options);
	selected_fresh_matter = $("input[name=sd_nutrients_fresh]:checked").val();
	updateLabels();
}

// getting search option for feed types for querying summary data
function getSdFeedOptions(){
	get_selected_options(sd_feeds_options1);
	get_selected_options(sd_feeds_options2);
	updateLabels();
}

// updates labels for displaying input statistics and puts them in the appropriate places
function updateLabels(){
	var active_feeds_button = "#open_td_feeds_options";
	var active_feeds_label  = "#open_td_feeds_label";
	if ($(active_feeds_button).css("display") === "none"){active_feeds_button = "#open_sd_feeds_options"; active_feeds_label = "#open_sd_feeds_label";}
	if (areFeedsLoading()) setLoadingLabel(active_feeds_label, active_feeds_button);// feed type
	else setStatsLabel(active_feeds_label, active_feeds_button, (td_classified_feeds1.count_selected + td_classified_feeds2.count_selected + td_unclassified_feeds.count_selected + td_agridea_feeds.count_selected + sd_feeds_options1.count_selected + sd_feeds_options2.count_selected) + "/" + (td_classified_feeds1.count + td_unclassified_feeds.count + td_agridea_feeds.count + sd_feeds_options1.count));
	
	var active_nutrients_button = "#open_td_nutrients_options";
	var active_nutrients_label  = "#open_td_nutrients_label";
	if ($(active_nutrients_button).css("display") === "none") {active_nutrients_button = "#open_sd_nutrients_options"; active_nutrients_label = "#open_sd_nutrients_label";}
	if (areNutrientsLoading()) setLoadingLabel(active_nutrients_label, active_nutrients_button);// nutrients
	else setStatsLabel(active_nutrients_label, active_nutrients_button, (td_nutrients_options.count_selected + td_der_nutrients_options.count_selected + sd_nutrients_options.count_selected) + "/" + (td_nutrients_options.count + td_der_nutrients_options.count + sd_nutrients_options.count));

	if (areGeoLoading()&& $("#open_geo_options").attr('class') === "search_item") setLoadingLabel("#open_geo_label", "#open_geo_options");
	else if (selected_data_type == "t"){
		if (selected_radius.value == "")
			setStatsLabel("#open_geo_label", "#open_geo_options", (td_geo_canton.count_selected + td_geo_altitude.count_selected) + "/" + (td_geo_canton.count + td_geo_altitude.count + 1));
		else setStatsLabel("#open_geo_label", "#open_geo_options", (td_geo_canton.count_selected + td_geo_altitude.count_selected + 1) + "/" + (td_geo_canton.count + td_geo_altitude.count + 1));
	}else setStatsLabel("#open_geo_label", "#open_geo_options", "");

	if (areTimeLoading()&& $("#open_time_options").attr('class') === "search_item") setLoadingLabel("#open_time_label", "#open_time_options");
	else if (selected_data_type == "t") setStatsLabel("#open_time_label", "#open_time_options", (td_time_year.count_selected + td_time_season.count_selected) + "/" + (td_time_year.count + td_time_season.count));
	else setStatsLabel("#open_time_label", "#open_time_options", "");

	setSwitchToRawPosition();
}

// sets position of the checkbox that switchs between the raw and clean data
function setSwitchToRawPosition(){
	if ($("#switch_to_raw").length>0) {
		$("#switch_to_raw").css('left', $("#switch_data_type").offset().left + 20);
		$("#switch_to_raw").css('top',  $("#switch_data_type").offset().top + 24);
	}
}

// set the label to show the progress bar
function setLoadingLabel(label_name, button_name){
	$(label_name).css('left', $(button_name).offset().left + 17);
	$(label_name).css('top',  $(button_name).offset().top + 28);
	$(label_name).html("");
	$(label_name).css('background-image', "url(\'layout_resources/images/bar.gif\')");
	$(label_name).css('background-repeat', 'no-repeat');
	$(label_name).css('width', $(button_name).width());
	$(label_name).css('height', '7px');
}

// set the label to show the text
function setStatsLabel(label_name, button_name, text){
	$(label_name).css('left', $(button_name).offset().left + 25);
	$(label_name).css('top',  $(button_name).offset().top + 24);
	$(label_name).html(text);
	$(label_name).css('background-image', '');
	$(label_name).css('background-repeat', '');
	$(label_name).css('width', '');
	$(label_name).css('height', '');
}
